# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['UpdateApiAppKeyArgs', 'UpdateApiAppKey']

@pulumi.input_type
class UpdateApiAppKeyArgs:
    def __init__(__self__, *,
                 api_app_id: pulumi.Input[str],
                 api_app_key: pulumi.Input[str]):
        """
        The set of arguments for constructing a UpdateApiAppKey resource.
        :param pulumi.Input[str] api_app_id: Application unique ID.
        :param pulumi.Input[str] api_app_key: Key of the application.
        """
        pulumi.set(__self__, "api_app_id", api_app_id)
        pulumi.set(__self__, "api_app_key", api_app_key)

    @property
    @pulumi.getter(name="apiAppId")
    def api_app_id(self) -> pulumi.Input[str]:
        """
        Application unique ID.
        """
        return pulumi.get(self, "api_app_id")

    @api_app_id.setter
    def api_app_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "api_app_id", value)

    @property
    @pulumi.getter(name="apiAppKey")
    def api_app_key(self) -> pulumi.Input[str]:
        """
        Key of the application.
        """
        return pulumi.get(self, "api_app_key")

    @api_app_key.setter
    def api_app_key(self, value: pulumi.Input[str]):
        pulumi.set(self, "api_app_key", value)


@pulumi.input_type
class _UpdateApiAppKeyState:
    def __init__(__self__, *,
                 api_app_id: Optional[pulumi.Input[str]] = None,
                 api_app_key: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering UpdateApiAppKey resources.
        :param pulumi.Input[str] api_app_id: Application unique ID.
        :param pulumi.Input[str] api_app_key: Key of the application.
        """
        if api_app_id is not None:
            pulumi.set(__self__, "api_app_id", api_app_id)
        if api_app_key is not None:
            pulumi.set(__self__, "api_app_key", api_app_key)

    @property
    @pulumi.getter(name="apiAppId")
    def api_app_id(self) -> Optional[pulumi.Input[str]]:
        """
        Application unique ID.
        """
        return pulumi.get(self, "api_app_id")

    @api_app_id.setter
    def api_app_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_app_id", value)

    @property
    @pulumi.getter(name="apiAppKey")
    def api_app_key(self) -> Optional[pulumi.Input[str]]:
        """
        Key of the application.
        """
        return pulumi.get(self, "api_app_key")

    @api_app_key.setter
    def api_app_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "api_app_key", value)


class UpdateApiAppKey(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_app_id: Optional[pulumi.Input[str]] = None,
                 api_app_key: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a apiGateway update_api_app_key

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.api_gateway.UpdateApiAppKey("example",
            api_app_id="app-krljp4wn",
            api_app_key="APID6JmG21yRCc03h4z16hlsTqj1wpO3dB3ZQcUP")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] api_app_id: Application unique ID.
        :param pulumi.Input[str] api_app_key: Key of the application.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UpdateApiAppKeyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a apiGateway update_api_app_key

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.api_gateway.UpdateApiAppKey("example",
            api_app_id="app-krljp4wn",
            api_app_key="APID6JmG21yRCc03h4z16hlsTqj1wpO3dB3ZQcUP")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param UpdateApiAppKeyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UpdateApiAppKeyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 api_app_id: Optional[pulumi.Input[str]] = None,
                 api_app_key: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UpdateApiAppKeyArgs.__new__(UpdateApiAppKeyArgs)

            if api_app_id is None and not opts.urn:
                raise TypeError("Missing required property 'api_app_id'")
            __props__.__dict__["api_app_id"] = api_app_id
            if api_app_key is None and not opts.urn:
                raise TypeError("Missing required property 'api_app_key'")
            __props__.__dict__["api_app_key"] = api_app_key
        super(UpdateApiAppKey, __self__).__init__(
            'tencentcloud:ApiGateway/updateApiAppKey:UpdateApiAppKey',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            api_app_id: Optional[pulumi.Input[str]] = None,
            api_app_key: Optional[pulumi.Input[str]] = None) -> 'UpdateApiAppKey':
        """
        Get an existing UpdateApiAppKey resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] api_app_id: Application unique ID.
        :param pulumi.Input[str] api_app_key: Key of the application.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UpdateApiAppKeyState.__new__(_UpdateApiAppKeyState)

        __props__.__dict__["api_app_id"] = api_app_id
        __props__.__dict__["api_app_key"] = api_app_key
        return UpdateApiAppKey(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="apiAppId")
    def api_app_id(self) -> pulumi.Output[str]:
        """
        Application unique ID.
        """
        return pulumi.get(self, "api_app_id")

    @property
    @pulumi.getter(name="apiAppKey")
    def api_app_key(self) -> pulumi.Output[str]:
        """
        Key of the application.
        """
        return pulumi.get(self, "api_app_key")

