# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSnapshotPoliciesResult',
    'AwaitableGetSnapshotPoliciesResult',
    'get_snapshot_policies',
    'get_snapshot_policies_output',
]

@pulumi.output_type
class GetSnapshotPoliciesResult:
    """
    A collection of values returned by getSnapshotPolicies.
    """
    def __init__(__self__, id=None, result_output_file=None, snapshot_policy_id=None, snapshot_policy_lists=None, snapshot_policy_name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if snapshot_policy_id and not isinstance(snapshot_policy_id, str):
            raise TypeError("Expected argument 'snapshot_policy_id' to be a str")
        pulumi.set(__self__, "snapshot_policy_id", snapshot_policy_id)
        if snapshot_policy_lists and not isinstance(snapshot_policy_lists, list):
            raise TypeError("Expected argument 'snapshot_policy_lists' to be a list")
        pulumi.set(__self__, "snapshot_policy_lists", snapshot_policy_lists)
        if snapshot_policy_name and not isinstance(snapshot_policy_name, str):
            raise TypeError("Expected argument 'snapshot_policy_name' to be a str")
        pulumi.set(__self__, "snapshot_policy_name", snapshot_policy_name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="snapshotPolicyId")
    def snapshot_policy_id(self) -> Optional[str]:
        """
        ID of the snapshot policy.
        """
        return pulumi.get(self, "snapshot_policy_id")

    @property
    @pulumi.getter(name="snapshotPolicyLists")
    def snapshot_policy_lists(self) -> Sequence['outputs.GetSnapshotPoliciesSnapshotPolicyListResult']:
        """
        A list of snapshot policy. Each element contains the following attributes:
        """
        return pulumi.get(self, "snapshot_policy_lists")

    @property
    @pulumi.getter(name="snapshotPolicyName")
    def snapshot_policy_name(self) -> Optional[str]:
        """
        Name of the snapshot policy.
        """
        return pulumi.get(self, "snapshot_policy_name")


class AwaitableGetSnapshotPoliciesResult(GetSnapshotPoliciesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSnapshotPoliciesResult(
            id=self.id,
            result_output_file=self.result_output_file,
            snapshot_policy_id=self.snapshot_policy_id,
            snapshot_policy_lists=self.snapshot_policy_lists,
            snapshot_policy_name=self.snapshot_policy_name)


def get_snapshot_policies(result_output_file: Optional[str] = None,
                          snapshot_policy_id: Optional[str] = None,
                          snapshot_policy_name: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSnapshotPoliciesResult:
    """
    Use this data source to query detailed information of CBS snapshot policies.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    policies = tencentcloud.Cbs.get_snapshot_policies(snapshot_policy_id="snap-f3io7adt",
        snapshot_policy_name="test")
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str snapshot_policy_id: ID of the snapshot policy to be queried.
    :param str snapshot_policy_name: Name of the snapshot policy to be queried.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    __args__['snapshotPolicyId'] = snapshot_policy_id
    __args__['snapshotPolicyName'] = snapshot_policy_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cbs/getSnapshotPolicies:getSnapshotPolicies', __args__, opts=opts, typ=GetSnapshotPoliciesResult).value

    return AwaitableGetSnapshotPoliciesResult(
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        snapshot_policy_id=pulumi.get(__ret__, 'snapshot_policy_id'),
        snapshot_policy_lists=pulumi.get(__ret__, 'snapshot_policy_lists'),
        snapshot_policy_name=pulumi.get(__ret__, 'snapshot_policy_name'))


@_utilities.lift_output_func(get_snapshot_policies)
def get_snapshot_policies_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                 snapshot_policy_id: Optional[pulumi.Input[Optional[str]]] = None,
                                 snapshot_policy_name: Optional[pulumi.Input[Optional[str]]] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSnapshotPoliciesResult]:
    """
    Use this data source to query detailed information of CBS snapshot policies.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    policies = tencentcloud.Cbs.get_snapshot_policies(snapshot_policy_id="snap-f3io7adt",
        snapshot_policy_name="test")
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str snapshot_policy_id: ID of the snapshot policy to be queried.
    :param str snapshot_policy_name: Name of the snapshot policy to be queried.
    """
    ...
