# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RouteTableSelectionPoliciesArgs', 'RouteTableSelectionPolicies']

@pulumi.input_type
class RouteTableSelectionPoliciesArgs:
    def __init__(__self__, *,
                 ccn_id: pulumi.Input[str],
                 selection_policies: pulumi.Input[Sequence[pulumi.Input['RouteTableSelectionPoliciesSelectionPolicyArgs']]]):
        """
        The set of arguments for constructing a RouteTableSelectionPolicies resource.
        :param pulumi.Input[str] ccn_id: CCN Instance ID.
        :param pulumi.Input[Sequence[pulumi.Input['RouteTableSelectionPoliciesSelectionPolicyArgs']]] selection_policies: Select strategy information set.
        """
        pulumi.set(__self__, "ccn_id", ccn_id)
        pulumi.set(__self__, "selection_policies", selection_policies)

    @property
    @pulumi.getter(name="ccnId")
    def ccn_id(self) -> pulumi.Input[str]:
        """
        CCN Instance ID.
        """
        return pulumi.get(self, "ccn_id")

    @ccn_id.setter
    def ccn_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "ccn_id", value)

    @property
    @pulumi.getter(name="selectionPolicies")
    def selection_policies(self) -> pulumi.Input[Sequence[pulumi.Input['RouteTableSelectionPoliciesSelectionPolicyArgs']]]:
        """
        Select strategy information set.
        """
        return pulumi.get(self, "selection_policies")

    @selection_policies.setter
    def selection_policies(self, value: pulumi.Input[Sequence[pulumi.Input['RouteTableSelectionPoliciesSelectionPolicyArgs']]]):
        pulumi.set(self, "selection_policies", value)


@pulumi.input_type
class _RouteTableSelectionPoliciesState:
    def __init__(__self__, *,
                 ccn_id: Optional[pulumi.Input[str]] = None,
                 selection_policies: Optional[pulumi.Input[Sequence[pulumi.Input['RouteTableSelectionPoliciesSelectionPolicyArgs']]]] = None):
        """
        Input properties used for looking up and filtering RouteTableSelectionPolicies resources.
        :param pulumi.Input[str] ccn_id: CCN Instance ID.
        :param pulumi.Input[Sequence[pulumi.Input['RouteTableSelectionPoliciesSelectionPolicyArgs']]] selection_policies: Select strategy information set.
        """
        if ccn_id is not None:
            pulumi.set(__self__, "ccn_id", ccn_id)
        if selection_policies is not None:
            pulumi.set(__self__, "selection_policies", selection_policies)

    @property
    @pulumi.getter(name="ccnId")
    def ccn_id(self) -> Optional[pulumi.Input[str]]:
        """
        CCN Instance ID.
        """
        return pulumi.get(self, "ccn_id")

    @ccn_id.setter
    def ccn_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ccn_id", value)

    @property
    @pulumi.getter(name="selectionPolicies")
    def selection_policies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['RouteTableSelectionPoliciesSelectionPolicyArgs']]]]:
        """
        Select strategy information set.
        """
        return pulumi.get(self, "selection_policies")

    @selection_policies.setter
    def selection_policies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['RouteTableSelectionPoliciesSelectionPolicyArgs']]]]):
        pulumi.set(self, "selection_policies", value)


class RouteTableSelectionPolicies(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ccn_id: Optional[pulumi.Input[str]] = None,
                 selection_policies: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RouteTableSelectionPoliciesSelectionPolicyArgs']]]]] = None,
                 __props__=None):
        """
        Provides a resource to create a CCN Route table selection policies.

        > **NOTE:** Use this resource to manage all selection policies under the routing table of CCN instances.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        config = pulumi.Config()
        region = config.get("region")
        if region is None:
            region = "ap-guangzhou"
        availability_zone = config.get("availabilityZone")
        if availability_zone is None:
            availability_zone = "ap-guangzhou-4"
        # create vpc
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="172.16.0.0/16")
        # create subnet
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=availability_zone,
            vpc_id=vpc.id,
            cidr_block="172.16.0.0/24",
            is_multicast=False)
        # create ccn
        example_instance = tencentcloud.ccn.Instance("exampleInstance",
            description="desc.",
            qos="AG",
            charge_type="PREPAID",
            bandwidth_limit_type="INTER_REGION_LIMIT",
            tags={
                "createBy": "terraform",
            })
        # create ccn route table
        example_route_table = tencentcloud.ccn.RouteTable("exampleRouteTable",
            ccn_id=example_instance.id,
            description="desc.")
        # attachment instance
        attachment = tencentcloud.ccn.Attachment("attachment",
            ccn_id=example_instance.id,
            instance_id=vpc.id,
            instance_type="VPC",
            instance_region=region,
            route_table_id=example_route_table.id)
        # create route table selection policy
        example_route_table_selection_policies = tencentcloud.ccn.RouteTableSelectionPolicies("exampleRouteTableSelectionPolicies",
            ccn_id=example_instance.id,
            selection_policies=[tencentcloud.ccn.RouteTableSelectionPoliciesSelectionPolicyArgs(
                instance_type="VPC",
                instance_id=vpc.id,
                source_cidr_block="192.168.100.0/24",
                route_table_id=example_route_table.id,
                description="desc.",
            )])
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Ccn instance can be imported, e.g.

        ```sh
        $ pulumi import tencentcloud:Ccn/routeTableSelectionPolicies:RouteTableSelectionPolicies example ccn-gr7nynbd
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ccn_id: CCN Instance ID.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RouteTableSelectionPoliciesSelectionPolicyArgs']]]] selection_policies: Select strategy information set.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RouteTableSelectionPoliciesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a CCN Route table selection policies.

        > **NOTE:** Use this resource to manage all selection policies under the routing table of CCN instances.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        config = pulumi.Config()
        region = config.get("region")
        if region is None:
            region = "ap-guangzhou"
        availability_zone = config.get("availabilityZone")
        if availability_zone is None:
            availability_zone = "ap-guangzhou-4"
        # create vpc
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="172.16.0.0/16")
        # create subnet
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=availability_zone,
            vpc_id=vpc.id,
            cidr_block="172.16.0.0/24",
            is_multicast=False)
        # create ccn
        example_instance = tencentcloud.ccn.Instance("exampleInstance",
            description="desc.",
            qos="AG",
            charge_type="PREPAID",
            bandwidth_limit_type="INTER_REGION_LIMIT",
            tags={
                "createBy": "terraform",
            })
        # create ccn route table
        example_route_table = tencentcloud.ccn.RouteTable("exampleRouteTable",
            ccn_id=example_instance.id,
            description="desc.")
        # attachment instance
        attachment = tencentcloud.ccn.Attachment("attachment",
            ccn_id=example_instance.id,
            instance_id=vpc.id,
            instance_type="VPC",
            instance_region=region,
            route_table_id=example_route_table.id)
        # create route table selection policy
        example_route_table_selection_policies = tencentcloud.ccn.RouteTableSelectionPolicies("exampleRouteTableSelectionPolicies",
            ccn_id=example_instance.id,
            selection_policies=[tencentcloud.ccn.RouteTableSelectionPoliciesSelectionPolicyArgs(
                instance_type="VPC",
                instance_id=vpc.id,
                source_cidr_block="192.168.100.0/24",
                route_table_id=example_route_table.id,
                description="desc.",
            )])
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Ccn instance can be imported, e.g.

        ```sh
        $ pulumi import tencentcloud:Ccn/routeTableSelectionPolicies:RouteTableSelectionPolicies example ccn-gr7nynbd
        ```

        :param str resource_name: The name of the resource.
        :param RouteTableSelectionPoliciesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RouteTableSelectionPoliciesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 ccn_id: Optional[pulumi.Input[str]] = None,
                 selection_policies: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RouteTableSelectionPoliciesSelectionPolicyArgs']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RouteTableSelectionPoliciesArgs.__new__(RouteTableSelectionPoliciesArgs)

            if ccn_id is None and not opts.urn:
                raise TypeError("Missing required property 'ccn_id'")
            __props__.__dict__["ccn_id"] = ccn_id
            if selection_policies is None and not opts.urn:
                raise TypeError("Missing required property 'selection_policies'")
            __props__.__dict__["selection_policies"] = selection_policies
        super(RouteTableSelectionPolicies, __self__).__init__(
            'tencentcloud:Ccn/routeTableSelectionPolicies:RouteTableSelectionPolicies',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            ccn_id: Optional[pulumi.Input[str]] = None,
            selection_policies: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RouteTableSelectionPoliciesSelectionPolicyArgs']]]]] = None) -> 'RouteTableSelectionPolicies':
        """
        Get an existing RouteTableSelectionPolicies resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] ccn_id: CCN Instance ID.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['RouteTableSelectionPoliciesSelectionPolicyArgs']]]] selection_policies: Select strategy information set.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RouteTableSelectionPoliciesState.__new__(_RouteTableSelectionPoliciesState)

        __props__.__dict__["ccn_id"] = ccn_id
        __props__.__dict__["selection_policies"] = selection_policies
        return RouteTableSelectionPolicies(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="ccnId")
    def ccn_id(self) -> pulumi.Output[str]:
        """
        CCN Instance ID.
        """
        return pulumi.get(self, "ccn_id")

    @property
    @pulumi.getter(name="selectionPolicies")
    def selection_policies(self) -> pulumi.Output[Sequence['outputs.RouteTableSelectionPoliciesSelectionPolicy']]:
        """
        Select strategy information set.
        """
        return pulumi.get(self, "selection_policies")

