# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDedicatedClusterInstanceTypesResult',
    'AwaitableGetDedicatedClusterInstanceTypesResult',
    'get_dedicated_cluster_instance_types',
    'get_dedicated_cluster_instance_types_output',
]

@pulumi.output_type
class GetDedicatedClusterInstanceTypesResult:
    """
    A collection of values returned by getDedicatedClusterInstanceTypes.
    """
    def __init__(__self__, dedicated_cluster_id=None, dedicated_cluster_instance_type_sets=None, id=None, result_output_file=None):
        if dedicated_cluster_id and not isinstance(dedicated_cluster_id, str):
            raise TypeError("Expected argument 'dedicated_cluster_id' to be a str")
        pulumi.set(__self__, "dedicated_cluster_id", dedicated_cluster_id)
        if dedicated_cluster_instance_type_sets and not isinstance(dedicated_cluster_instance_type_sets, list):
            raise TypeError("Expected argument 'dedicated_cluster_instance_type_sets' to be a list")
        pulumi.set(__self__, "dedicated_cluster_instance_type_sets", dedicated_cluster_instance_type_sets)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="dedicatedClusterId")
    def dedicated_cluster_id(self) -> str:
        return pulumi.get(self, "dedicated_cluster_id")

    @property
    @pulumi.getter(name="dedicatedClusterInstanceTypeSets")
    def dedicated_cluster_instance_type_sets(self) -> Sequence['outputs.GetDedicatedClusterInstanceTypesDedicatedClusterInstanceTypeSetResult']:
        """
        Dedicated Cluster Supported InstanceType.
        """
        return pulumi.get(self, "dedicated_cluster_instance_type_sets")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDedicatedClusterInstanceTypesResult(GetDedicatedClusterInstanceTypesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDedicatedClusterInstanceTypesResult(
            dedicated_cluster_id=self.dedicated_cluster_id,
            dedicated_cluster_instance_type_sets=self.dedicated_cluster_instance_type_sets,
            id=self.id,
            result_output_file=self.result_output_file)


def get_dedicated_cluster_instance_types(dedicated_cluster_id: Optional[str] = None,
                                         result_output_file: Optional[str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDedicatedClusterInstanceTypesResult:
    """
    Use this data source to query detailed information of CDC dedicated cluster instance types

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    types = tencentcloud.Cdc.get_dedicated_cluster_instance_types(dedicated_cluster_id="cluster-262n63e8")
    ```
    <!--End PulumiCodeChooser -->


    :param str dedicated_cluster_id: Dedicated Cluster ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['dedicatedClusterId'] = dedicated_cluster_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cdc/getDedicatedClusterInstanceTypes:getDedicatedClusterInstanceTypes', __args__, opts=opts, typ=GetDedicatedClusterInstanceTypesResult).value

    return AwaitableGetDedicatedClusterInstanceTypesResult(
        dedicated_cluster_id=pulumi.get(__ret__, 'dedicated_cluster_id'),
        dedicated_cluster_instance_type_sets=pulumi.get(__ret__, 'dedicated_cluster_instance_type_sets'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_dedicated_cluster_instance_types)
def get_dedicated_cluster_instance_types_output(dedicated_cluster_id: Optional[pulumi.Input[str]] = None,
                                                result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDedicatedClusterInstanceTypesResult]:
    """
    Use this data source to query detailed information of CDC dedicated cluster instance types

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    types = tencentcloud.Cdc.get_dedicated_cluster_instance_types(dedicated_cluster_id="cluster-262n63e8")
    ```
    <!--End PulumiCodeChooser -->


    :param str dedicated_cluster_id: Dedicated Cluster ID.
    :param str result_output_file: Used to save results.
    """
    ...
