# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetVpcFwSwitchesResult',
    'AwaitableGetVpcFwSwitchesResult',
    'get_vpc_fw_switches',
    'get_vpc_fw_switches_output',
]

@pulumi.output_type
class GetVpcFwSwitchesResult:
    """
    A collection of values returned by getVpcFwSwitches.
    """
    def __init__(__self__, id=None, result_output_file=None, switch_lists=None, vpc_ins_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if switch_lists and not isinstance(switch_lists, list):
            raise TypeError("Expected argument 'switch_lists' to be a list")
        pulumi.set(__self__, "switch_lists", switch_lists)
        if vpc_ins_id and not isinstance(vpc_ins_id, str):
            raise TypeError("Expected argument 'vpc_ins_id' to be a str")
        pulumi.set(__self__, "vpc_ins_id", vpc_ins_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="switchLists")
    def switch_lists(self) -> Sequence['outputs.GetVpcFwSwitchesSwitchListResult']:
        """
        Switch list.
        """
        return pulumi.get(self, "switch_lists")

    @property
    @pulumi.getter(name="vpcInsId")
    def vpc_ins_id(self) -> str:
        return pulumi.get(self, "vpc_ins_id")


class AwaitableGetVpcFwSwitchesResult(GetVpcFwSwitchesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetVpcFwSwitchesResult(
            id=self.id,
            result_output_file=self.result_output_file,
            switch_lists=self.switch_lists,
            vpc_ins_id=self.vpc_ins_id)


def get_vpc_fw_switches(result_output_file: Optional[str] = None,
                        vpc_ins_id: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetVpcFwSwitchesResult:
    """
    Use this data source to query detailed information of cfw vpc_fw_switches

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Cfw.get_vpc_fw_switches(vpc_ins_id="cfwg-c8c2de41")
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str vpc_ins_id: Firewall instance id.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    __args__['vpcInsId'] = vpc_ins_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cfw/getVpcFwSwitches:getVpcFwSwitches', __args__, opts=opts, typ=GetVpcFwSwitchesResult).value

    return AwaitableGetVpcFwSwitchesResult(
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        switch_lists=pulumi.get(__ret__, 'switch_lists'),
        vpc_ins_id=pulumi.get(__ret__, 'vpc_ins_id'))


@_utilities.lift_output_func(get_vpc_fw_switches)
def get_vpc_fw_switches_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                               vpc_ins_id: Optional[pulumi.Input[str]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetVpcFwSwitchesResult]:
    """
    Use this data source to query detailed information of cfw vpc_fw_switches

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Cfw.get_vpc_fw_switches(vpc_ins_id="cfwg-c8c2de41")
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str vpc_ins_id: Firewall instance id.
    """
    ...
