# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['MountPointArgs', 'MountPoint']

@pulumi.input_type
class MountPointArgs:
    def __init__(__self__, *,
                 file_system_id: pulumi.Input[str],
                 mount_point_name: pulumi.Input[str],
                 mount_point_status: pulumi.Input[int]):
        """
        The set of arguments for constructing a MountPoint resource.
        :param pulumi.Input[str] file_system_id: file system id you want to mount.
        :param pulumi.Input[str] mount_point_name: mount point name.
        :param pulumi.Input[int] mount_point_status: mount status 1:open, 2:close.
        """
        pulumi.set(__self__, "file_system_id", file_system_id)
        pulumi.set(__self__, "mount_point_name", mount_point_name)
        pulumi.set(__self__, "mount_point_status", mount_point_status)

    @property
    @pulumi.getter(name="fileSystemId")
    def file_system_id(self) -> pulumi.Input[str]:
        """
        file system id you want to mount.
        """
        return pulumi.get(self, "file_system_id")

    @file_system_id.setter
    def file_system_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "file_system_id", value)

    @property
    @pulumi.getter(name="mountPointName")
    def mount_point_name(self) -> pulumi.Input[str]:
        """
        mount point name.
        """
        return pulumi.get(self, "mount_point_name")

    @mount_point_name.setter
    def mount_point_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "mount_point_name", value)

    @property
    @pulumi.getter(name="mountPointStatus")
    def mount_point_status(self) -> pulumi.Input[int]:
        """
        mount status 1:open, 2:close.
        """
        return pulumi.get(self, "mount_point_status")

    @mount_point_status.setter
    def mount_point_status(self, value: pulumi.Input[int]):
        pulumi.set(self, "mount_point_status", value)


@pulumi.input_type
class _MountPointState:
    def __init__(__self__, *,
                 file_system_id: Optional[pulumi.Input[str]] = None,
                 mount_point_name: Optional[pulumi.Input[str]] = None,
                 mount_point_status: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering MountPoint resources.
        :param pulumi.Input[str] file_system_id: file system id you want to mount.
        :param pulumi.Input[str] mount_point_name: mount point name.
        :param pulumi.Input[int] mount_point_status: mount status 1:open, 2:close.
        """
        if file_system_id is not None:
            pulumi.set(__self__, "file_system_id", file_system_id)
        if mount_point_name is not None:
            pulumi.set(__self__, "mount_point_name", mount_point_name)
        if mount_point_status is not None:
            pulumi.set(__self__, "mount_point_status", mount_point_status)

    @property
    @pulumi.getter(name="fileSystemId")
    def file_system_id(self) -> Optional[pulumi.Input[str]]:
        """
        file system id you want to mount.
        """
        return pulumi.get(self, "file_system_id")

    @file_system_id.setter
    def file_system_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_system_id", value)

    @property
    @pulumi.getter(name="mountPointName")
    def mount_point_name(self) -> Optional[pulumi.Input[str]]:
        """
        mount point name.
        """
        return pulumi.get(self, "mount_point_name")

    @mount_point_name.setter
    def mount_point_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "mount_point_name", value)

    @property
    @pulumi.getter(name="mountPointStatus")
    def mount_point_status(self) -> Optional[pulumi.Input[int]]:
        """
        mount status 1:open, 2:close.
        """
        return pulumi.get(self, "mount_point_status")

    @mount_point_status.setter
    def mount_point_status(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "mount_point_status", value)


class MountPoint(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 file_system_id: Optional[pulumi.Input[str]] = None,
                 mount_point_name: Optional[pulumi.Input[str]] = None,
                 mount_point_status: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a chdfs mount_point

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        mount_point = tencentcloud.chdfs.MountPoint("mountPoint",
            file_system_id="f14mpfy5lh4e",
            mount_point_name="terraform-test",
            mount_point_status=1)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        chdfs mount_point can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Chdfs/mountPoint:MountPoint mount_point mount_point_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] file_system_id: file system id you want to mount.
        :param pulumi.Input[str] mount_point_name: mount point name.
        :param pulumi.Input[int] mount_point_status: mount status 1:open, 2:close.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: MountPointArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a chdfs mount_point

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        mount_point = tencentcloud.chdfs.MountPoint("mountPoint",
            file_system_id="f14mpfy5lh4e",
            mount_point_name="terraform-test",
            mount_point_status=1)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        chdfs mount_point can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Chdfs/mountPoint:MountPoint mount_point mount_point_id
        ```

        :param str resource_name: The name of the resource.
        :param MountPointArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(MountPointArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 file_system_id: Optional[pulumi.Input[str]] = None,
                 mount_point_name: Optional[pulumi.Input[str]] = None,
                 mount_point_status: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = MountPointArgs.__new__(MountPointArgs)

            if file_system_id is None and not opts.urn:
                raise TypeError("Missing required property 'file_system_id'")
            __props__.__dict__["file_system_id"] = file_system_id
            if mount_point_name is None and not opts.urn:
                raise TypeError("Missing required property 'mount_point_name'")
            __props__.__dict__["mount_point_name"] = mount_point_name
            if mount_point_status is None and not opts.urn:
                raise TypeError("Missing required property 'mount_point_status'")
            __props__.__dict__["mount_point_status"] = mount_point_status
        super(MountPoint, __self__).__init__(
            'tencentcloud:Chdfs/mountPoint:MountPoint',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            file_system_id: Optional[pulumi.Input[str]] = None,
            mount_point_name: Optional[pulumi.Input[str]] = None,
            mount_point_status: Optional[pulumi.Input[int]] = None) -> 'MountPoint':
        """
        Get an existing MountPoint resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] file_system_id: file system id you want to mount.
        :param pulumi.Input[str] mount_point_name: mount point name.
        :param pulumi.Input[int] mount_point_status: mount status 1:open, 2:close.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _MountPointState.__new__(_MountPointState)

        __props__.__dict__["file_system_id"] = file_system_id
        __props__.__dict__["mount_point_name"] = mount_point_name
        __props__.__dict__["mount_point_status"] = mount_point_status
        return MountPoint(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="fileSystemId")
    def file_system_id(self) -> pulumi.Output[str]:
        """
        file system id you want to mount.
        """
        return pulumi.get(self, "file_system_id")

    @property
    @pulumi.getter(name="mountPointName")
    def mount_point_name(self) -> pulumi.Output[str]:
        """
        mount point name.
        """
        return pulumi.get(self, "mount_point_name")

    @property
    @pulumi.getter(name="mountPointStatus")
    def mount_point_status(self) -> pulumi.Output[int]:
        """
        mount status 1:open, 2:close.
        """
        return pulumi.get(self, "mount_point_status")

