# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetCrossTargetsResult',
    'AwaitableGetCrossTargetsResult',
    'get_cross_targets',
    'get_cross_targets_output',
]

@pulumi.output_type
class GetCrossTargetsResult:
    """
    A collection of values returned by getCrossTargets.
    """
    def __init__(__self__, cross_target_sets=None, filters=None, id=None, result_output_file=None):
        if cross_target_sets and not isinstance(cross_target_sets, list):
            raise TypeError("Expected argument 'cross_target_sets' to be a list")
        pulumi.set(__self__, "cross_target_sets", cross_target_sets)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="crossTargetSets")
    def cross_target_sets(self) -> Sequence['outputs.GetCrossTargetsCrossTargetSetResult']:
        """
        Cross target set.
        """
        return pulumi.get(self, "cross_target_sets")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetCrossTargetsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetCrossTargetsResult(GetCrossTargetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCrossTargetsResult(
            cross_target_sets=self.cross_target_sets,
            filters=self.filters,
            id=self.id,
            result_output_file=self.result_output_file)


def get_cross_targets(filters: Optional[Sequence[pulumi.InputType['GetCrossTargetsFilterArgs']]] = None,
                      result_output_file: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCrossTargetsResult:
    """
    Use this data source to query detailed information of clb cross_targets

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    cross_targets = tencentcloud.Clb.get_cross_targets(filters=[tencentcloud.clb.GetCrossTargetsFilterArgs(
        name="vpc-id",
        values=["vpc-4owdpnwr"],
    )])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[pulumi.InputType['GetCrossTargetsFilterArgs']] filters: Filter conditions to query CVMs and ENIs: vpc-id - String - Required: No - (Filter condition) Filter by VPC ID, such as vpc-12345678. ip - String - Required: No - (Filter condition) Filter by real server IP, such as 192.168.0.1. listener-id - String - Required: No - (Filter condition) Filter by listener ID, such as lbl-12345678. location-id - String - Required: No - (Filter condition) Filter by forwarding rule ID of the layer-7 listener, such as loc-12345678.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Clb/getCrossTargets:getCrossTargets', __args__, opts=opts, typ=GetCrossTargetsResult).value

    return AwaitableGetCrossTargetsResult(
        cross_target_sets=pulumi.get(__ret__, 'cross_target_sets'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_cross_targets)
def get_cross_targets_output(filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetCrossTargetsFilterArgs']]]]] = None,
                             result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCrossTargetsResult]:
    """
    Use this data source to query detailed information of clb cross_targets

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    cross_targets = tencentcloud.Clb.get_cross_targets(filters=[tencentcloud.clb.GetCrossTargetsFilterArgs(
        name="vpc-id",
        values=["vpc-4owdpnwr"],
    )])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[pulumi.InputType['GetCrossTargetsFilterArgs']] filters: Filter conditions to query CVMs and ENIs: vpc-id - String - Required: No - (Filter condition) Filter by VPC ID, such as vpc-12345678. ip - String - Required: No - (Filter condition) Filter by real server IP, such as 192.168.0.1. listener-id - String - Required: No - (Filter condition) Filter by listener ID, such as lbl-12345678. location-id - String - Required: No - (Filter condition) Filter by forwarding rule ID of the layer-7 listener, such as loc-12345678.
    :param str result_output_file: Used to save results.
    """
    ...
