# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInstanceByCertIdResult',
    'AwaitableGetInstanceByCertIdResult',
    'get_instance_by_cert_id',
    'get_instance_by_cert_id_output',
]

@pulumi.output_type
class GetInstanceByCertIdResult:
    """
    A collection of values returned by getInstanceByCertId.
    """
    def __init__(__self__, cert_ids=None, cert_sets=None, id=None, result_output_file=None):
        if cert_ids and not isinstance(cert_ids, list):
            raise TypeError("Expected argument 'cert_ids' to be a list")
        pulumi.set(__self__, "cert_ids", cert_ids)
        if cert_sets and not isinstance(cert_sets, list):
            raise TypeError("Expected argument 'cert_sets' to be a list")
        pulumi.set(__self__, "cert_sets", cert_sets)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="certIds")
    def cert_ids(self) -> Sequence[str]:
        return pulumi.get(self, "cert_ids")

    @property
    @pulumi.getter(name="certSets")
    def cert_sets(self) -> Sequence['outputs.GetInstanceByCertIdCertSetResult']:
        """
        Certificate ID and list of CLB instances associated with it.
        """
        return pulumi.get(self, "cert_sets")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetInstanceByCertIdResult(GetInstanceByCertIdResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstanceByCertIdResult(
            cert_ids=self.cert_ids,
            cert_sets=self.cert_sets,
            id=self.id,
            result_output_file=self.result_output_file)


def get_instance_by_cert_id(cert_ids: Optional[Sequence[str]] = None,
                            result_output_file: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstanceByCertIdResult:
    """
    Use this data source to query detailed information of clb instance_by_cert_id

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    instance_by_cert_id = tencentcloud.Clb.get_instance_by_cert_id(cert_ids=["3a6B5y8v"])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[str] cert_ids: Server or client certificate ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['certIds'] = cert_ids
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Clb/getInstanceByCertId:getInstanceByCertId', __args__, opts=opts, typ=GetInstanceByCertIdResult).value

    return AwaitableGetInstanceByCertIdResult(
        cert_ids=pulumi.get(__ret__, 'cert_ids'),
        cert_sets=pulumi.get(__ret__, 'cert_sets'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_instance_by_cert_id)
def get_instance_by_cert_id_output(cert_ids: Optional[pulumi.Input[Sequence[str]]] = None,
                                   result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInstanceByCertIdResult]:
    """
    Use this data source to query detailed information of clb instance_by_cert_id

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    instance_by_cert_id = tencentcloud.Clb.get_instance_by_cert_id(cert_ids=["3a6B5y8v"])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[str] cert_ids: Server or client certificate ID.
    :param str result_output_file: Used to save results.
    """
    ...
