# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ObjectRestoreOperationArgs', 'ObjectRestoreOperation']

@pulumi.input_type
class ObjectRestoreOperationArgs:
    def __init__(__self__, *,
                 bucket: pulumi.Input[str],
                 days: pulumi.Input[int],
                 key: pulumi.Input[str],
                 tier: pulumi.Input[str]):
        """
        The set of arguments for constructing a ObjectRestoreOperation resource.
        :param pulumi.Input[str] bucket: Bucket.
        :param pulumi.Input[int] days: Specifies the valid duration of the restored temporary copy in days.
        :param pulumi.Input[str] key: Object key.
        :param pulumi.Input[str] tier: when restoring, Tier can be specified as the supported recovery model.
               There are three recovery models for recovering archived storage type data, which are:
               - Expedited: quick retrieval mode, and the recovery task can be completed in 1-5 minutes.
               - Standard: standard retrieval mode. Recovery task is completed within 3-5 hours.
               - Bulk: batch retrieval mode, and the recovery task is completed within 5-12 hours.
               For deep recovery archive storage type data, there are two recovery models, which are:
               - Standard: standard retrieval mode, recovery time is 12-24 hours.
               - Bulk: batch retrieval mode, recovery time is 24-48 hours.
        """
        pulumi.set(__self__, "bucket", bucket)
        pulumi.set(__self__, "days", days)
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "tier", tier)

    @property
    @pulumi.getter
    def bucket(self) -> pulumi.Input[str]:
        """
        Bucket.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: pulumi.Input[str]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter
    def days(self) -> pulumi.Input[int]:
        """
        Specifies the valid duration of the restored temporary copy in days.
        """
        return pulumi.get(self, "days")

    @days.setter
    def days(self, value: pulumi.Input[int]):
        pulumi.set(self, "days", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        Object key.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def tier(self) -> pulumi.Input[str]:
        """
        when restoring, Tier can be specified as the supported recovery model.
        There are three recovery models for recovering archived storage type data, which are:
        - Expedited: quick retrieval mode, and the recovery task can be completed in 1-5 minutes.
        - Standard: standard retrieval mode. Recovery task is completed within 3-5 hours.
        - Bulk: batch retrieval mode, and the recovery task is completed within 5-12 hours.
        For deep recovery archive storage type data, there are two recovery models, which are:
        - Standard: standard retrieval mode, recovery time is 12-24 hours.
        - Bulk: batch retrieval mode, recovery time is 24-48 hours.
        """
        return pulumi.get(self, "tier")

    @tier.setter
    def tier(self, value: pulumi.Input[str]):
        pulumi.set(self, "tier", value)


@pulumi.input_type
class _ObjectRestoreOperationState:
    def __init__(__self__, *,
                 bucket: Optional[pulumi.Input[str]] = None,
                 days: Optional[pulumi.Input[int]] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 tier: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ObjectRestoreOperation resources.
        :param pulumi.Input[str] bucket: Bucket.
        :param pulumi.Input[int] days: Specifies the valid duration of the restored temporary copy in days.
        :param pulumi.Input[str] key: Object key.
        :param pulumi.Input[str] tier: when restoring, Tier can be specified as the supported recovery model.
               There are three recovery models for recovering archived storage type data, which are:
               - Expedited: quick retrieval mode, and the recovery task can be completed in 1-5 minutes.
               - Standard: standard retrieval mode. Recovery task is completed within 3-5 hours.
               - Bulk: batch retrieval mode, and the recovery task is completed within 5-12 hours.
               For deep recovery archive storage type data, there are two recovery models, which are:
               - Standard: standard retrieval mode, recovery time is 12-24 hours.
               - Bulk: batch retrieval mode, recovery time is 24-48 hours.
        """
        if bucket is not None:
            pulumi.set(__self__, "bucket", bucket)
        if days is not None:
            pulumi.set(__self__, "days", days)
        if key is not None:
            pulumi.set(__self__, "key", key)
        if tier is not None:
            pulumi.set(__self__, "tier", tier)

    @property
    @pulumi.getter
    def bucket(self) -> Optional[pulumi.Input[str]]:
        """
        Bucket.
        """
        return pulumi.get(self, "bucket")

    @bucket.setter
    def bucket(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bucket", value)

    @property
    @pulumi.getter
    def days(self) -> Optional[pulumi.Input[int]]:
        """
        Specifies the valid duration of the restored temporary copy in days.
        """
        return pulumi.get(self, "days")

    @days.setter
    def days(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "days", value)

    @property
    @pulumi.getter
    def key(self) -> Optional[pulumi.Input[str]]:
        """
        Object key.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def tier(self) -> Optional[pulumi.Input[str]]:
        """
        when restoring, Tier can be specified as the supported recovery model.
        There are three recovery models for recovering archived storage type data, which are:
        - Expedited: quick retrieval mode, and the recovery task can be completed in 1-5 minutes.
        - Standard: standard retrieval mode. Recovery task is completed within 3-5 hours.
        - Bulk: batch retrieval mode, and the recovery task is completed within 5-12 hours.
        For deep recovery archive storage type data, there are two recovery models, which are:
        - Standard: standard retrieval mode, recovery time is 12-24 hours.
        - Bulk: batch retrieval mode, recovery time is 24-48 hours.
        """
        return pulumi.get(self, "tier")

    @tier.setter
    def tier(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tier", value)


class ObjectRestoreOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket: Optional[pulumi.Input[str]] = None,
                 days: Optional[pulumi.Input[int]] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 tier: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to restore object

        > **NOTE:** The current resource does not support cdc.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        object_restore = tencentcloud.cos.ObjectRestoreOperation("objectRestore",
            bucket="keep-test-1308919341",
            days=2,
            key="test-restore.txt",
            tier="Expedited")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] bucket: Bucket.
        :param pulumi.Input[int] days: Specifies the valid duration of the restored temporary copy in days.
        :param pulumi.Input[str] key: Object key.
        :param pulumi.Input[str] tier: when restoring, Tier can be specified as the supported recovery model.
               There are three recovery models for recovering archived storage type data, which are:
               - Expedited: quick retrieval mode, and the recovery task can be completed in 1-5 minutes.
               - Standard: standard retrieval mode. Recovery task is completed within 3-5 hours.
               - Bulk: batch retrieval mode, and the recovery task is completed within 5-12 hours.
               For deep recovery archive storage type data, there are two recovery models, which are:
               - Standard: standard retrieval mode, recovery time is 12-24 hours.
               - Bulk: batch retrieval mode, recovery time is 24-48 hours.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ObjectRestoreOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to restore object

        > **NOTE:** The current resource does not support cdc.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        object_restore = tencentcloud.cos.ObjectRestoreOperation("objectRestore",
            bucket="keep-test-1308919341",
            days=2,
            key="test-restore.txt",
            tier="Expedited")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param ObjectRestoreOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ObjectRestoreOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 bucket: Optional[pulumi.Input[str]] = None,
                 days: Optional[pulumi.Input[int]] = None,
                 key: Optional[pulumi.Input[str]] = None,
                 tier: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ObjectRestoreOperationArgs.__new__(ObjectRestoreOperationArgs)

            if bucket is None and not opts.urn:
                raise TypeError("Missing required property 'bucket'")
            __props__.__dict__["bucket"] = bucket
            if days is None and not opts.urn:
                raise TypeError("Missing required property 'days'")
            __props__.__dict__["days"] = days
            if key is None and not opts.urn:
                raise TypeError("Missing required property 'key'")
            __props__.__dict__["key"] = key
            if tier is None and not opts.urn:
                raise TypeError("Missing required property 'tier'")
            __props__.__dict__["tier"] = tier
        super(ObjectRestoreOperation, __self__).__init__(
            'tencentcloud:Cos/objectRestoreOperation:ObjectRestoreOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            bucket: Optional[pulumi.Input[str]] = None,
            days: Optional[pulumi.Input[int]] = None,
            key: Optional[pulumi.Input[str]] = None,
            tier: Optional[pulumi.Input[str]] = None) -> 'ObjectRestoreOperation':
        """
        Get an existing ObjectRestoreOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] bucket: Bucket.
        :param pulumi.Input[int] days: Specifies the valid duration of the restored temporary copy in days.
        :param pulumi.Input[str] key: Object key.
        :param pulumi.Input[str] tier: when restoring, Tier can be specified as the supported recovery model.
               There are three recovery models for recovering archived storage type data, which are:
               - Expedited: quick retrieval mode, and the recovery task can be completed in 1-5 minutes.
               - Standard: standard retrieval mode. Recovery task is completed within 3-5 hours.
               - Bulk: batch retrieval mode, and the recovery task is completed within 5-12 hours.
               For deep recovery archive storage type data, there are two recovery models, which are:
               - Standard: standard retrieval mode, recovery time is 12-24 hours.
               - Bulk: batch retrieval mode, recovery time is 24-48 hours.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ObjectRestoreOperationState.__new__(_ObjectRestoreOperationState)

        __props__.__dict__["bucket"] = bucket
        __props__.__dict__["days"] = days
        __props__.__dict__["key"] = key
        __props__.__dict__["tier"] = tier
        return ObjectRestoreOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def bucket(self) -> pulumi.Output[str]:
        """
        Bucket.
        """
        return pulumi.get(self, "bucket")

    @property
    @pulumi.getter
    def days(self) -> pulumi.Output[int]:
        """
        Specifies the valid duration of the restored temporary copy in days.
        """
        return pulumi.get(self, "days")

    @property
    @pulumi.getter
    def key(self) -> pulumi.Output[str]:
        """
        Object key.
        """
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def tier(self) -> pulumi.Output[str]:
        """
        when restoring, Tier can be specified as the supported recovery model.
        There are three recovery models for recovering archived storage type data, which are:
        - Expedited: quick retrieval mode, and the recovery task can be completed in 1-5 minutes.
        - Standard: standard retrieval mode. Recovery task is completed within 3-5 hours.
        - Bulk: batch retrieval mode, and the recovery task is completed within 5-12 hours.
        For deep recovery archive storage type data, there are two recovery models, which are:
        - Standard: standard retrieval mode, recovery time is 12-24 hours.
        - Bulk: batch retrieval mode, recovery time is 24-48 hours.
        """
        return pulumi.get(self, "tier")

