# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['TimeshiftRuleAttachmentArgs', 'TimeshiftRuleAttachment']

@pulumi.input_type
class TimeshiftRuleAttachmentArgs:
    def __init__(__self__, *,
                 app_name: pulumi.Input[str],
                 domain_name: pulumi.Input[str],
                 stream_name: pulumi.Input[str],
                 template_id: pulumi.Input[int]):
        """
        The set of arguments for constructing a TimeshiftRuleAttachment resource.
        :param pulumi.Input[str] app_name: The push path, which should be the same as `AppName` in the push and playback URLs. The default value is `live`.
        :param pulumi.Input[str] domain_name: The push domain.
        :param pulumi.Input[str] stream_name: The stream name.Note: If you pass in a non-empty string, the rule will only be applied to the specified stream.
        :param pulumi.Input[int] template_id: The template ID.
        """
        pulumi.set(__self__, "app_name", app_name)
        pulumi.set(__self__, "domain_name", domain_name)
        pulumi.set(__self__, "stream_name", stream_name)
        pulumi.set(__self__, "template_id", template_id)

    @property
    @pulumi.getter(name="appName")
    def app_name(self) -> pulumi.Input[str]:
        """
        The push path, which should be the same as `AppName` in the push and playback URLs. The default value is `live`.
        """
        return pulumi.get(self, "app_name")

    @app_name.setter
    def app_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "app_name", value)

    @property
    @pulumi.getter(name="domainName")
    def domain_name(self) -> pulumi.Input[str]:
        """
        The push domain.
        """
        return pulumi.get(self, "domain_name")

    @domain_name.setter
    def domain_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "domain_name", value)

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> pulumi.Input[str]:
        """
        The stream name.Note: If you pass in a non-empty string, the rule will only be applied to the specified stream.
        """
        return pulumi.get(self, "stream_name")

    @stream_name.setter
    def stream_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "stream_name", value)

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> pulumi.Input[int]:
        """
        The template ID.
        """
        return pulumi.get(self, "template_id")

    @template_id.setter
    def template_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "template_id", value)


@pulumi.input_type
class _TimeshiftRuleAttachmentState:
    def __init__(__self__, *,
                 app_name: Optional[pulumi.Input[str]] = None,
                 domain_name: Optional[pulumi.Input[str]] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 template_id: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering TimeshiftRuleAttachment resources.
        :param pulumi.Input[str] app_name: The push path, which should be the same as `AppName` in the push and playback URLs. The default value is `live`.
        :param pulumi.Input[str] domain_name: The push domain.
        :param pulumi.Input[str] stream_name: The stream name.Note: If you pass in a non-empty string, the rule will only be applied to the specified stream.
        :param pulumi.Input[int] template_id: The template ID.
        """
        if app_name is not None:
            pulumi.set(__self__, "app_name", app_name)
        if domain_name is not None:
            pulumi.set(__self__, "domain_name", domain_name)
        if stream_name is not None:
            pulumi.set(__self__, "stream_name", stream_name)
        if template_id is not None:
            pulumi.set(__self__, "template_id", template_id)

    @property
    @pulumi.getter(name="appName")
    def app_name(self) -> Optional[pulumi.Input[str]]:
        """
        The push path, which should be the same as `AppName` in the push and playback URLs. The default value is `live`.
        """
        return pulumi.get(self, "app_name")

    @app_name.setter
    def app_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "app_name", value)

    @property
    @pulumi.getter(name="domainName")
    def domain_name(self) -> Optional[pulumi.Input[str]]:
        """
        The push domain.
        """
        return pulumi.get(self, "domain_name")

    @domain_name.setter
    def domain_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "domain_name", value)

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> Optional[pulumi.Input[str]]:
        """
        The stream name.Note: If you pass in a non-empty string, the rule will only be applied to the specified stream.
        """
        return pulumi.get(self, "stream_name")

    @stream_name.setter
    def stream_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stream_name", value)

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> Optional[pulumi.Input[int]]:
        """
        The template ID.
        """
        return pulumi.get(self, "template_id")

    @template_id.setter
    def template_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "template_id", value)


class TimeshiftRuleAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_name: Optional[pulumi.Input[str]] = None,
                 domain_name: Optional[pulumi.Input[str]] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 template_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a css timeshift_rule_attachment

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        timeshift_rule_attachment = tencentcloud.css.TimeshiftRuleAttachment("timeshiftRuleAttachment",
            app_name="qqq",
            domain_name="177154.push.tlivecloud.com",
            stream_name="ppp",
            template_id=252586)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        css timeshift_rule_attachment can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Css/timeshiftRuleAttachment:TimeshiftRuleAttachment timeshift_rule_attachment templateId#domainName
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_name: The push path, which should be the same as `AppName` in the push and playback URLs. The default value is `live`.
        :param pulumi.Input[str] domain_name: The push domain.
        :param pulumi.Input[str] stream_name: The stream name.Note: If you pass in a non-empty string, the rule will only be applied to the specified stream.
        :param pulumi.Input[int] template_id: The template ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TimeshiftRuleAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a css timeshift_rule_attachment

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        timeshift_rule_attachment = tencentcloud.css.TimeshiftRuleAttachment("timeshiftRuleAttachment",
            app_name="qqq",
            domain_name="177154.push.tlivecloud.com",
            stream_name="ppp",
            template_id=252586)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        css timeshift_rule_attachment can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Css/timeshiftRuleAttachment:TimeshiftRuleAttachment timeshift_rule_attachment templateId#domainName
        ```

        :param str resource_name: The name of the resource.
        :param TimeshiftRuleAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TimeshiftRuleAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_name: Optional[pulumi.Input[str]] = None,
                 domain_name: Optional[pulumi.Input[str]] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 template_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TimeshiftRuleAttachmentArgs.__new__(TimeshiftRuleAttachmentArgs)

            if app_name is None and not opts.urn:
                raise TypeError("Missing required property 'app_name'")
            __props__.__dict__["app_name"] = app_name
            if domain_name is None and not opts.urn:
                raise TypeError("Missing required property 'domain_name'")
            __props__.__dict__["domain_name"] = domain_name
            if stream_name is None and not opts.urn:
                raise TypeError("Missing required property 'stream_name'")
            __props__.__dict__["stream_name"] = stream_name
            if template_id is None and not opts.urn:
                raise TypeError("Missing required property 'template_id'")
            __props__.__dict__["template_id"] = template_id
        super(TimeshiftRuleAttachment, __self__).__init__(
            'tencentcloud:Css/timeshiftRuleAttachment:TimeshiftRuleAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            app_name: Optional[pulumi.Input[str]] = None,
            domain_name: Optional[pulumi.Input[str]] = None,
            stream_name: Optional[pulumi.Input[str]] = None,
            template_id: Optional[pulumi.Input[int]] = None) -> 'TimeshiftRuleAttachment':
        """
        Get an existing TimeshiftRuleAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_name: The push path, which should be the same as `AppName` in the push and playback URLs. The default value is `live`.
        :param pulumi.Input[str] domain_name: The push domain.
        :param pulumi.Input[str] stream_name: The stream name.Note: If you pass in a non-empty string, the rule will only be applied to the specified stream.
        :param pulumi.Input[int] template_id: The template ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TimeshiftRuleAttachmentState.__new__(_TimeshiftRuleAttachmentState)

        __props__.__dict__["app_name"] = app_name
        __props__.__dict__["domain_name"] = domain_name
        __props__.__dict__["stream_name"] = stream_name
        __props__.__dict__["template_id"] = template_id
        return TimeshiftRuleAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="appName")
    def app_name(self) -> pulumi.Output[str]:
        """
        The push path, which should be the same as `AppName` in the push and playback URLs. The default value is `live`.
        """
        return pulumi.get(self, "app_name")

    @property
    @pulumi.getter(name="domainName")
    def domain_name(self) -> pulumi.Output[str]:
        """
        The push domain.
        """
        return pulumi.get(self, "domain_name")

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> pulumi.Output[str]:
        """
        The stream name.Note: If you pass in a non-empty string, the rule will only be applied to the specified stream.
        """
        return pulumi.get(self, "stream_name")

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> pulumi.Output[int]:
        """
        The template ID.
        """
        return pulumi.get(self, "template_id")

