# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDescribeInstanceSlowQueriesResult',
    'AwaitableGetDescribeInstanceSlowQueriesResult',
    'get_describe_instance_slow_queries',
    'get_describe_instance_slow_queries_output',
]

@pulumi.output_type
class GetDescribeInstanceSlowQueriesResult:
    """
    A collection of values returned by getDescribeInstanceSlowQueries.
    """
    def __init__(__self__, binlogs=None, cluster_id=None, end_time=None, id=None, result_output_file=None, start_time=None):
        if binlogs and not isinstance(binlogs, list):
            raise TypeError("Expected argument 'binlogs' to be a list")
        pulumi.set(__self__, "binlogs", binlogs)
        if cluster_id and not isinstance(cluster_id, str):
            raise TypeError("Expected argument 'cluster_id' to be a str")
        pulumi.set(__self__, "cluster_id", cluster_id)
        if end_time and not isinstance(end_time, str):
            raise TypeError("Expected argument 'end_time' to be a str")
        pulumi.set(__self__, "end_time", end_time)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if start_time and not isinstance(start_time, str):
            raise TypeError("Expected argument 'start_time' to be a str")
        pulumi.set(__self__, "start_time", start_time)

    @property
    @pulumi.getter
    def binlogs(self) -> Sequence['outputs.GetDescribeInstanceSlowQueriesBinlogResult']:
        """
        Note to the Binlog list: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "binlogs")

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> str:
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="endTime")
    def end_time(self) -> Optional[str]:
        return pulumi.get(self, "end_time")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> Optional[str]:
        """
        Earliest transaction time.
        """
        return pulumi.get(self, "start_time")


class AwaitableGetDescribeInstanceSlowQueriesResult(GetDescribeInstanceSlowQueriesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDescribeInstanceSlowQueriesResult(
            binlogs=self.binlogs,
            cluster_id=self.cluster_id,
            end_time=self.end_time,
            id=self.id,
            result_output_file=self.result_output_file,
            start_time=self.start_time)


def get_describe_instance_slow_queries(cluster_id: Optional[str] = None,
                                       end_time: Optional[str] = None,
                                       result_output_file: Optional[str] = None,
                                       start_time: Optional[str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDescribeInstanceSlowQueriesResult:
    """
    Use this data source to query detailed information of cynosdb describe_instance_slow_queries

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    describe_instance_slow_queries = tencentcloud.Cynosdb.get_describe_instance_slow_queries(cluster_id="cynosdbmysql-bws8h88b",
        end_time="2023-06-19 14:00:00",
        start_time="2023-06-01 12:00:00")
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: Cluster ID.
    :param str end_time: End time.
    :param str result_output_file: Used to save results.
    :param str start_time: start time.
    """
    __args__ = dict()
    __args__['clusterId'] = cluster_id
    __args__['endTime'] = end_time
    __args__['resultOutputFile'] = result_output_file
    __args__['startTime'] = start_time
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cynosdb/getDescribeInstanceSlowQueries:getDescribeInstanceSlowQueries', __args__, opts=opts, typ=GetDescribeInstanceSlowQueriesResult).value

    return AwaitableGetDescribeInstanceSlowQueriesResult(
        binlogs=pulumi.get(__ret__, 'binlogs'),
        cluster_id=pulumi.get(__ret__, 'cluster_id'),
        end_time=pulumi.get(__ret__, 'end_time'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        start_time=pulumi.get(__ret__, 'start_time'))


@_utilities.lift_output_func(get_describe_instance_slow_queries)
def get_describe_instance_slow_queries_output(cluster_id: Optional[pulumi.Input[str]] = None,
                                              end_time: Optional[pulumi.Input[Optional[str]]] = None,
                                              result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                              start_time: Optional[pulumi.Input[Optional[str]]] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDescribeInstanceSlowQueriesResult]:
    """
    Use this data source to query detailed information of cynosdb describe_instance_slow_queries

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    describe_instance_slow_queries = tencentcloud.Cynosdb.get_describe_instance_slow_queries(cluster_id="cynosdbmysql-bws8h88b",
        end_time="2023-06-19 14:00:00",
        start_time="2023-06-01 12:00:00")
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: Cluster ID.
    :param str end_time: End time.
    :param str result_output_file: Used to save results.
    :param str start_time: start time.
    """
    ...
