# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['UpgradeProxyVersionArgs', 'UpgradeProxyVersion']

@pulumi.input_type
class UpgradeProxyVersionArgs:
    def __init__(__self__, *,
                 cluster_id: pulumi.Input[str],
                 dst_proxy_version: pulumi.Input[str]):
        """
        The set of arguments for constructing a UpgradeProxyVersion resource.
        :param pulumi.Input[str] cluster_id: Cluster ID.
        :param pulumi.Input[str] dst_proxy_version: Database Agent Upgrade Version.
        """
        pulumi.set(__self__, "cluster_id", cluster_id)
        pulumi.set(__self__, "dst_proxy_version", dst_proxy_version)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Input[str]:
        """
        Cluster ID.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="dstProxyVersion")
    def dst_proxy_version(self) -> pulumi.Input[str]:
        """
        Database Agent Upgrade Version.
        """
        return pulumi.get(self, "dst_proxy_version")

    @dst_proxy_version.setter
    def dst_proxy_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "dst_proxy_version", value)


@pulumi.input_type
class _UpgradeProxyVersionState:
    def __init__(__self__, *,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 dst_proxy_version: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering UpgradeProxyVersion resources.
        :param pulumi.Input[str] cluster_id: Cluster ID.
        :param pulumi.Input[str] dst_proxy_version: Database Agent Upgrade Version.
        """
        if cluster_id is not None:
            pulumi.set(__self__, "cluster_id", cluster_id)
        if dst_proxy_version is not None:
            pulumi.set(__self__, "dst_proxy_version", dst_proxy_version)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> Optional[pulumi.Input[str]]:
        """
        Cluster ID.
        """
        return pulumi.get(self, "cluster_id")

    @cluster_id.setter
    def cluster_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cluster_id", value)

    @property
    @pulumi.getter(name="dstProxyVersion")
    def dst_proxy_version(self) -> Optional[pulumi.Input[str]]:
        """
        Database Agent Upgrade Version.
        """
        return pulumi.get(self, "dst_proxy_version")

    @dst_proxy_version.setter
    def dst_proxy_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dst_proxy_version", value)


class UpgradeProxyVersion(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 dst_proxy_version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a cynosdb upgrade_proxy_version

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        upgrade_proxy_version = tencentcloud.cynosdb.UpgradeProxyVersion("upgradeProxyVersion",
            cluster_id="cynosdbmysql-bws8h88b",
            dst_proxy_version="1.3.7")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_id: Cluster ID.
        :param pulumi.Input[str] dst_proxy_version: Database Agent Upgrade Version.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UpgradeProxyVersionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a cynosdb upgrade_proxy_version

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        upgrade_proxy_version = tencentcloud.cynosdb.UpgradeProxyVersion("upgradeProxyVersion",
            cluster_id="cynosdbmysql-bws8h88b",
            dst_proxy_version="1.3.7")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param UpgradeProxyVersionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UpgradeProxyVersionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cluster_id: Optional[pulumi.Input[str]] = None,
                 dst_proxy_version: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UpgradeProxyVersionArgs.__new__(UpgradeProxyVersionArgs)

            if cluster_id is None and not opts.urn:
                raise TypeError("Missing required property 'cluster_id'")
            __props__.__dict__["cluster_id"] = cluster_id
            if dst_proxy_version is None and not opts.urn:
                raise TypeError("Missing required property 'dst_proxy_version'")
            __props__.__dict__["dst_proxy_version"] = dst_proxy_version
        super(UpgradeProxyVersion, __self__).__init__(
            'tencentcloud:Cynosdb/upgradeProxyVersion:UpgradeProxyVersion',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cluster_id: Optional[pulumi.Input[str]] = None,
            dst_proxy_version: Optional[pulumi.Input[str]] = None) -> 'UpgradeProxyVersion':
        """
        Get an existing UpgradeProxyVersion resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cluster_id: Cluster ID.
        :param pulumi.Input[str] dst_proxy_version: Database Agent Upgrade Version.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UpgradeProxyVersionState.__new__(_UpgradeProxyVersionState)

        __props__.__dict__["cluster_id"] = cluster_id
        __props__.__dict__["dst_proxy_version"] = dst_proxy_version
        return UpgradeProxyVersion(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> pulumi.Output[str]:
        """
        Cluster ID.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="dstProxyVersion")
    def dst_proxy_version(self) -> pulumi.Output[str]:
        """
        Database Agent Upgrade Version.
        """
        return pulumi.get(self, "dst_proxy_version")

