# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['BindDeviceAccountPasswordArgs', 'BindDeviceAccountPassword']

@pulumi.input_type
class BindDeviceAccountPasswordArgs:
    def __init__(__self__, *,
                 device_account_id: pulumi.Input[int],
                 password: pulumi.Input[str]):
        """
        The set of arguments for constructing a BindDeviceAccountPassword resource.
        :param pulumi.Input[int] device_account_id: Host account ID.
        :param pulumi.Input[str] password: Host account password.
        """
        pulumi.set(__self__, "device_account_id", device_account_id)
        pulumi.set(__self__, "password", password)

    @property
    @pulumi.getter(name="deviceAccountId")
    def device_account_id(self) -> pulumi.Input[int]:
        """
        Host account ID.
        """
        return pulumi.get(self, "device_account_id")

    @device_account_id.setter
    def device_account_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "device_account_id", value)

    @property
    @pulumi.getter
    def password(self) -> pulumi.Input[str]:
        """
        Host account password.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: pulumi.Input[str]):
        pulumi.set(self, "password", value)


@pulumi.input_type
class _BindDeviceAccountPasswordState:
    def __init__(__self__, *,
                 device_account_id: Optional[pulumi.Input[int]] = None,
                 password: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BindDeviceAccountPassword resources.
        :param pulumi.Input[int] device_account_id: Host account ID.
        :param pulumi.Input[str] password: Host account password.
        """
        if device_account_id is not None:
            pulumi.set(__self__, "device_account_id", device_account_id)
        if password is not None:
            pulumi.set(__self__, "password", password)

    @property
    @pulumi.getter(name="deviceAccountId")
    def device_account_id(self) -> Optional[pulumi.Input[int]]:
        """
        Host account ID.
        """
        return pulumi.get(self, "device_account_id")

    @device_account_id.setter
    def device_account_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "device_account_id", value)

    @property
    @pulumi.getter
    def password(self) -> Optional[pulumi.Input[str]]:
        """
        Host account password.
        """
        return pulumi.get(self, "password")

    @password.setter
    def password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "password", value)


class BindDeviceAccountPassword(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device_account_id: Optional[pulumi.Input[int]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a dasb bind_device_account_password

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example_device = tencentcloud.dasb.Device("exampleDevice",
            os_name="Linux",
            ip="192.168.0.1",
            port=80)
        example_device_account = tencentcloud.dasb.DeviceAccount("exampleDeviceAccount",
            device_id=example_device.id,
            account="root")
        example_bind_device_account_password = tencentcloud.dasb.BindDeviceAccountPassword("exampleBindDeviceAccountPassword",
            device_account_id=example_device_account.id,
            password="TerraformPassword")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] device_account_id: Host account ID.
        :param pulumi.Input[str] password: Host account password.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BindDeviceAccountPasswordArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a dasb bind_device_account_password

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example_device = tencentcloud.dasb.Device("exampleDevice",
            os_name="Linux",
            ip="192.168.0.1",
            port=80)
        example_device_account = tencentcloud.dasb.DeviceAccount("exampleDeviceAccount",
            device_id=example_device.id,
            account="root")
        example_bind_device_account_password = tencentcloud.dasb.BindDeviceAccountPassword("exampleBindDeviceAccountPassword",
            device_account_id=example_device_account.id,
            password="TerraformPassword")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param BindDeviceAccountPasswordArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BindDeviceAccountPasswordArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device_account_id: Optional[pulumi.Input[int]] = None,
                 password: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BindDeviceAccountPasswordArgs.__new__(BindDeviceAccountPasswordArgs)

            if device_account_id is None and not opts.urn:
                raise TypeError("Missing required property 'device_account_id'")
            __props__.__dict__["device_account_id"] = device_account_id
            if password is None and not opts.urn:
                raise TypeError("Missing required property 'password'")
            __props__.__dict__["password"] = password
        super(BindDeviceAccountPassword, __self__).__init__(
            'tencentcloud:Dasb/bindDeviceAccountPassword:BindDeviceAccountPassword',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            device_account_id: Optional[pulumi.Input[int]] = None,
            password: Optional[pulumi.Input[str]] = None) -> 'BindDeviceAccountPassword':
        """
        Get an existing BindDeviceAccountPassword resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] device_account_id: Host account ID.
        :param pulumi.Input[str] password: Host account password.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BindDeviceAccountPasswordState.__new__(_BindDeviceAccountPasswordState)

        __props__.__dict__["device_account_id"] = device_account_id
        __props__.__dict__["password"] = password
        return BindDeviceAccountPassword(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="deviceAccountId")
    def device_account_id(self) -> pulumi.Output[int]:
        """
        Host account ID.
        """
        return pulumi.get(self, "device_account_id")

    @property
    @pulumi.getter
    def password(self) -> pulumi.Output[str]:
        """
        Host account password.
        """
        return pulumi.get(self, "password")

