# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetNoPrimaryKeyTablesResult',
    'AwaitableGetNoPrimaryKeyTablesResult',
    'get_no_primary_key_tables',
    'get_no_primary_key_tables_output',
]

@pulumi.output_type
class GetNoPrimaryKeyTablesResult:
    """
    A collection of values returned by getNoPrimaryKeyTables.
    """
    def __init__(__self__, date=None, id=None, instance_id=None, no_primary_key_table_count_diff=None, no_primary_key_tables=None, product=None, result_output_file=None, timestamp=None):
        if date and not isinstance(date, str):
            raise TypeError("Expected argument 'date' to be a str")
        pulumi.set(__self__, "date", date)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if no_primary_key_table_count_diff and not isinstance(no_primary_key_table_count_diff, int):
            raise TypeError("Expected argument 'no_primary_key_table_count_diff' to be a int")
        pulumi.set(__self__, "no_primary_key_table_count_diff", no_primary_key_table_count_diff)
        if no_primary_key_tables and not isinstance(no_primary_key_tables, list):
            raise TypeError("Expected argument 'no_primary_key_tables' to be a list")
        pulumi.set(__self__, "no_primary_key_tables", no_primary_key_tables)
        if product and not isinstance(product, str):
            raise TypeError("Expected argument 'product' to be a str")
        pulumi.set(__self__, "product", product)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if timestamp and not isinstance(timestamp, int):
            raise TypeError("Expected argument 'timestamp' to be a int")
        pulumi.set(__self__, "timestamp", timestamp)

    @property
    @pulumi.getter
    def date(self) -> str:
        return pulumi.get(self, "date")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="noPrimaryKeyTableCountDiff")
    def no_primary_key_table_count_diff(self) -> int:
        """
        The difference with yesterday&amp;#39;s scan of the table without a primary key. A positive number means an increase, a negative number means a decrease, and 0 means no change.
        """
        return pulumi.get(self, "no_primary_key_table_count_diff")

    @property
    @pulumi.getter(name="noPrimaryKeyTables")
    def no_primary_key_tables(self) -> Sequence['outputs.GetNoPrimaryKeyTablesNoPrimaryKeyTableResult']:
        """
        A list of tables without primary keys.
        """
        return pulumi.get(self, "no_primary_key_tables")

    @property
    @pulumi.getter
    def product(self) -> Optional[str]:
        return pulumi.get(self, "product")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def timestamp(self) -> int:
        """
        Collection timestamp (seconds).
        """
        return pulumi.get(self, "timestamp")


class AwaitableGetNoPrimaryKeyTablesResult(GetNoPrimaryKeyTablesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNoPrimaryKeyTablesResult(
            date=self.date,
            id=self.id,
            instance_id=self.instance_id,
            no_primary_key_table_count_diff=self.no_primary_key_table_count_diff,
            no_primary_key_tables=self.no_primary_key_tables,
            product=self.product,
            result_output_file=self.result_output_file,
            timestamp=self.timestamp)


def get_no_primary_key_tables(date: Optional[str] = None,
                              instance_id: Optional[str] = None,
                              product: Optional[str] = None,
                              result_output_file: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNoPrimaryKeyTablesResult:
    """
    Use this data source to query detailed information of dbbrain no_primary_key_tables

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    no_primary_key_tables = tencentcloud.Dbbrain.get_no_primary_key_tables(date="",
        instance_id="",
        product="")
    ```
    <!--End PulumiCodeChooser -->


    :param str date: Query date, such as 2021-05-27, the earliest date is 30 days ago.
    :param str instance_id: instance id.
    :param str product: Service product type, supported values: `mysql` - ApsaraDB for MySQL, the default is `mysql`.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['date'] = date
    __args__['instanceId'] = instance_id
    __args__['product'] = product
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dbbrain/getNoPrimaryKeyTables:getNoPrimaryKeyTables', __args__, opts=opts, typ=GetNoPrimaryKeyTablesResult).value

    return AwaitableGetNoPrimaryKeyTablesResult(
        date=pulumi.get(__ret__, 'date'),
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        no_primary_key_table_count_diff=pulumi.get(__ret__, 'no_primary_key_table_count_diff'),
        no_primary_key_tables=pulumi.get(__ret__, 'no_primary_key_tables'),
        product=pulumi.get(__ret__, 'product'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        timestamp=pulumi.get(__ret__, 'timestamp'))


@_utilities.lift_output_func(get_no_primary_key_tables)
def get_no_primary_key_tables_output(date: Optional[pulumi.Input[str]] = None,
                                     instance_id: Optional[pulumi.Input[str]] = None,
                                     product: Optional[pulumi.Input[Optional[str]]] = None,
                                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetNoPrimaryKeyTablesResult]:
    """
    Use this data source to query detailed information of dbbrain no_primary_key_tables

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    no_primary_key_tables = tencentcloud.Dbbrain.get_no_primary_key_tables(date="",
        instance_id="",
        product="")
    ```
    <!--End PulumiCodeChooser -->


    :param str date: Query date, such as 2021-05-27, the earliest date is 30 days ago.
    :param str instance_id: instance id.
    :param str product: Service product type, supported values: `mysql` - ApsaraDB for MySQL, the default is `mysql`.
    :param str result_output_file: Used to save results.
    """
    ...
