# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetRedisTopKeyPrefixListResult',
    'AwaitableGetRedisTopKeyPrefixListResult',
    'get_redis_top_key_prefix_list',
    'get_redis_top_key_prefix_list_output',
]

@pulumi.output_type
class GetRedisTopKeyPrefixListResult:
    """
    A collection of values returned by getRedisTopKeyPrefixList.
    """
    def __init__(__self__, date=None, id=None, instance_id=None, items=None, product=None, result_output_file=None):
        if date and not isinstance(date, str):
            raise TypeError("Expected argument 'date' to be a str")
        pulumi.set(__self__, "date", date)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if product and not isinstance(product, str):
            raise TypeError("Expected argument 'product' to be a str")
        pulumi.set(__self__, "product", product)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def date(self) -> str:
        return pulumi.get(self, "date")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetRedisTopKeyPrefixListItemResult']:
        """
        list of top key prefixes.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter
    def product(self) -> str:
        return pulumi.get(self, "product")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetRedisTopKeyPrefixListResult(GetRedisTopKeyPrefixListResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRedisTopKeyPrefixListResult(
            date=self.date,
            id=self.id,
            instance_id=self.instance_id,
            items=self.items,
            product=self.product,
            result_output_file=self.result_output_file)


def get_redis_top_key_prefix_list(date: Optional[str] = None,
                                  instance_id: Optional[str] = None,
                                  product: Optional[str] = None,
                                  result_output_file: Optional[str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRedisTopKeyPrefixListResult:
    """
    Use this data source to query detailed information of dbbrain redis_top_key_prefix_list

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    redis_top_key_prefix_list = tencentcloud.Dbbrain.get_redis_top_key_prefix_list(instance_id=local["redis_id"],
        date="%s",
        product="redis")
    ```
    <!--End PulumiCodeChooser -->


    :param str date: Query date, such as 2021-05-27, the earliest date can be the previous 30 days.
    :param str instance_id: instance id.
    :param str product: Service product type, supported values include `redis` - cloud database Redis.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['date'] = date
    __args__['instanceId'] = instance_id
    __args__['product'] = product
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dbbrain/getRedisTopKeyPrefixList:getRedisTopKeyPrefixList', __args__, opts=opts, typ=GetRedisTopKeyPrefixListResult).value

    return AwaitableGetRedisTopKeyPrefixListResult(
        date=pulumi.get(__ret__, 'date'),
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        items=pulumi.get(__ret__, 'items'),
        product=pulumi.get(__ret__, 'product'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_redis_top_key_prefix_list)
def get_redis_top_key_prefix_list_output(date: Optional[pulumi.Input[str]] = None,
                                         instance_id: Optional[pulumi.Input[str]] = None,
                                         product: Optional[pulumi.Input[str]] = None,
                                         result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRedisTopKeyPrefixListResult]:
    """
    Use this data source to query detailed information of dbbrain redis_top_key_prefix_list

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    redis_top_key_prefix_list = tencentcloud.Dbbrain.get_redis_top_key_prefix_list(instance_id=local["redis_id"],
        date="%s",
        product="redis")
    ```
    <!--End PulumiCodeChooser -->


    :param str date: Query date, such as 2021-05-27, the earliest date can be the previous 30 days.
    :param str instance_id: instance id.
    :param str product: Service product type, supported values include `redis` - cloud database Redis.
    :param str result_output_file: Used to save results.
    """
    ...
