# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['AttachWorkGroupPolicyOperationArgs', 'AttachWorkGroupPolicyOperation']

@pulumi.input_type
class AttachWorkGroupPolicyOperationArgs:
    def __init__(__self__, *,
                 work_group_id: pulumi.Input[int],
                 policy_sets: Optional[pulumi.Input[Sequence[pulumi.Input['AttachWorkGroupPolicyOperationPolicySetArgs']]]] = None):
        """
        The set of arguments for constructing a AttachWorkGroupPolicyOperation resource.
        :param pulumi.Input[int] work_group_id: Work group id.
        :param pulumi.Input[Sequence[pulumi.Input['AttachWorkGroupPolicyOperationPolicySetArgs']]] policy_sets: The set of policies to be bound.
        """
        pulumi.set(__self__, "work_group_id", work_group_id)
        if policy_sets is not None:
            pulumi.set(__self__, "policy_sets", policy_sets)

    @property
    @pulumi.getter(name="workGroupId")
    def work_group_id(self) -> pulumi.Input[int]:
        """
        Work group id.
        """
        return pulumi.get(self, "work_group_id")

    @work_group_id.setter
    def work_group_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "work_group_id", value)

    @property
    @pulumi.getter(name="policySets")
    def policy_sets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AttachWorkGroupPolicyOperationPolicySetArgs']]]]:
        """
        The set of policies to be bound.
        """
        return pulumi.get(self, "policy_sets")

    @policy_sets.setter
    def policy_sets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AttachWorkGroupPolicyOperationPolicySetArgs']]]]):
        pulumi.set(self, "policy_sets", value)


@pulumi.input_type
class _AttachWorkGroupPolicyOperationState:
    def __init__(__self__, *,
                 policy_sets: Optional[pulumi.Input[Sequence[pulumi.Input['AttachWorkGroupPolicyOperationPolicySetArgs']]]] = None,
                 work_group_id: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering AttachWorkGroupPolicyOperation resources.
        :param pulumi.Input[Sequence[pulumi.Input['AttachWorkGroupPolicyOperationPolicySetArgs']]] policy_sets: The set of policies to be bound.
        :param pulumi.Input[int] work_group_id: Work group id.
        """
        if policy_sets is not None:
            pulumi.set(__self__, "policy_sets", policy_sets)
        if work_group_id is not None:
            pulumi.set(__self__, "work_group_id", work_group_id)

    @property
    @pulumi.getter(name="policySets")
    def policy_sets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AttachWorkGroupPolicyOperationPolicySetArgs']]]]:
        """
        The set of policies to be bound.
        """
        return pulumi.get(self, "policy_sets")

    @policy_sets.setter
    def policy_sets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AttachWorkGroupPolicyOperationPolicySetArgs']]]]):
        pulumi.set(self, "policy_sets", value)

    @property
    @pulumi.getter(name="workGroupId")
    def work_group_id(self) -> Optional[pulumi.Input[int]]:
        """
        Work group id.
        """
        return pulumi.get(self, "work_group_id")

    @work_group_id.setter
    def work_group_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "work_group_id", value)


class AttachWorkGroupPolicyOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 policy_sets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachWorkGroupPolicyOperationPolicySetArgs']]]]] = None,
                 work_group_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Create a AttachWorkGroupPolicyOperation resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachWorkGroupPolicyOperationPolicySetArgs']]]] policy_sets: The set of policies to be bound.
        :param pulumi.Input[int] work_group_id: Work group id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AttachWorkGroupPolicyOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a AttachWorkGroupPolicyOperation resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param AttachWorkGroupPolicyOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AttachWorkGroupPolicyOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 policy_sets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachWorkGroupPolicyOperationPolicySetArgs']]]]] = None,
                 work_group_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AttachWorkGroupPolicyOperationArgs.__new__(AttachWorkGroupPolicyOperationArgs)

            __props__.__dict__["policy_sets"] = policy_sets
            if work_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'work_group_id'")
            __props__.__dict__["work_group_id"] = work_group_id
        super(AttachWorkGroupPolicyOperation, __self__).__init__(
            'tencentcloud:Dlc/attachWorkGroupPolicyOperation:AttachWorkGroupPolicyOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            policy_sets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachWorkGroupPolicyOperationPolicySetArgs']]]]] = None,
            work_group_id: Optional[pulumi.Input[int]] = None) -> 'AttachWorkGroupPolicyOperation':
        """
        Get an existing AttachWorkGroupPolicyOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachWorkGroupPolicyOperationPolicySetArgs']]]] policy_sets: The set of policies to be bound.
        :param pulumi.Input[int] work_group_id: Work group id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AttachWorkGroupPolicyOperationState.__new__(_AttachWorkGroupPolicyOperationState)

        __props__.__dict__["policy_sets"] = policy_sets
        __props__.__dict__["work_group_id"] = work_group_id
        return AttachWorkGroupPolicyOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="policySets")
    def policy_sets(self) -> pulumi.Output[Optional[Sequence['outputs.AttachWorkGroupPolicyOperationPolicySet']]]:
        """
        The set of policies to be bound.
        """
        return pulumi.get(self, "policy_sets")

    @property
    @pulumi.getter(name="workGroupId")
    def work_group_id(self) -> pulumi.Output[int]:
        """
        Work group id.
        """
        return pulumi.get(self, "work_group_id")

