# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDescribeDataEngineEventsResult',
    'AwaitableGetDescribeDataEngineEventsResult',
    'get_describe_data_engine_events',
    'get_describe_data_engine_events_output',
]

@pulumi.output_type
class GetDescribeDataEngineEventsResult:
    """
    A collection of values returned by getDescribeDataEngineEvents.
    """
    def __init__(__self__, data_engine_name=None, events=None, id=None, result_output_file=None):
        if data_engine_name and not isinstance(data_engine_name, str):
            raise TypeError("Expected argument 'data_engine_name' to be a str")
        pulumi.set(__self__, "data_engine_name", data_engine_name)
        if events and not isinstance(events, list):
            raise TypeError("Expected argument 'events' to be a list")
        pulumi.set(__self__, "events", events)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="dataEngineName")
    def data_engine_name(self) -> str:
        return pulumi.get(self, "data_engine_name")

    @property
    @pulumi.getter
    def events(self) -> Sequence['outputs.GetDescribeDataEngineEventsEventResult']:
        """
        Event details.
        """
        return pulumi.get(self, "events")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDescribeDataEngineEventsResult(GetDescribeDataEngineEventsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDescribeDataEngineEventsResult(
            data_engine_name=self.data_engine_name,
            events=self.events,
            id=self.id,
            result_output_file=self.result_output_file)


def get_describe_data_engine_events(data_engine_name: Optional[str] = None,
                                    result_output_file: Optional[str] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDescribeDataEngineEventsResult:
    """
    Use this data source to query detailed information of dlc describe_data_engine_events

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    describe_data_engine_events = tencentcloud.Dlc.get_describe_data_engine_events(data_engine_name="test")
    ```
    <!--End PulumiCodeChooser -->


    :param str data_engine_name: Data engine name.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['dataEngineName'] = data_engine_name
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dlc/getDescribeDataEngineEvents:getDescribeDataEngineEvents', __args__, opts=opts, typ=GetDescribeDataEngineEventsResult).value

    return AwaitableGetDescribeDataEngineEventsResult(
        data_engine_name=pulumi.get(__ret__, 'data_engine_name'),
        events=pulumi.get(__ret__, 'events'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_describe_data_engine_events)
def get_describe_data_engine_events_output(data_engine_name: Optional[pulumi.Input[str]] = None,
                                           result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDescribeDataEngineEventsResult]:
    """
    Use this data source to query detailed information of dlc describe_data_engine_events

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    describe_data_engine_events = tencentcloud.Dlc.get_describe_data_engine_events(data_engine_name="test")
    ```
    <!--End PulumiCodeChooser -->


    :param str data_engine_name: Data engine name.
    :param str result_output_file: Used to save results.
    """
    ...
