# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['RollbackDataEngineImageOperationArgs', 'RollbackDataEngineImageOperation']

@pulumi.input_type
class RollbackDataEngineImageOperationArgs:
    def __init__(__self__, *,
                 data_engine_id: pulumi.Input[str],
                 from_record_id: Optional[pulumi.Input[str]] = None,
                 to_record_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a RollbackDataEngineImageOperation resource.
        :param pulumi.Input[str] data_engine_id: Engine unique id.
        :param pulumi.Input[str] from_record_id: Log record id before rollback.
        :param pulumi.Input[str] to_record_id: Log record id after rollback.
        """
        pulumi.set(__self__, "data_engine_id", data_engine_id)
        if from_record_id is not None:
            pulumi.set(__self__, "from_record_id", from_record_id)
        if to_record_id is not None:
            pulumi.set(__self__, "to_record_id", to_record_id)

    @property
    @pulumi.getter(name="dataEngineId")
    def data_engine_id(self) -> pulumi.Input[str]:
        """
        Engine unique id.
        """
        return pulumi.get(self, "data_engine_id")

    @data_engine_id.setter
    def data_engine_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "data_engine_id", value)

    @property
    @pulumi.getter(name="fromRecordId")
    def from_record_id(self) -> Optional[pulumi.Input[str]]:
        """
        Log record id before rollback.
        """
        return pulumi.get(self, "from_record_id")

    @from_record_id.setter
    def from_record_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "from_record_id", value)

    @property
    @pulumi.getter(name="toRecordId")
    def to_record_id(self) -> Optional[pulumi.Input[str]]:
        """
        Log record id after rollback.
        """
        return pulumi.get(self, "to_record_id")

    @to_record_id.setter
    def to_record_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "to_record_id", value)


@pulumi.input_type
class _RollbackDataEngineImageOperationState:
    def __init__(__self__, *,
                 data_engine_id: Optional[pulumi.Input[str]] = None,
                 from_record_id: Optional[pulumi.Input[str]] = None,
                 to_record_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RollbackDataEngineImageOperation resources.
        :param pulumi.Input[str] data_engine_id: Engine unique id.
        :param pulumi.Input[str] from_record_id: Log record id before rollback.
        :param pulumi.Input[str] to_record_id: Log record id after rollback.
        """
        if data_engine_id is not None:
            pulumi.set(__self__, "data_engine_id", data_engine_id)
        if from_record_id is not None:
            pulumi.set(__self__, "from_record_id", from_record_id)
        if to_record_id is not None:
            pulumi.set(__self__, "to_record_id", to_record_id)

    @property
    @pulumi.getter(name="dataEngineId")
    def data_engine_id(self) -> Optional[pulumi.Input[str]]:
        """
        Engine unique id.
        """
        return pulumi.get(self, "data_engine_id")

    @data_engine_id.setter
    def data_engine_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "data_engine_id", value)

    @property
    @pulumi.getter(name="fromRecordId")
    def from_record_id(self) -> Optional[pulumi.Input[str]]:
        """
        Log record id before rollback.
        """
        return pulumi.get(self, "from_record_id")

    @from_record_id.setter
    def from_record_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "from_record_id", value)

    @property
    @pulumi.getter(name="toRecordId")
    def to_record_id(self) -> Optional[pulumi.Input[str]]:
        """
        Log record id after rollback.
        """
        return pulumi.get(self, "to_record_id")

    @to_record_id.setter
    def to_record_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "to_record_id", value)


class RollbackDataEngineImageOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 data_engine_id: Optional[pulumi.Input[str]] = None,
                 from_record_id: Optional[pulumi.Input[str]] = None,
                 to_record_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a dlc rollback_data_engine_image

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        check_data_engine_image_can_be_rollback = tencentcloud.Dlc.get_check_data_engine_image_can_be_rollback(data_engine_id="DataEngine-cgkvbas6")
        rollback_data_engine_image = tencentcloud.dlc.RollbackDataEngineImageOperation("rollbackDataEngineImage",
            data_engine_id="DataEngine-cgkvbas6",
            from_record_id=check_data_engine_image_can_be_rollback.from_record_id,
            to_record_id=check_data_engine_image_can_be_rollback.to_record_id)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        dlc rollback_data_engine_image can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Dlc/rollbackDataEngineImageOperation:RollbackDataEngineImageOperation rollback_data_engine_image rollback_data_engine_image_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] data_engine_id: Engine unique id.
        :param pulumi.Input[str] from_record_id: Log record id before rollback.
        :param pulumi.Input[str] to_record_id: Log record id after rollback.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RollbackDataEngineImageOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a dlc rollback_data_engine_image

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        check_data_engine_image_can_be_rollback = tencentcloud.Dlc.get_check_data_engine_image_can_be_rollback(data_engine_id="DataEngine-cgkvbas6")
        rollback_data_engine_image = tencentcloud.dlc.RollbackDataEngineImageOperation("rollbackDataEngineImage",
            data_engine_id="DataEngine-cgkvbas6",
            from_record_id=check_data_engine_image_can_be_rollback.from_record_id,
            to_record_id=check_data_engine_image_can_be_rollback.to_record_id)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        dlc rollback_data_engine_image can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Dlc/rollbackDataEngineImageOperation:RollbackDataEngineImageOperation rollback_data_engine_image rollback_data_engine_image_id
        ```

        :param str resource_name: The name of the resource.
        :param RollbackDataEngineImageOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RollbackDataEngineImageOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 data_engine_id: Optional[pulumi.Input[str]] = None,
                 from_record_id: Optional[pulumi.Input[str]] = None,
                 to_record_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RollbackDataEngineImageOperationArgs.__new__(RollbackDataEngineImageOperationArgs)

            if data_engine_id is None and not opts.urn:
                raise TypeError("Missing required property 'data_engine_id'")
            __props__.__dict__["data_engine_id"] = data_engine_id
            __props__.__dict__["from_record_id"] = from_record_id
            __props__.__dict__["to_record_id"] = to_record_id
        super(RollbackDataEngineImageOperation, __self__).__init__(
            'tencentcloud:Dlc/rollbackDataEngineImageOperation:RollbackDataEngineImageOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            data_engine_id: Optional[pulumi.Input[str]] = None,
            from_record_id: Optional[pulumi.Input[str]] = None,
            to_record_id: Optional[pulumi.Input[str]] = None) -> 'RollbackDataEngineImageOperation':
        """
        Get an existing RollbackDataEngineImageOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] data_engine_id: Engine unique id.
        :param pulumi.Input[str] from_record_id: Log record id before rollback.
        :param pulumi.Input[str] to_record_id: Log record id after rollback.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RollbackDataEngineImageOperationState.__new__(_RollbackDataEngineImageOperationState)

        __props__.__dict__["data_engine_id"] = data_engine_id
        __props__.__dict__["from_record_id"] = from_record_id
        __props__.__dict__["to_record_id"] = to_record_id
        return RollbackDataEngineImageOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dataEngineId")
    def data_engine_id(self) -> pulumi.Output[str]:
        """
        Engine unique id.
        """
        return pulumi.get(self, "data_engine_id")

    @property
    @pulumi.getter(name="fromRecordId")
    def from_record_id(self) -> pulumi.Output[Optional[str]]:
        """
        Log record id before rollback.
        """
        return pulumi.get(self, "from_record_id")

    @property
    @pulumi.getter(name="toRecordId")
    def to_record_id(self) -> pulumi.Output[Optional[str]]:
        """
        Log record id after rollback.
        """
        return pulumi.get(self, "to_record_id")

