# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['DiagnoseInstanceArgs', 'DiagnoseInstance']

@pulumi.input_type
class DiagnoseInstanceArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 diagnose_indices: Optional[pulumi.Input[str]] = None,
                 diagnose_jobs: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a DiagnoseInstance resource.
        :param pulumi.Input[str] instance_id: Instance id.
        :param pulumi.Input[str] diagnose_indices: Indexes that need to be diagnosed. Wildcards are supported.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] diagnose_jobs: Diagnostic items that need to be triggered.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        if diagnose_indices is not None:
            pulumi.set(__self__, "diagnose_indices", diagnose_indices)
        if diagnose_jobs is not None:
            pulumi.set(__self__, "diagnose_jobs", diagnose_jobs)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="diagnoseIndices")
    def diagnose_indices(self) -> Optional[pulumi.Input[str]]:
        """
        Indexes that need to be diagnosed. Wildcards are supported.
        """
        return pulumi.get(self, "diagnose_indices")

    @diagnose_indices.setter
    def diagnose_indices(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "diagnose_indices", value)

    @property
    @pulumi.getter(name="diagnoseJobs")
    def diagnose_jobs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Diagnostic items that need to be triggered.
        """
        return pulumi.get(self, "diagnose_jobs")

    @diagnose_jobs.setter
    def diagnose_jobs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "diagnose_jobs", value)


@pulumi.input_type
class _DiagnoseInstanceState:
    def __init__(__self__, *,
                 diagnose_indices: Optional[pulumi.Input[str]] = None,
                 diagnose_jobs: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering DiagnoseInstance resources.
        :param pulumi.Input[str] diagnose_indices: Indexes that need to be diagnosed. Wildcards are supported.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] diagnose_jobs: Diagnostic items that need to be triggered.
        :param pulumi.Input[str] instance_id: Instance id.
        """
        if diagnose_indices is not None:
            pulumi.set(__self__, "diagnose_indices", diagnose_indices)
        if diagnose_jobs is not None:
            pulumi.set(__self__, "diagnose_jobs", diagnose_jobs)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="diagnoseIndices")
    def diagnose_indices(self) -> Optional[pulumi.Input[str]]:
        """
        Indexes that need to be diagnosed. Wildcards are supported.
        """
        return pulumi.get(self, "diagnose_indices")

    @diagnose_indices.setter
    def diagnose_indices(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "diagnose_indices", value)

    @property
    @pulumi.getter(name="diagnoseJobs")
    def diagnose_jobs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Diagnostic items that need to be triggered.
        """
        return pulumi.get(self, "diagnose_jobs")

    @diagnose_jobs.setter
    def diagnose_jobs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "diagnose_jobs", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)


class DiagnoseInstance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 diagnose_indices: Optional[pulumi.Input[str]] = None,
                 diagnose_jobs: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a elasticsearch diagnose instance

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        diagnose_instance = tencentcloud.elasticsearch.DiagnoseInstance("diagnoseInstance",
            diagnose_indices="*",
            diagnose_jobs=["cluster_health"],
            instance_id="es-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] diagnose_indices: Indexes that need to be diagnosed. Wildcards are supported.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] diagnose_jobs: Diagnostic items that need to be triggered.
        :param pulumi.Input[str] instance_id: Instance id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DiagnoseInstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a elasticsearch diagnose instance

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        diagnose_instance = tencentcloud.elasticsearch.DiagnoseInstance("diagnoseInstance",
            diagnose_indices="*",
            diagnose_jobs=["cluster_health"],
            instance_id="es-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param DiagnoseInstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DiagnoseInstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 diagnose_indices: Optional[pulumi.Input[str]] = None,
                 diagnose_jobs: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DiagnoseInstanceArgs.__new__(DiagnoseInstanceArgs)

            __props__.__dict__["diagnose_indices"] = diagnose_indices
            __props__.__dict__["diagnose_jobs"] = diagnose_jobs
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
        super(DiagnoseInstance, __self__).__init__(
            'tencentcloud:Elasticsearch/diagnoseInstance:DiagnoseInstance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            diagnose_indices: Optional[pulumi.Input[str]] = None,
            diagnose_jobs: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            instance_id: Optional[pulumi.Input[str]] = None) -> 'DiagnoseInstance':
        """
        Get an existing DiagnoseInstance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] diagnose_indices: Indexes that need to be diagnosed. Wildcards are supported.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] diagnose_jobs: Diagnostic items that need to be triggered.
        :param pulumi.Input[str] instance_id: Instance id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DiagnoseInstanceState.__new__(_DiagnoseInstanceState)

        __props__.__dict__["diagnose_indices"] = diagnose_indices
        __props__.__dict__["diagnose_jobs"] = diagnose_jobs
        __props__.__dict__["instance_id"] = instance_id
        return DiagnoseInstance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="diagnoseIndices")
    def diagnose_indices(self) -> pulumi.Output[Optional[str]]:
        """
        Indexes that need to be diagnosed. Wildcards are supported.
        """
        return pulumi.get(self, "diagnose_indices")

    @property
    @pulumi.getter(name="diagnoseJobs")
    def diagnose_jobs(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Diagnostic items that need to be triggered.
        """
        return pulumi.get(self, "diagnose_jobs")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance id.
        """
        return pulumi.get(self, "instance_id")

