# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetViewsResult',
    'AwaitableGetViewsResult',
    'get_views',
    'get_views_output',
]

@pulumi.output_type
class GetViewsResult:
    """
    A collection of values returned by getViews.
    """
    def __init__(__self__, cluster_views=None, id=None, instance_id=None, kibanas_views=None, nodes_views=None, result_output_file=None):
        if cluster_views and not isinstance(cluster_views, list):
            raise TypeError("Expected argument 'cluster_views' to be a list")
        pulumi.set(__self__, "cluster_views", cluster_views)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if kibanas_views and not isinstance(kibanas_views, list):
            raise TypeError("Expected argument 'kibanas_views' to be a list")
        pulumi.set(__self__, "kibanas_views", kibanas_views)
        if nodes_views and not isinstance(nodes_views, list):
            raise TypeError("Expected argument 'nodes_views' to be a list")
        pulumi.set(__self__, "nodes_views", nodes_views)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="clusterViews")
    def cluster_views(self) -> Sequence['outputs.GetViewsClusterViewResult']:
        """
        Cluster view.
        """
        return pulumi.get(self, "cluster_views")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="kibanasViews")
    def kibanas_views(self) -> Sequence['outputs.GetViewsKibanasViewResult']:
        """
        Kibanas view.
        """
        return pulumi.get(self, "kibanas_views")

    @property
    @pulumi.getter(name="nodesViews")
    def nodes_views(self) -> Sequence['outputs.GetViewsNodesViewResult']:
        """
        Node View.
        """
        return pulumi.get(self, "nodes_views")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetViewsResult(GetViewsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetViewsResult(
            cluster_views=self.cluster_views,
            id=self.id,
            instance_id=self.instance_id,
            kibanas_views=self.kibanas_views,
            nodes_views=self.nodes_views,
            result_output_file=self.result_output_file)


def get_views(instance_id: Optional[str] = None,
              result_output_file: Optional[str] = None,
              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetViewsResult:
    """
    Use this data source to query detailed information of elasticsearch views

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    views = tencentcloud.Elasticsearch.get_views(instance_id="es-xxxxxx")
    ```
    <!--End PulumiCodeChooser -->


    :param str instance_id: Instance id.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Elasticsearch/getViews:getViews', __args__, opts=opts, typ=GetViewsResult).value

    return AwaitableGetViewsResult(
        cluster_views=pulumi.get(__ret__, 'cluster_views'),
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        kibanas_views=pulumi.get(__ret__, 'kibanas_views'),
        nodes_views=pulumi.get(__ret__, 'nodes_views'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_views)
def get_views_output(instance_id: Optional[pulumi.Input[str]] = None,
                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetViewsResult]:
    """
    Use this data source to query detailed information of elasticsearch views

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    views = tencentcloud.Elasticsearch.get_views(instance_id="es-xxxxxx")
    ```
    <!--End PulumiCodeChooser -->


    :param str instance_id: Instance id.
    :param str result_output_file: Used to save results.
    """
    ...
