# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetCvmQuotaResult',
    'AwaitableGetCvmQuotaResult',
    'get_cvm_quota',
    'get_cvm_quota_output',
]

@pulumi.output_type
class GetCvmQuotaResult:
    """
    A collection of values returned by getCvmQuota.
    """
    def __init__(__self__, cluster_id=None, eks_quota_sets=None, id=None, post_paid_quota_sets=None, result_output_file=None, spot_paid_quota_sets=None, zone_id=None):
        if cluster_id and not isinstance(cluster_id, str):
            raise TypeError("Expected argument 'cluster_id' to be a str")
        pulumi.set(__self__, "cluster_id", cluster_id)
        if eks_quota_sets and not isinstance(eks_quota_sets, list):
            raise TypeError("Expected argument 'eks_quota_sets' to be a list")
        pulumi.set(__self__, "eks_quota_sets", eks_quota_sets)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if post_paid_quota_sets and not isinstance(post_paid_quota_sets, list):
            raise TypeError("Expected argument 'post_paid_quota_sets' to be a list")
        pulumi.set(__self__, "post_paid_quota_sets", post_paid_quota_sets)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if spot_paid_quota_sets and not isinstance(spot_paid_quota_sets, list):
            raise TypeError("Expected argument 'spot_paid_quota_sets' to be a list")
        pulumi.set(__self__, "spot_paid_quota_sets", spot_paid_quota_sets)
        if zone_id and not isinstance(zone_id, int):
            raise TypeError("Expected argument 'zone_id' to be a int")
        pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> str:
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter(name="eksQuotaSets")
    def eks_quota_sets(self) -> Sequence['outputs.GetCvmQuotaEksQuotaSetResult']:
        """
        Eks quota Note: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "eks_quota_sets")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="postPaidQuotaSets")
    def post_paid_quota_sets(self) -> Sequence['outputs.GetCvmQuotaPostPaidQuotaSetResult']:
        """
        Postpaid quota list Note: This field may return null, indicating that no valid value can be obtained.
        """
        return pulumi.get(self, "post_paid_quota_sets")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="spotPaidQuotaSets")
    def spot_paid_quota_sets(self) -> Sequence['outputs.GetCvmQuotaSpotPaidQuotaSetResult']:
        """
        Biding instance quota list Note: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "spot_paid_quota_sets")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[int]:
        return pulumi.get(self, "zone_id")


class AwaitableGetCvmQuotaResult(GetCvmQuotaResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCvmQuotaResult(
            cluster_id=self.cluster_id,
            eks_quota_sets=self.eks_quota_sets,
            id=self.id,
            post_paid_quota_sets=self.post_paid_quota_sets,
            result_output_file=self.result_output_file,
            spot_paid_quota_sets=self.spot_paid_quota_sets,
            zone_id=self.zone_id)


def get_cvm_quota(cluster_id: Optional[str] = None,
                  result_output_file: Optional[str] = None,
                  zone_id: Optional[int] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCvmQuotaResult:
    """
    Use this data source to query detailed information of emr cvm_quota

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    cvm_quota = tencentcloud.Emr.get_cvm_quota(cluster_id="emr-0ze36vnp",
        zone_id=100003)
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: EMR cluster ID.
    :param str result_output_file: Used to save results.
    :param int zone_id: Zone ID.
    """
    __args__ = dict()
    __args__['clusterId'] = cluster_id
    __args__['resultOutputFile'] = result_output_file
    __args__['zoneId'] = zone_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Emr/getCvmQuota:getCvmQuota', __args__, opts=opts, typ=GetCvmQuotaResult).value

    return AwaitableGetCvmQuotaResult(
        cluster_id=pulumi.get(__ret__, 'cluster_id'),
        eks_quota_sets=pulumi.get(__ret__, 'eks_quota_sets'),
        id=pulumi.get(__ret__, 'id'),
        post_paid_quota_sets=pulumi.get(__ret__, 'post_paid_quota_sets'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        spot_paid_quota_sets=pulumi.get(__ret__, 'spot_paid_quota_sets'),
        zone_id=pulumi.get(__ret__, 'zone_id'))


@_utilities.lift_output_func(get_cvm_quota)
def get_cvm_quota_output(cluster_id: Optional[pulumi.Input[str]] = None,
                         result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                         zone_id: Optional[pulumi.Input[Optional[int]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCvmQuotaResult]:
    """
    Use this data source to query detailed information of emr cvm_quota

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    cvm_quota = tencentcloud.Emr.get_cvm_quota(cluster_id="emr-0ze36vnp",
        zone_id=100003)
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: EMR cluster ID.
    :param str result_output_file: Used to save results.
    :param int zone_id: Zone ID.
    """
    ...
