# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetAccessRegionsResult',
    'AwaitableGetAccessRegionsResult',
    'get_access_regions',
    'get_access_regions_output',
]

@pulumi.output_type
class GetAccessRegionsResult:
    """
    A collection of values returned by getAccessRegions.
    """
    def __init__(__self__, access_region_sets=None, id=None, result_output_file=None):
        if access_region_sets and not isinstance(access_region_sets, list):
            raise TypeError("Expected argument 'access_region_sets' to be a list")
        pulumi.set(__self__, "access_region_sets", access_region_sets)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="accessRegionSets")
    def access_region_sets(self) -> Sequence['outputs.GetAccessRegionsAccessRegionSetResult']:
        """
        Acceleration Zone Details List.
        """
        return pulumi.get(self, "access_region_sets")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetAccessRegionsResult(GetAccessRegionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAccessRegionsResult(
            access_region_sets=self.access_region_sets,
            id=self.id,
            result_output_file=self.result_output_file)


def get_access_regions(result_output_file: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAccessRegionsResult:
    """
    Use this data source to query detailed information of gaap access regions

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    access_regions = tencentcloud.Gaap.get_access_regions()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getAccessRegions:getAccessRegions', __args__, opts=opts, typ=GetAccessRegionsResult).value

    return AwaitableGetAccessRegionsResult(
        access_region_sets=pulumi.get(__ret__, 'access_region_sets'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_access_regions)
def get_access_regions_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetAccessRegionsResult]:
    """
    Use this data source to query detailed information of gaap access regions

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    access_regions = tencentcloud.Gaap.get_access_regions()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    ...
