# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetBlackHeaderResult',
    'AwaitableGetBlackHeaderResult',
    'get_black_header',
    'get_black_header_output',
]

@pulumi.output_type
class GetBlackHeaderResult:
    """
    A collection of values returned by getBlackHeader.
    """
    def __init__(__self__, black_headers=None, id=None, result_output_file=None):
        if black_headers and not isinstance(black_headers, list):
            raise TypeError("Expected argument 'black_headers' to be a list")
        pulumi.set(__self__, "black_headers", black_headers)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="blackHeaders")
    def black_headers(self) -> Sequence[str]:
        """
        Disabled custom header listNote: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "black_headers")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetBlackHeaderResult(GetBlackHeaderResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetBlackHeaderResult(
            black_headers=self.black_headers,
            id=self.id,
            result_output_file=self.result_output_file)


def get_black_header(result_output_file: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetBlackHeaderResult:
    """
    Use this data source to query detailed information of gaap black header

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    black_header = tencentcloud.Gaap.get_black_header()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getBlackHeader:getBlackHeader', __args__, opts=opts, typ=GetBlackHeaderResult).value

    return AwaitableGetBlackHeaderResult(
        black_headers=pulumi.get(__ret__, 'black_headers'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_black_header)
def get_black_header_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetBlackHeaderResult]:
    """
    Use this data source to query detailed information of gaap black header

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    black_header = tencentcloud.Gaap.get_black_header()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    ...
