# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetCustomHeaderResult',
    'AwaitableGetCustomHeaderResult',
    'get_custom_header',
    'get_custom_header_output',
]

@pulumi.output_type
class GetCustomHeaderResult:
    """
    A collection of values returned by getCustomHeader.
    """
    def __init__(__self__, headers=None, id=None, result_output_file=None, rule_id=None):
        if headers and not isinstance(headers, list):
            raise TypeError("Expected argument 'headers' to be a list")
        pulumi.set(__self__, "headers", headers)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if rule_id and not isinstance(rule_id, str):
            raise TypeError("Expected argument 'rule_id' to be a str")
        pulumi.set(__self__, "rule_id", rule_id)

    @property
    @pulumi.getter
    def headers(self) -> Sequence['outputs.GetCustomHeaderHeaderResult']:
        """
        HeadersNote: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "headers")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> str:
        return pulumi.get(self, "rule_id")


class AwaitableGetCustomHeaderResult(GetCustomHeaderResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCustomHeaderResult(
            headers=self.headers,
            id=self.id,
            result_output_file=self.result_output_file,
            rule_id=self.rule_id)


def get_custom_header(result_output_file: Optional[str] = None,
                      rule_id: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCustomHeaderResult:
    """
    Use this data source to query detailed information of gaap custom header

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    custom_header = tencentcloud.Gaap.get_custom_header(rule_id="rule-hddrxgpd")
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str rule_id: Rule IdNote: This field may return null, indicating that a valid value cannot be obtained.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    __args__['ruleId'] = rule_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getCustomHeader:getCustomHeader', __args__, opts=opts, typ=GetCustomHeaderResult).value

    return AwaitableGetCustomHeaderResult(
        headers=pulumi.get(__ret__, 'headers'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        rule_id=pulumi.get(__ret__, 'rule_id'))


@_utilities.lift_output_func(get_custom_header)
def get_custom_header_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             rule_id: Optional[pulumi.Input[str]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCustomHeaderResult]:
    """
    Use this data source to query detailed information of gaap custom header

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    custom_header = tencentcloud.Gaap.get_custom_header(rule_id="rule-hddrxgpd")
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str rule_id: Rule IdNote: This field may return null, indicating that a valid value cannot be obtained.
    """
    ...
