# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDestRegionsResult',
    'AwaitableGetDestRegionsResult',
    'get_dest_regions',
    'get_dest_regions_output',
]

@pulumi.output_type
class GetDestRegionsResult:
    """
    A collection of values returned by getDestRegions.
    """
    def __init__(__self__, dest_region_sets=None, id=None, result_output_file=None):
        if dest_region_sets and not isinstance(dest_region_sets, list):
            raise TypeError("Expected argument 'dest_region_sets' to be a list")
        pulumi.set(__self__, "dest_region_sets", dest_region_sets)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="destRegionSets")
    def dest_region_sets(self) -> Sequence['outputs.GetDestRegionsDestRegionSetResult']:
        """
        Source Site Area Details List.
        """
        return pulumi.get(self, "dest_region_sets")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDestRegionsResult(GetDestRegionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDestRegionsResult(
            dest_region_sets=self.dest_region_sets,
            id=self.id,
            result_output_file=self.result_output_file)


def get_dest_regions(result_output_file: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDestRegionsResult:
    """
    Use this data source to query detailed information of gaap dest regions

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    dest_regions = tencentcloud.Gaap.get_dest_regions()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getDestRegions:getDestRegions', __args__, opts=opts, typ=GetDestRegionsResult).value

    return AwaitableGetDestRegionsResult(
        dest_region_sets=pulumi.get(__ret__, 'dest_region_sets'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_dest_regions)
def get_dest_regions_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDestRegionsResult]:
    """
    Use this data source to query detailed information of gaap dest regions

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    dest_regions = tencentcloud.Gaap.get_dest_regions()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    ...
