# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDomainErrorPagesResult',
    'AwaitableGetDomainErrorPagesResult',
    'get_domain_error_pages',
    'get_domain_error_pages_output',
]

@pulumi.output_type
class GetDomainErrorPagesResult:
    """
    A collection of values returned by getDomainErrorPages.
    """
    def __init__(__self__, domain=None, error_page_info_lists=None, id=None, ids=None, listener_id=None, result_output_file=None):
        if domain and not isinstance(domain, str):
            raise TypeError("Expected argument 'domain' to be a str")
        pulumi.set(__self__, "domain", domain)
        if error_page_info_lists and not isinstance(error_page_info_lists, list):
            raise TypeError("Expected argument 'error_page_info_lists' to be a list")
        pulumi.set(__self__, "error_page_info_lists", error_page_info_lists)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if listener_id and not isinstance(listener_id, str):
            raise TypeError("Expected argument 'listener_id' to be a str")
        pulumi.set(__self__, "listener_id", listener_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def domain(self) -> str:
        """
        HTTP domain.
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter(name="errorPageInfoLists")
    def error_page_info_lists(self) -> Sequence['outputs.GetDomainErrorPagesErrorPageInfoListResult']:
        """
        An information list of error page info detail. Each element contains the following attributes:
        """
        return pulumi.get(self, "error_page_info_lists")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def ids(self) -> Optional[Sequence[str]]:
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter(name="listenerId")
    def listener_id(self) -> str:
        """
        ID of the layer7 listener.
        """
        return pulumi.get(self, "listener_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDomainErrorPagesResult(GetDomainErrorPagesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDomainErrorPagesResult(
            domain=self.domain,
            error_page_info_lists=self.error_page_info_lists,
            id=self.id,
            ids=self.ids,
            listener_id=self.listener_id,
            result_output_file=self.result_output_file)


def get_domain_error_pages(domain: Optional[str] = None,
                           ids: Optional[Sequence[str]] = None,
                           listener_id: Optional[str] = None,
                           result_output_file: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDomainErrorPagesResult:
    """
    Use this data source to query custom GAAP HTTP domain error page info list.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    foo_proxy = tencentcloud.gaap.Proxy("fooProxy",
        bandwidth=10,
        concurrent=2,
        access_region="SouthChina",
        realserver_region="NorthChina")
    foo_layer7_listener = tencentcloud.gaap.Layer7Listener("fooLayer7Listener",
        protocol="HTTP",
        port=80,
        proxy_id="%s")
    foo_http_domain = tencentcloud.gaap.HttpDomain("fooHttpDomain",
        listener_id=foo_layer7_listener.id,
        domain="www.qq.com")
    foo_domain_error_page = tencentcloud.gaap.DomainErrorPage("fooDomainErrorPage",
        listener_id=foo_layer7_listener.id,
        domain=foo_http_domain.domain,
        error_codes=[
            406,
            504,
        ],
        new_error_code=502,
        body="bad request",
        clear_headers=[
            "Content-Length",
            "X-TEST",
        ],
        set_headers={
            "X-TEST": "test",
        })
    foo_domain_error_pages = tencentcloud.Gaap.get_domain_error_pages_output(listener_id=foo_domain_error_page.listener_id,
        domain=foo_domain_error_page.domain)
    ```
    <!--End PulumiCodeChooser -->


    :param str domain: HTTP domain to be queried.
    :param Sequence[str] ids: List of the error page info ID to be queried.
    :param str listener_id: ID of the layer7 listener to be queried.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['domain'] = domain
    __args__['ids'] = ids
    __args__['listenerId'] = listener_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getDomainErrorPages:getDomainErrorPages', __args__, opts=opts, typ=GetDomainErrorPagesResult).value

    return AwaitableGetDomainErrorPagesResult(
        domain=pulumi.get(__ret__, 'domain'),
        error_page_info_lists=pulumi.get(__ret__, 'error_page_info_lists'),
        id=pulumi.get(__ret__, 'id'),
        ids=pulumi.get(__ret__, 'ids'),
        listener_id=pulumi.get(__ret__, 'listener_id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_domain_error_pages)
def get_domain_error_pages_output(domain: Optional[pulumi.Input[str]] = None,
                                  ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                  listener_id: Optional[pulumi.Input[str]] = None,
                                  result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDomainErrorPagesResult]:
    """
    Use this data source to query custom GAAP HTTP domain error page info list.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    foo_proxy = tencentcloud.gaap.Proxy("fooProxy",
        bandwidth=10,
        concurrent=2,
        access_region="SouthChina",
        realserver_region="NorthChina")
    foo_layer7_listener = tencentcloud.gaap.Layer7Listener("fooLayer7Listener",
        protocol="HTTP",
        port=80,
        proxy_id="%s")
    foo_http_domain = tencentcloud.gaap.HttpDomain("fooHttpDomain",
        listener_id=foo_layer7_listener.id,
        domain="www.qq.com")
    foo_domain_error_page = tencentcloud.gaap.DomainErrorPage("fooDomainErrorPage",
        listener_id=foo_layer7_listener.id,
        domain=foo_http_domain.domain,
        error_codes=[
            406,
            504,
        ],
        new_error_code=502,
        body="bad request",
        clear_headers=[
            "Content-Length",
            "X-TEST",
        ],
        set_headers={
            "X-TEST": "test",
        })
    foo_domain_error_pages = tencentcloud.Gaap.get_domain_error_pages_output(listener_id=foo_domain_error_page.listener_id,
        domain=foo_domain_error_page.domain)
    ```
    <!--End PulumiCodeChooser -->


    :param str domain: HTTP domain to be queried.
    :param Sequence[str] ids: List of the error page info ID to be queried.
    :param str listener_id: ID of the layer7 listener to be queried.
    :param str result_output_file: Used to save results.
    """
    ...
