# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetProxyAndStatisticsListenersResult',
    'AwaitableGetProxyAndStatisticsListenersResult',
    'get_proxy_and_statistics_listeners',
    'get_proxy_and_statistics_listeners_output',
]

@pulumi.output_type
class GetProxyAndStatisticsListenersResult:
    """
    A collection of values returned by getProxyAndStatisticsListeners.
    """
    def __init__(__self__, id=None, project_id=None, proxy_sets=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if project_id and not isinstance(project_id, int):
            raise TypeError("Expected argument 'project_id' to be a int")
        pulumi.set(__self__, "project_id", project_id)
        if proxy_sets and not isinstance(proxy_sets, list):
            raise TypeError("Expected argument 'proxy_sets' to be a list")
        pulumi.set(__self__, "proxy_sets", proxy_sets)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> int:
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter(name="proxySets")
    def proxy_sets(self) -> Sequence['outputs.GetProxyAndStatisticsListenersProxySetResult']:
        """
        proxy information that can be counted.
        """
        return pulumi.get(self, "proxy_sets")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetProxyAndStatisticsListenersResult(GetProxyAndStatisticsListenersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProxyAndStatisticsListenersResult(
            id=self.id,
            project_id=self.project_id,
            proxy_sets=self.proxy_sets,
            result_output_file=self.result_output_file)


def get_proxy_and_statistics_listeners(project_id: Optional[int] = None,
                                       result_output_file: Optional[str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProxyAndStatisticsListenersResult:
    """
    Use this data source to query detailed information of gaap proxy and statistics listeners

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    proxy_and_statistics_listeners = tencentcloud.Gaap.get_proxy_and_statistics_listeners(project_id=0)
    ```
    <!--End PulumiCodeChooser -->


    :param int project_id: Project Id.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['projectId'] = project_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getProxyAndStatisticsListeners:getProxyAndStatisticsListeners', __args__, opts=opts, typ=GetProxyAndStatisticsListenersResult).value

    return AwaitableGetProxyAndStatisticsListenersResult(
        id=pulumi.get(__ret__, 'id'),
        project_id=pulumi.get(__ret__, 'project_id'),
        proxy_sets=pulumi.get(__ret__, 'proxy_sets'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_proxy_and_statistics_listeners)
def get_proxy_and_statistics_listeners_output(project_id: Optional[pulumi.Input[int]] = None,
                                              result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProxyAndStatisticsListenersResult]:
    """
    Use this data source to query detailed information of gaap proxy and statistics listeners

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    proxy_and_statistics_listeners = tencentcloud.Gaap.get_proxy_and_statistics_listeners(project_id=0)
    ```
    <!--End PulumiCodeChooser -->


    :param int project_id: Project Id.
    :param str result_output_file: Used to save results.
    """
    ...
