# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CenterRoleConfigurationArgs', 'CenterRoleConfiguration']

@pulumi.input_type
class CenterRoleConfigurationArgs:
    def __init__(__self__, *,
                 role_configuration_name: pulumi.Input[str],
                 zone_id: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 relay_state: Optional[pulumi.Input[str]] = None,
                 session_duration: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a CenterRoleConfiguration resource.
        :param pulumi.Input[str] role_configuration_name: Access configuration name, which contains up to 128 characters, including English letters, digits, and hyphens (-).
        :param pulumi.Input[str] zone_id: Space ID.
        :param pulumi.Input[str] description: Access configuration description, which contains up to 1024 characters.
        :param pulumi.Input[str] relay_state: Initial access page. It indicates the initial access page URL when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. This page must be the Tencent Cloud console page. The default is null, which indicates navigating to the home page of the Tencent Cloud console.
        :param pulumi.Input[int] session_duration: Session duration. It indicates the maximum session duration when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. Unit: seconds. Value range: 900-43,200 (15 minutes to 12 hours). Default value: 3600 (1 hour).
        """
        pulumi.set(__self__, "role_configuration_name", role_configuration_name)
        pulumi.set(__self__, "zone_id", zone_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if relay_state is not None:
            pulumi.set(__self__, "relay_state", relay_state)
        if session_duration is not None:
            pulumi.set(__self__, "session_duration", session_duration)

    @property
    @pulumi.getter(name="roleConfigurationName")
    def role_configuration_name(self) -> pulumi.Input[str]:
        """
        Access configuration name, which contains up to 128 characters, including English letters, digits, and hyphens (-).
        """
        return pulumi.get(self, "role_configuration_name")

    @role_configuration_name.setter
    def role_configuration_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "role_configuration_name", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Input[str]:
        """
        Space ID.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "zone_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Access configuration description, which contains up to 1024 characters.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="relayState")
    def relay_state(self) -> Optional[pulumi.Input[str]]:
        """
        Initial access page. It indicates the initial access page URL when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. This page must be the Tencent Cloud console page. The default is null, which indicates navigating to the home page of the Tencent Cloud console.
        """
        return pulumi.get(self, "relay_state")

    @relay_state.setter
    def relay_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "relay_state", value)

    @property
    @pulumi.getter(name="sessionDuration")
    def session_duration(self) -> Optional[pulumi.Input[int]]:
        """
        Session duration. It indicates the maximum session duration when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. Unit: seconds. Value range: 900-43,200 (15 minutes to 12 hours). Default value: 3600 (1 hour).
        """
        return pulumi.get(self, "session_duration")

    @session_duration.setter
    def session_duration(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "session_duration", value)


@pulumi.input_type
class _CenterRoleConfigurationState:
    def __init__(__self__, *,
                 create_time: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 relay_state: Optional[pulumi.Input[str]] = None,
                 role_configuration_id: Optional[pulumi.Input[str]] = None,
                 role_configuration_name: Optional[pulumi.Input[str]] = None,
                 session_duration: Optional[pulumi.Input[int]] = None,
                 update_time: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CenterRoleConfiguration resources.
        :param pulumi.Input[str] create_time: Create time.
        :param pulumi.Input[str] description: Access configuration description, which contains up to 1024 characters.
        :param pulumi.Input[str] relay_state: Initial access page. It indicates the initial access page URL when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. This page must be the Tencent Cloud console page. The default is null, which indicates navigating to the home page of the Tencent Cloud console.
        :param pulumi.Input[str] role_configuration_id: Role configuration id.
        :param pulumi.Input[str] role_configuration_name: Access configuration name, which contains up to 128 characters, including English letters, digits, and hyphens (-).
        :param pulumi.Input[int] session_duration: Session duration. It indicates the maximum session duration when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. Unit: seconds. Value range: 900-43,200 (15 minutes to 12 hours). Default value: 3600 (1 hour).
        :param pulumi.Input[str] update_time: Update time.
        :param pulumi.Input[str] zone_id: Space ID.
        """
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if relay_state is not None:
            pulumi.set(__self__, "relay_state", relay_state)
        if role_configuration_id is not None:
            pulumi.set(__self__, "role_configuration_id", role_configuration_id)
        if role_configuration_name is not None:
            pulumi.set(__self__, "role_configuration_name", role_configuration_name)
        if session_duration is not None:
            pulumi.set(__self__, "session_duration", session_duration)
        if update_time is not None:
            pulumi.set(__self__, "update_time", update_time)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        Create time.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Access configuration description, which contains up to 1024 characters.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="relayState")
    def relay_state(self) -> Optional[pulumi.Input[str]]:
        """
        Initial access page. It indicates the initial access page URL when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. This page must be the Tencent Cloud console page. The default is null, which indicates navigating to the home page of the Tencent Cloud console.
        """
        return pulumi.get(self, "relay_state")

    @relay_state.setter
    def relay_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "relay_state", value)

    @property
    @pulumi.getter(name="roleConfigurationId")
    def role_configuration_id(self) -> Optional[pulumi.Input[str]]:
        """
        Role configuration id.
        """
        return pulumi.get(self, "role_configuration_id")

    @role_configuration_id.setter
    def role_configuration_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role_configuration_id", value)

    @property
    @pulumi.getter(name="roleConfigurationName")
    def role_configuration_name(self) -> Optional[pulumi.Input[str]]:
        """
        Access configuration name, which contains up to 128 characters, including English letters, digits, and hyphens (-).
        """
        return pulumi.get(self, "role_configuration_name")

    @role_configuration_name.setter
    def role_configuration_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "role_configuration_name", value)

    @property
    @pulumi.getter(name="sessionDuration")
    def session_duration(self) -> Optional[pulumi.Input[int]]:
        """
        Session duration. It indicates the maximum session duration when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. Unit: seconds. Value range: 900-43,200 (15 minutes to 12 hours). Default value: 3600 (1 hour).
        """
        return pulumi.get(self, "session_duration")

    @session_duration.setter
    def session_duration(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "session_duration", value)

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> Optional[pulumi.Input[str]]:
        """
        Update time.
        """
        return pulumi.get(self, "update_time")

    @update_time.setter
    def update_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "update_time", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Space ID.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


class CenterRoleConfiguration(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 relay_state: Optional[pulumi.Input[str]] = None,
                 role_configuration_name: Optional[pulumi.Input[str]] = None,
                 session_duration: Optional[pulumi.Input[int]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a organization identity_center_role_configuration

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        identity_center_role_configuration = tencentcloud.identity.CenterRoleConfiguration("identityCenterRoleConfiguration",
            description="test",
            role_configuration_name="tf-test",
            zone_id="z-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization identity_center_role_configuration can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Identity/centerRoleConfiguration:CenterRoleConfiguration identity_center_role_configuration ${zoneId}#${roleConfigurationId}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Access configuration description, which contains up to 1024 characters.
        :param pulumi.Input[str] relay_state: Initial access page. It indicates the initial access page URL when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. This page must be the Tencent Cloud console page. The default is null, which indicates navigating to the home page of the Tencent Cloud console.
        :param pulumi.Input[str] role_configuration_name: Access configuration name, which contains up to 128 characters, including English letters, digits, and hyphens (-).
        :param pulumi.Input[int] session_duration: Session duration. It indicates the maximum session duration when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. Unit: seconds. Value range: 900-43,200 (15 minutes to 12 hours). Default value: 3600 (1 hour).
        :param pulumi.Input[str] zone_id: Space ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CenterRoleConfigurationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a organization identity_center_role_configuration

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        identity_center_role_configuration = tencentcloud.identity.CenterRoleConfiguration("identityCenterRoleConfiguration",
            description="test",
            role_configuration_name="tf-test",
            zone_id="z-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization identity_center_role_configuration can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Identity/centerRoleConfiguration:CenterRoleConfiguration identity_center_role_configuration ${zoneId}#${roleConfigurationId}
        ```

        :param str resource_name: The name of the resource.
        :param CenterRoleConfigurationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CenterRoleConfigurationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 relay_state: Optional[pulumi.Input[str]] = None,
                 role_configuration_name: Optional[pulumi.Input[str]] = None,
                 session_duration: Optional[pulumi.Input[int]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CenterRoleConfigurationArgs.__new__(CenterRoleConfigurationArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["relay_state"] = relay_state
            if role_configuration_name is None and not opts.urn:
                raise TypeError("Missing required property 'role_configuration_name'")
            __props__.__dict__["role_configuration_name"] = role_configuration_name
            __props__.__dict__["session_duration"] = session_duration
            if zone_id is None and not opts.urn:
                raise TypeError("Missing required property 'zone_id'")
            __props__.__dict__["zone_id"] = zone_id
            __props__.__dict__["create_time"] = None
            __props__.__dict__["role_configuration_id"] = None
            __props__.__dict__["update_time"] = None
        super(CenterRoleConfiguration, __self__).__init__(
            'tencentcloud:Identity/centerRoleConfiguration:CenterRoleConfiguration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            relay_state: Optional[pulumi.Input[str]] = None,
            role_configuration_id: Optional[pulumi.Input[str]] = None,
            role_configuration_name: Optional[pulumi.Input[str]] = None,
            session_duration: Optional[pulumi.Input[int]] = None,
            update_time: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[str]] = None) -> 'CenterRoleConfiguration':
        """
        Get an existing CenterRoleConfiguration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] create_time: Create time.
        :param pulumi.Input[str] description: Access configuration description, which contains up to 1024 characters.
        :param pulumi.Input[str] relay_state: Initial access page. It indicates the initial access page URL when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. This page must be the Tencent Cloud console page. The default is null, which indicates navigating to the home page of the Tencent Cloud console.
        :param pulumi.Input[str] role_configuration_id: Role configuration id.
        :param pulumi.Input[str] role_configuration_name: Access configuration name, which contains up to 128 characters, including English letters, digits, and hyphens (-).
        :param pulumi.Input[int] session_duration: Session duration. It indicates the maximum session duration when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. Unit: seconds. Value range: 900-43,200 (15 minutes to 12 hours). Default value: 3600 (1 hour).
        :param pulumi.Input[str] update_time: Update time.
        :param pulumi.Input[str] zone_id: Space ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CenterRoleConfigurationState.__new__(_CenterRoleConfigurationState)

        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["description"] = description
        __props__.__dict__["relay_state"] = relay_state
        __props__.__dict__["role_configuration_id"] = role_configuration_id
        __props__.__dict__["role_configuration_name"] = role_configuration_name
        __props__.__dict__["session_duration"] = session_duration
        __props__.__dict__["update_time"] = update_time
        __props__.__dict__["zone_id"] = zone_id
        return CenterRoleConfiguration(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        Create time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        Access configuration description, which contains up to 1024 characters.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="relayState")
    def relay_state(self) -> pulumi.Output[str]:
        """
        Initial access page. It indicates the initial access page URL when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. This page must be the Tencent Cloud console page. The default is null, which indicates navigating to the home page of the Tencent Cloud console.
        """
        return pulumi.get(self, "relay_state")

    @property
    @pulumi.getter(name="roleConfigurationId")
    def role_configuration_id(self) -> pulumi.Output[str]:
        """
        Role configuration id.
        """
        return pulumi.get(self, "role_configuration_id")

    @property
    @pulumi.getter(name="roleConfigurationName")
    def role_configuration_name(self) -> pulumi.Output[str]:
        """
        Access configuration name, which contains up to 128 characters, including English letters, digits, and hyphens (-).
        """
        return pulumi.get(self, "role_configuration_name")

    @property
    @pulumi.getter(name="sessionDuration")
    def session_duration(self) -> pulumi.Output[int]:
        """
        Session duration. It indicates the maximum session duration when CIC users use the access configuration to access the target account of the Tencent Cloud Organization. Unit: seconds. Value range: 900-43,200 (15 minutes to 12 hours). Default value: 3600 (1 hour).
        """
        return pulumi.get(self, "session_duration")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> pulumi.Output[str]:
        """
        Update time.
        """
        return pulumi.get(self, "update_time")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[str]:
        """
        Space ID.
        """
        return pulumi.get(self, "zone_id")

