# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CenterScimCredentialStatusArgs', 'CenterScimCredentialStatus']

@pulumi.input_type
class CenterScimCredentialStatusArgs:
    def __init__(__self__, *,
                 credential_id: pulumi.Input[str],
                 status: pulumi.Input[str],
                 zone_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a CenterScimCredentialStatus resource.
        :param pulumi.Input[str] credential_id: SCIM key ID. scimcred-prefix and followed by 12 random digits/lowercase letters.
        :param pulumi.Input[str] status: SCIM key status. Enabled-enabled. Disabled-disabled.
        :param pulumi.Input[str] zone_id: Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        pulumi.set(__self__, "credential_id", credential_id)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="credentialId")
    def credential_id(self) -> pulumi.Input[str]:
        """
        SCIM key ID. scimcred-prefix and followed by 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "credential_id")

    @credential_id.setter
    def credential_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "credential_id", value)

    @property
    @pulumi.getter
    def status(self) -> pulumi.Input[str]:
        """
        SCIM key status. Enabled-enabled. Disabled-disabled.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: pulumi.Input[str]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Input[str]:
        """
        Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "zone_id", value)


@pulumi.input_type
class _CenterScimCredentialStatusState:
    def __init__(__self__, *,
                 credential_id: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CenterScimCredentialStatus resources.
        :param pulumi.Input[str] credential_id: SCIM key ID. scimcred-prefix and followed by 12 random digits/lowercase letters.
        :param pulumi.Input[str] status: SCIM key status. Enabled-enabled. Disabled-disabled.
        :param pulumi.Input[str] zone_id: Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        if credential_id is not None:
            pulumi.set(__self__, "credential_id", credential_id)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="credentialId")
    def credential_id(self) -> Optional[pulumi.Input[str]]:
        """
        SCIM key ID. scimcred-prefix and followed by 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "credential_id")

    @credential_id.setter
    def credential_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "credential_id", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        SCIM key status. Enabled-enabled. Disabled-disabled.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


class CenterScimCredentialStatus(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 credential_id: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage identity center scim credential status

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        identity_center_scim_credential_status = tencentcloud.identity.CenterScimCredentialStatus("identityCenterScimCredentialStatus",
            credential_id="scimcred-xxxxxx",
            status="Enabled",
            zone_id="z-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization identity_center_scim_credential_status can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Identity/centerScimCredentialStatus:CenterScimCredentialStatus identity_center_scim_credential_status ${zone_id}#${credential_id}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] credential_id: SCIM key ID. scimcred-prefix and followed by 12 random digits/lowercase letters.
        :param pulumi.Input[str] status: SCIM key status. Enabled-enabled. Disabled-disabled.
        :param pulumi.Input[str] zone_id: Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CenterScimCredentialStatusArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage identity center scim credential status

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        identity_center_scim_credential_status = tencentcloud.identity.CenterScimCredentialStatus("identityCenterScimCredentialStatus",
            credential_id="scimcred-xxxxxx",
            status="Enabled",
            zone_id="z-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization identity_center_scim_credential_status can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Identity/centerScimCredentialStatus:CenterScimCredentialStatus identity_center_scim_credential_status ${zone_id}#${credential_id}
        ```

        :param str resource_name: The name of the resource.
        :param CenterScimCredentialStatusArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CenterScimCredentialStatusArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 credential_id: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CenterScimCredentialStatusArgs.__new__(CenterScimCredentialStatusArgs)

            if credential_id is None and not opts.urn:
                raise TypeError("Missing required property 'credential_id'")
            __props__.__dict__["credential_id"] = credential_id
            if status is None and not opts.urn:
                raise TypeError("Missing required property 'status'")
            __props__.__dict__["status"] = status
            if zone_id is None and not opts.urn:
                raise TypeError("Missing required property 'zone_id'")
            __props__.__dict__["zone_id"] = zone_id
        super(CenterScimCredentialStatus, __self__).__init__(
            'tencentcloud:Identity/centerScimCredentialStatus:CenterScimCredentialStatus',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            credential_id: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[str]] = None) -> 'CenterScimCredentialStatus':
        """
        Get an existing CenterScimCredentialStatus resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] credential_id: SCIM key ID. scimcred-prefix and followed by 12 random digits/lowercase letters.
        :param pulumi.Input[str] status: SCIM key status. Enabled-enabled. Disabled-disabled.
        :param pulumi.Input[str] zone_id: Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CenterScimCredentialStatusState.__new__(_CenterScimCredentialStatusState)

        __props__.__dict__["credential_id"] = credential_id
        __props__.__dict__["status"] = status
        __props__.__dict__["zone_id"] = zone_id
        return CenterScimCredentialStatus(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="credentialId")
    def credential_id(self) -> pulumi.Output[str]:
        """
        SCIM key ID. scimcred-prefix and followed by 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "credential_id")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        SCIM key status. Enabled-enabled. Disabled-disabled.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[str]:
        """
        Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "zone_id")

