# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CenterScimSynchronizationStatusArgs', 'CenterScimSynchronizationStatus']

@pulumi.input_type
class CenterScimSynchronizationStatusArgs:
    def __init__(__self__, *,
                 scim_synchronization_status: pulumi.Input[str],
                 zone_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a CenterScimSynchronizationStatus resource.
        :param pulumi.Input[str] scim_synchronization_status: SCIM synchronization status. Enabled-enabled. Disabled-disables.
        :param pulumi.Input[str] zone_id: Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        pulumi.set(__self__, "scim_synchronization_status", scim_synchronization_status)
        pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="scimSynchronizationStatus")
    def scim_synchronization_status(self) -> pulumi.Input[str]:
        """
        SCIM synchronization status. Enabled-enabled. Disabled-disables.
        """
        return pulumi.get(self, "scim_synchronization_status")

    @scim_synchronization_status.setter
    def scim_synchronization_status(self, value: pulumi.Input[str]):
        pulumi.set(self, "scim_synchronization_status", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Input[str]:
        """
        Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "zone_id", value)


@pulumi.input_type
class _CenterScimSynchronizationStatusState:
    def __init__(__self__, *,
                 scim_synchronization_status: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CenterScimSynchronizationStatus resources.
        :param pulumi.Input[str] scim_synchronization_status: SCIM synchronization status. Enabled-enabled. Disabled-disables.
        :param pulumi.Input[str] zone_id: Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        if scim_synchronization_status is not None:
            pulumi.set(__self__, "scim_synchronization_status", scim_synchronization_status)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="scimSynchronizationStatus")
    def scim_synchronization_status(self) -> Optional[pulumi.Input[str]]:
        """
        SCIM synchronization status. Enabled-enabled. Disabled-disables.
        """
        return pulumi.get(self, "scim_synchronization_status")

    @scim_synchronization_status.setter
    def scim_synchronization_status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scim_synchronization_status", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


class CenterScimSynchronizationStatus(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 scim_synchronization_status: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage identity center scim synchronization status

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        identity_center_scim_synchronization_status = tencentcloud.identity.CenterScimSynchronizationStatus("identityCenterScimSynchronizationStatus",
            scim_synchronization_status="Enabled",
            zone_id="z-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization identity_center_scim_synchronization_status can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Identity/centerScimSynchronizationStatus:CenterScimSynchronizationStatus identity_center_scim_synchronization_status ${zone_id}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] scim_synchronization_status: SCIM synchronization status. Enabled-enabled. Disabled-disables.
        :param pulumi.Input[str] zone_id: Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CenterScimSynchronizationStatusArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage identity center scim synchronization status

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        identity_center_scim_synchronization_status = tencentcloud.identity.CenterScimSynchronizationStatus("identityCenterScimSynchronizationStatus",
            scim_synchronization_status="Enabled",
            zone_id="z-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization identity_center_scim_synchronization_status can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Identity/centerScimSynchronizationStatus:CenterScimSynchronizationStatus identity_center_scim_synchronization_status ${zone_id}
        ```

        :param str resource_name: The name of the resource.
        :param CenterScimSynchronizationStatusArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CenterScimSynchronizationStatusArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 scim_synchronization_status: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CenterScimSynchronizationStatusArgs.__new__(CenterScimSynchronizationStatusArgs)

            if scim_synchronization_status is None and not opts.urn:
                raise TypeError("Missing required property 'scim_synchronization_status'")
            __props__.__dict__["scim_synchronization_status"] = scim_synchronization_status
            if zone_id is None and not opts.urn:
                raise TypeError("Missing required property 'zone_id'")
            __props__.__dict__["zone_id"] = zone_id
        super(CenterScimSynchronizationStatus, __self__).__init__(
            'tencentcloud:Identity/centerScimSynchronizationStatus:CenterScimSynchronizationStatus',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            scim_synchronization_status: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[str]] = None) -> 'CenterScimSynchronizationStatus':
        """
        Get an existing CenterScimSynchronizationStatus resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] scim_synchronization_status: SCIM synchronization status. Enabled-enabled. Disabled-disables.
        :param pulumi.Input[str] zone_id: Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CenterScimSynchronizationStatusState.__new__(_CenterScimSynchronizationStatusState)

        __props__.__dict__["scim_synchronization_status"] = scim_synchronization_status
        __props__.__dict__["zone_id"] = zone_id
        return CenterScimSynchronizationStatus(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="scimSynchronizationStatus")
    def scim_synchronization_status(self) -> pulumi.Output[str]:
        """
        SCIM synchronization status. Enabled-enabled. Disabled-disables.
        """
        return pulumi.get(self, "scim_synchronization_status")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[str]:
        """
        Space ID. z-prefix starts with 12 random digits/lowercase letters.
        """
        return pulumi.get(self, "zone_id")

