# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CenterUserSyncProvisioningArgs', 'CenterUserSyncProvisioning']

@pulumi.input_type
class CenterUserSyncProvisioningArgs:
    def __init__(__self__, *,
                 zone_id: pulumi.Input[str],
                 deletion_strategy: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 duplication_strategy: Optional[pulumi.Input[str]] = None,
                 principal_id: Optional[pulumi.Input[str]] = None,
                 principal_type: Optional[pulumi.Input[str]] = None,
                 target_type: Optional[pulumi.Input[str]] = None,
                 target_uin: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a CenterUserSyncProvisioning resource.
        :param pulumi.Input[str] zone_id: Space ID.
        :param pulumi.Input[str] deletion_strategy: Deletion policy. It indicates the handling policy for CAM users already synchronized when the CAM user synchronization is deleted. Valid values: Delete: Delete the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted; Keep: Keep the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted.
        :param pulumi.Input[str] description: Description.
        :param pulumi.Input[str] duplication_strategy: Conflict policy. It indicates the handling policy for existence of a user with the same username when CIC users are synchronized to CAM. Valid values: KeepBoth: Keep both, that is, add the _cic suffix to the CIC user's username and then try to create a CAM user with the username when CIC users are synchronized to CAM and a user with the same username already exists in CAM; TakeOver: Replace, that is, directly replace the existing CAM user with the synchronized CIC user when CIC users are synchronized to CAM and a user with the same username already exists in CAM.
        :param pulumi.Input[str] principal_id: Identity ID for the CAM user synchronization. Valid values:
               When the PrincipalType value is Group, it is the CIC user group ID (g-********).
               When the PrincipalType value is User, it is the CIC user ID (u-********).
        :param pulumi.Input[str] principal_type: Identity type for the CAM user synchronization. Valid values:
               
               User: indicates that the identity for the CAM user synchronization is a CIC user.
               Group: indicates that the identity for the CAM user synchronization is a CIC user group.
        :param pulumi.Input[str] target_type: Type of the synchronized target account of the Tencent Cloud Organization. ManagerUin: admin account; MemberUin: member account.
        :param pulumi.Input[int] target_uin: UIN of the synchronized target account of the Tencent Cloud Organization.
        """
        pulumi.set(__self__, "zone_id", zone_id)
        if deletion_strategy is not None:
            pulumi.set(__self__, "deletion_strategy", deletion_strategy)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if duplication_strategy is not None:
            pulumi.set(__self__, "duplication_strategy", duplication_strategy)
        if principal_id is not None:
            pulumi.set(__self__, "principal_id", principal_id)
        if principal_type is not None:
            pulumi.set(__self__, "principal_type", principal_type)
        if target_type is not None:
            pulumi.set(__self__, "target_type", target_type)
        if target_uin is not None:
            pulumi.set(__self__, "target_uin", target_uin)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Input[str]:
        """
        Space ID.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "zone_id", value)

    @property
    @pulumi.getter(name="deletionStrategy")
    def deletion_strategy(self) -> Optional[pulumi.Input[str]]:
        """
        Deletion policy. It indicates the handling policy for CAM users already synchronized when the CAM user synchronization is deleted. Valid values: Delete: Delete the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted; Keep: Keep the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted.
        """
        return pulumi.get(self, "deletion_strategy")

    @deletion_strategy.setter
    def deletion_strategy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "deletion_strategy", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="duplicationStrategy")
    def duplication_strategy(self) -> Optional[pulumi.Input[str]]:
        """
        Conflict policy. It indicates the handling policy for existence of a user with the same username when CIC users are synchronized to CAM. Valid values: KeepBoth: Keep both, that is, add the _cic suffix to the CIC user's username and then try to create a CAM user with the username when CIC users are synchronized to CAM and a user with the same username already exists in CAM; TakeOver: Replace, that is, directly replace the existing CAM user with the synchronized CIC user when CIC users are synchronized to CAM and a user with the same username already exists in CAM.
        """
        return pulumi.get(self, "duplication_strategy")

    @duplication_strategy.setter
    def duplication_strategy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "duplication_strategy", value)

    @property
    @pulumi.getter(name="principalId")
    def principal_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identity ID for the CAM user synchronization. Valid values:
        When the PrincipalType value is Group, it is the CIC user group ID (g-********).
        When the PrincipalType value is User, it is the CIC user ID (u-********).
        """
        return pulumi.get(self, "principal_id")

    @principal_id.setter
    def principal_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "principal_id", value)

    @property
    @pulumi.getter(name="principalType")
    def principal_type(self) -> Optional[pulumi.Input[str]]:
        """
        Identity type for the CAM user synchronization. Valid values:

        User: indicates that the identity for the CAM user synchronization is a CIC user.
        Group: indicates that the identity for the CAM user synchronization is a CIC user group.
        """
        return pulumi.get(self, "principal_type")

    @principal_type.setter
    def principal_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "principal_type", value)

    @property
    @pulumi.getter(name="targetType")
    def target_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of the synchronized target account of the Tencent Cloud Organization. ManagerUin: admin account; MemberUin: member account.
        """
        return pulumi.get(self, "target_type")

    @target_type.setter
    def target_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_type", value)

    @property
    @pulumi.getter(name="targetUin")
    def target_uin(self) -> Optional[pulumi.Input[int]]:
        """
        UIN of the synchronized target account of the Tencent Cloud Organization.
        """
        return pulumi.get(self, "target_uin")

    @target_uin.setter
    def target_uin(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "target_uin", value)


@pulumi.input_type
class _CenterUserSyncProvisioningState:
    def __init__(__self__, *,
                 create_time: Optional[pulumi.Input[str]] = None,
                 deletion_strategy: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 duplication_strategy: Optional[pulumi.Input[str]] = None,
                 principal_id: Optional[pulumi.Input[str]] = None,
                 principal_name: Optional[pulumi.Input[str]] = None,
                 principal_type: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 target_name: Optional[pulumi.Input[str]] = None,
                 target_type: Optional[pulumi.Input[str]] = None,
                 target_uin: Optional[pulumi.Input[int]] = None,
                 update_time: Optional[pulumi.Input[str]] = None,
                 user_provisioning_id: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CenterUserSyncProvisioning resources.
        :param pulumi.Input[str] create_time: Create time.
        :param pulumi.Input[str] deletion_strategy: Deletion policy. It indicates the handling policy for CAM users already synchronized when the CAM user synchronization is deleted. Valid values: Delete: Delete the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted; Keep: Keep the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted.
        :param pulumi.Input[str] description: Description.
        :param pulumi.Input[str] duplication_strategy: Conflict policy. It indicates the handling policy for existence of a user with the same username when CIC users are synchronized to CAM. Valid values: KeepBoth: Keep both, that is, add the _cic suffix to the CIC user's username and then try to create a CAM user with the username when CIC users are synchronized to CAM and a user with the same username already exists in CAM; TakeOver: Replace, that is, directly replace the existing CAM user with the synchronized CIC user when CIC users are synchronized to CAM and a user with the same username already exists in CAM.
        :param pulumi.Input[str] principal_id: Identity ID for the CAM user synchronization. Valid values:
               When the PrincipalType value is Group, it is the CIC user group ID (g-********).
               When the PrincipalType value is User, it is the CIC user ID (u-********).
        :param pulumi.Input[str] principal_name: The identity name of the CAM user synchronization. Value: When PrincipalType is Group, the value is the CIC user group name; When PrincipalType takes the value to User, the value is the CIC user name.
        :param pulumi.Input[str] principal_type: Identity type for the CAM user synchronization. Valid values:
               
               User: indicates that the identity for the CAM user synchronization is a CIC user.
               Group: indicates that the identity for the CAM user synchronization is a CIC user group.
        :param pulumi.Input[str] status: Status of CAM user synchronization. Value:
               * Enabled: CAM user synchronization is enabled;
               * Disabled: CAM user synchronization is not enabled.
        :param pulumi.Input[str] target_name: Group account The name of the target account..
        :param pulumi.Input[str] target_type: Type of the synchronized target account of the Tencent Cloud Organization. ManagerUin: admin account; MemberUin: member account.
        :param pulumi.Input[int] target_uin: UIN of the synchronized target account of the Tencent Cloud Organization.
        :param pulumi.Input[str] update_time: Update time.
        :param pulumi.Input[str] user_provisioning_id: User provisioning id.
        :param pulumi.Input[str] zone_id: Space ID.
        """
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if deletion_strategy is not None:
            pulumi.set(__self__, "deletion_strategy", deletion_strategy)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if duplication_strategy is not None:
            pulumi.set(__self__, "duplication_strategy", duplication_strategy)
        if principal_id is not None:
            pulumi.set(__self__, "principal_id", principal_id)
        if principal_name is not None:
            pulumi.set(__self__, "principal_name", principal_name)
        if principal_type is not None:
            pulumi.set(__self__, "principal_type", principal_type)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if target_name is not None:
            pulumi.set(__self__, "target_name", target_name)
        if target_type is not None:
            pulumi.set(__self__, "target_type", target_type)
        if target_uin is not None:
            pulumi.set(__self__, "target_uin", target_uin)
        if update_time is not None:
            pulumi.set(__self__, "update_time", update_time)
        if user_provisioning_id is not None:
            pulumi.set(__self__, "user_provisioning_id", user_provisioning_id)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        Create time.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter(name="deletionStrategy")
    def deletion_strategy(self) -> Optional[pulumi.Input[str]]:
        """
        Deletion policy. It indicates the handling policy for CAM users already synchronized when the CAM user synchronization is deleted. Valid values: Delete: Delete the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted; Keep: Keep the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted.
        """
        return pulumi.get(self, "deletion_strategy")

    @deletion_strategy.setter
    def deletion_strategy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "deletion_strategy", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="duplicationStrategy")
    def duplication_strategy(self) -> Optional[pulumi.Input[str]]:
        """
        Conflict policy. It indicates the handling policy for existence of a user with the same username when CIC users are synchronized to CAM. Valid values: KeepBoth: Keep both, that is, add the _cic suffix to the CIC user's username and then try to create a CAM user with the username when CIC users are synchronized to CAM and a user with the same username already exists in CAM; TakeOver: Replace, that is, directly replace the existing CAM user with the synchronized CIC user when CIC users are synchronized to CAM and a user with the same username already exists in CAM.
        """
        return pulumi.get(self, "duplication_strategy")

    @duplication_strategy.setter
    def duplication_strategy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "duplication_strategy", value)

    @property
    @pulumi.getter(name="principalId")
    def principal_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identity ID for the CAM user synchronization. Valid values:
        When the PrincipalType value is Group, it is the CIC user group ID (g-********).
        When the PrincipalType value is User, it is the CIC user ID (u-********).
        """
        return pulumi.get(self, "principal_id")

    @principal_id.setter
    def principal_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "principal_id", value)

    @property
    @pulumi.getter(name="principalName")
    def principal_name(self) -> Optional[pulumi.Input[str]]:
        """
        The identity name of the CAM user synchronization. Value: When PrincipalType is Group, the value is the CIC user group name; When PrincipalType takes the value to User, the value is the CIC user name.
        """
        return pulumi.get(self, "principal_name")

    @principal_name.setter
    def principal_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "principal_name", value)

    @property
    @pulumi.getter(name="principalType")
    def principal_type(self) -> Optional[pulumi.Input[str]]:
        """
        Identity type for the CAM user synchronization. Valid values:

        User: indicates that the identity for the CAM user synchronization is a CIC user.
        Group: indicates that the identity for the CAM user synchronization is a CIC user group.
        """
        return pulumi.get(self, "principal_type")

    @principal_type.setter
    def principal_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "principal_type", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Status of CAM user synchronization. Value:
        * Enabled: CAM user synchronization is enabled;
        * Disabled: CAM user synchronization is not enabled.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="targetName")
    def target_name(self) -> Optional[pulumi.Input[str]]:
        """
        Group account The name of the target account..
        """
        return pulumi.get(self, "target_name")

    @target_name.setter
    def target_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_name", value)

    @property
    @pulumi.getter(name="targetType")
    def target_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of the synchronized target account of the Tencent Cloud Organization. ManagerUin: admin account; MemberUin: member account.
        """
        return pulumi.get(self, "target_type")

    @target_type.setter
    def target_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "target_type", value)

    @property
    @pulumi.getter(name="targetUin")
    def target_uin(self) -> Optional[pulumi.Input[int]]:
        """
        UIN of the synchronized target account of the Tencent Cloud Organization.
        """
        return pulumi.get(self, "target_uin")

    @target_uin.setter
    def target_uin(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "target_uin", value)

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> Optional[pulumi.Input[str]]:
        """
        Update time.
        """
        return pulumi.get(self, "update_time")

    @update_time.setter
    def update_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "update_time", value)

    @property
    @pulumi.getter(name="userProvisioningId")
    def user_provisioning_id(self) -> Optional[pulumi.Input[str]]:
        """
        User provisioning id.
        """
        return pulumi.get(self, "user_provisioning_id")

    @user_provisioning_id.setter
    def user_provisioning_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "user_provisioning_id", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        Space ID.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)


class CenterUserSyncProvisioning(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 deletion_strategy: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 duplication_strategy: Optional[pulumi.Input[str]] = None,
                 principal_id: Optional[pulumi.Input[str]] = None,
                 principal_type: Optional[pulumi.Input[str]] = None,
                 target_type: Optional[pulumi.Input[str]] = None,
                 target_uin: Optional[pulumi.Input[int]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a organization identity_center_user_sync_provisioning

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        identity_center_user_sync_provisioning = tencentcloud.identity.CenterUserSyncProvisioning("identityCenterUserSyncProvisioning",
            deletion_strategy="Keep",
            description="tf-test",
            duplication_strategy="TakeOver",
            principal_id="u-xxxxxx",
            principal_type="User",
            target_type="MemberUin",
            target_uin="xxxxxx",
            zone_id="z-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization identity_center_user_sync_provisioning can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Identity/centerUserSyncProvisioning:CenterUserSyncProvisioning identity_center_user_sync_provisioning ${zoneId}#${userProvisioningId}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] deletion_strategy: Deletion policy. It indicates the handling policy for CAM users already synchronized when the CAM user synchronization is deleted. Valid values: Delete: Delete the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted; Keep: Keep the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted.
        :param pulumi.Input[str] description: Description.
        :param pulumi.Input[str] duplication_strategy: Conflict policy. It indicates the handling policy for existence of a user with the same username when CIC users are synchronized to CAM. Valid values: KeepBoth: Keep both, that is, add the _cic suffix to the CIC user's username and then try to create a CAM user with the username when CIC users are synchronized to CAM and a user with the same username already exists in CAM; TakeOver: Replace, that is, directly replace the existing CAM user with the synchronized CIC user when CIC users are synchronized to CAM and a user with the same username already exists in CAM.
        :param pulumi.Input[str] principal_id: Identity ID for the CAM user synchronization. Valid values:
               When the PrincipalType value is Group, it is the CIC user group ID (g-********).
               When the PrincipalType value is User, it is the CIC user ID (u-********).
        :param pulumi.Input[str] principal_type: Identity type for the CAM user synchronization. Valid values:
               
               User: indicates that the identity for the CAM user synchronization is a CIC user.
               Group: indicates that the identity for the CAM user synchronization is a CIC user group.
        :param pulumi.Input[str] target_type: Type of the synchronized target account of the Tencent Cloud Organization. ManagerUin: admin account; MemberUin: member account.
        :param pulumi.Input[int] target_uin: UIN of the synchronized target account of the Tencent Cloud Organization.
        :param pulumi.Input[str] zone_id: Space ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CenterUserSyncProvisioningArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a organization identity_center_user_sync_provisioning

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        identity_center_user_sync_provisioning = tencentcloud.identity.CenterUserSyncProvisioning("identityCenterUserSyncProvisioning",
            deletion_strategy="Keep",
            description="tf-test",
            duplication_strategy="TakeOver",
            principal_id="u-xxxxxx",
            principal_type="User",
            target_type="MemberUin",
            target_uin="xxxxxx",
            zone_id="z-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization identity_center_user_sync_provisioning can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Identity/centerUserSyncProvisioning:CenterUserSyncProvisioning identity_center_user_sync_provisioning ${zoneId}#${userProvisioningId}
        ```

        :param str resource_name: The name of the resource.
        :param CenterUserSyncProvisioningArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CenterUserSyncProvisioningArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 deletion_strategy: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 duplication_strategy: Optional[pulumi.Input[str]] = None,
                 principal_id: Optional[pulumi.Input[str]] = None,
                 principal_type: Optional[pulumi.Input[str]] = None,
                 target_type: Optional[pulumi.Input[str]] = None,
                 target_uin: Optional[pulumi.Input[int]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CenterUserSyncProvisioningArgs.__new__(CenterUserSyncProvisioningArgs)

            __props__.__dict__["deletion_strategy"] = deletion_strategy
            __props__.__dict__["description"] = description
            __props__.__dict__["duplication_strategy"] = duplication_strategy
            __props__.__dict__["principal_id"] = principal_id
            __props__.__dict__["principal_type"] = principal_type
            __props__.__dict__["target_type"] = target_type
            __props__.__dict__["target_uin"] = target_uin
            if zone_id is None and not opts.urn:
                raise TypeError("Missing required property 'zone_id'")
            __props__.__dict__["zone_id"] = zone_id
            __props__.__dict__["create_time"] = None
            __props__.__dict__["principal_name"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["target_name"] = None
            __props__.__dict__["update_time"] = None
            __props__.__dict__["user_provisioning_id"] = None
        super(CenterUserSyncProvisioning, __self__).__init__(
            'tencentcloud:Identity/centerUserSyncProvisioning:CenterUserSyncProvisioning',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            deletion_strategy: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            duplication_strategy: Optional[pulumi.Input[str]] = None,
            principal_id: Optional[pulumi.Input[str]] = None,
            principal_name: Optional[pulumi.Input[str]] = None,
            principal_type: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            target_name: Optional[pulumi.Input[str]] = None,
            target_type: Optional[pulumi.Input[str]] = None,
            target_uin: Optional[pulumi.Input[int]] = None,
            update_time: Optional[pulumi.Input[str]] = None,
            user_provisioning_id: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[str]] = None) -> 'CenterUserSyncProvisioning':
        """
        Get an existing CenterUserSyncProvisioning resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] create_time: Create time.
        :param pulumi.Input[str] deletion_strategy: Deletion policy. It indicates the handling policy for CAM users already synchronized when the CAM user synchronization is deleted. Valid values: Delete: Delete the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted; Keep: Keep the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted.
        :param pulumi.Input[str] description: Description.
        :param pulumi.Input[str] duplication_strategy: Conflict policy. It indicates the handling policy for existence of a user with the same username when CIC users are synchronized to CAM. Valid values: KeepBoth: Keep both, that is, add the _cic suffix to the CIC user's username and then try to create a CAM user with the username when CIC users are synchronized to CAM and a user with the same username already exists in CAM; TakeOver: Replace, that is, directly replace the existing CAM user with the synchronized CIC user when CIC users are synchronized to CAM and a user with the same username already exists in CAM.
        :param pulumi.Input[str] principal_id: Identity ID for the CAM user synchronization. Valid values:
               When the PrincipalType value is Group, it is the CIC user group ID (g-********).
               When the PrincipalType value is User, it is the CIC user ID (u-********).
        :param pulumi.Input[str] principal_name: The identity name of the CAM user synchronization. Value: When PrincipalType is Group, the value is the CIC user group name; When PrincipalType takes the value to User, the value is the CIC user name.
        :param pulumi.Input[str] principal_type: Identity type for the CAM user synchronization. Valid values:
               
               User: indicates that the identity for the CAM user synchronization is a CIC user.
               Group: indicates that the identity for the CAM user synchronization is a CIC user group.
        :param pulumi.Input[str] status: Status of CAM user synchronization. Value:
               * Enabled: CAM user synchronization is enabled;
               * Disabled: CAM user synchronization is not enabled.
        :param pulumi.Input[str] target_name: Group account The name of the target account..
        :param pulumi.Input[str] target_type: Type of the synchronized target account of the Tencent Cloud Organization. ManagerUin: admin account; MemberUin: member account.
        :param pulumi.Input[int] target_uin: UIN of the synchronized target account of the Tencent Cloud Organization.
        :param pulumi.Input[str] update_time: Update time.
        :param pulumi.Input[str] user_provisioning_id: User provisioning id.
        :param pulumi.Input[str] zone_id: Space ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CenterUserSyncProvisioningState.__new__(_CenterUserSyncProvisioningState)

        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["deletion_strategy"] = deletion_strategy
        __props__.__dict__["description"] = description
        __props__.__dict__["duplication_strategy"] = duplication_strategy
        __props__.__dict__["principal_id"] = principal_id
        __props__.__dict__["principal_name"] = principal_name
        __props__.__dict__["principal_type"] = principal_type
        __props__.__dict__["status"] = status
        __props__.__dict__["target_name"] = target_name
        __props__.__dict__["target_type"] = target_type
        __props__.__dict__["target_uin"] = target_uin
        __props__.__dict__["update_time"] = update_time
        __props__.__dict__["user_provisioning_id"] = user_provisioning_id
        __props__.__dict__["zone_id"] = zone_id
        return CenterUserSyncProvisioning(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        Create time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="deletionStrategy")
    def deletion_strategy(self) -> pulumi.Output[Optional[str]]:
        """
        Deletion policy. It indicates the handling policy for CAM users already synchronized when the CAM user synchronization is deleted. Valid values: Delete: Delete the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted; Keep: Keep the CAM users already synchronized from CIC to CAM when the CAM user synchronization is deleted.
        """
        return pulumi.get(self, "deletion_strategy")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="duplicationStrategy")
    def duplication_strategy(self) -> pulumi.Output[Optional[str]]:
        """
        Conflict policy. It indicates the handling policy for existence of a user with the same username when CIC users are synchronized to CAM. Valid values: KeepBoth: Keep both, that is, add the _cic suffix to the CIC user's username and then try to create a CAM user with the username when CIC users are synchronized to CAM and a user with the same username already exists in CAM; TakeOver: Replace, that is, directly replace the existing CAM user with the synchronized CIC user when CIC users are synchronized to CAM and a user with the same username already exists in CAM.
        """
        return pulumi.get(self, "duplication_strategy")

    @property
    @pulumi.getter(name="principalId")
    def principal_id(self) -> pulumi.Output[Optional[str]]:
        """
        Identity ID for the CAM user synchronization. Valid values:
        When the PrincipalType value is Group, it is the CIC user group ID (g-********).
        When the PrincipalType value is User, it is the CIC user ID (u-********).
        """
        return pulumi.get(self, "principal_id")

    @property
    @pulumi.getter(name="principalName")
    def principal_name(self) -> pulumi.Output[str]:
        """
        The identity name of the CAM user synchronization. Value: When PrincipalType is Group, the value is the CIC user group name; When PrincipalType takes the value to User, the value is the CIC user name.
        """
        return pulumi.get(self, "principal_name")

    @property
    @pulumi.getter(name="principalType")
    def principal_type(self) -> pulumi.Output[Optional[str]]:
        """
        Identity type for the CAM user synchronization. Valid values:

        User: indicates that the identity for the CAM user synchronization is a CIC user.
        Group: indicates that the identity for the CAM user synchronization is a CIC user group.
        """
        return pulumi.get(self, "principal_type")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Status of CAM user synchronization. Value:
        * Enabled: CAM user synchronization is enabled;
        * Disabled: CAM user synchronization is not enabled.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="targetName")
    def target_name(self) -> pulumi.Output[str]:
        """
        Group account The name of the target account..
        """
        return pulumi.get(self, "target_name")

    @property
    @pulumi.getter(name="targetType")
    def target_type(self) -> pulumi.Output[Optional[str]]:
        """
        Type of the synchronized target account of the Tencent Cloud Organization. ManagerUin: admin account; MemberUin: member account.
        """
        return pulumi.get(self, "target_type")

    @property
    @pulumi.getter(name="targetUin")
    def target_uin(self) -> pulumi.Output[Optional[int]]:
        """
        UIN of the synchronized target account of the Tencent Cloud Organization.
        """
        return pulumi.get(self, "target_uin")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> pulumi.Output[str]:
        """
        Update time.
        """
        return pulumi.get(self, "update_time")

    @property
    @pulumi.getter(name="userProvisioningId")
    def user_provisioning_id(self) -> pulumi.Output[str]:
        """
        User provisioning id.
        """
        return pulumi.get(self, "user_provisioning_id")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[str]:
        """
        Space ID.
        """
        return pulumi.get(self, "zone_id")

