# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetClusterAuthenticationOptionsResult',
    'AwaitableGetClusterAuthenticationOptionsResult',
    'get_cluster_authentication_options',
    'get_cluster_authentication_options_output',
]

@pulumi.output_type
class GetClusterAuthenticationOptionsResult:
    """
    A collection of values returned by getClusterAuthenticationOptions.
    """
    def __init__(__self__, cluster_id=None, id=None, latest_operation_state=None, oidc_configs=None, result_output_file=None, service_accounts=None):
        if cluster_id and not isinstance(cluster_id, str):
            raise TypeError("Expected argument 'cluster_id' to be a str")
        pulumi.set(__self__, "cluster_id", cluster_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if latest_operation_state and not isinstance(latest_operation_state, str):
            raise TypeError("Expected argument 'latest_operation_state' to be a str")
        pulumi.set(__self__, "latest_operation_state", latest_operation_state)
        if oidc_configs and not isinstance(oidc_configs, list):
            raise TypeError("Expected argument 'oidc_configs' to be a list")
        pulumi.set(__self__, "oidc_configs", oidc_configs)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if service_accounts and not isinstance(service_accounts, list):
            raise TypeError("Expected argument 'service_accounts' to be a list")
        pulumi.set(__self__, "service_accounts", service_accounts)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> str:
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="latestOperationState")
    def latest_operation_state(self) -> str:
        """
        Result of the last modification. Values: `Updating`, `Success`, `Failed` or `TimeOut`. Note: this field may return `null`, indicating that no valid values can be obtained.
        """
        return pulumi.get(self, "latest_operation_state")

    @property
    @pulumi.getter(name="oidcConfigs")
    def oidc_configs(self) -> Sequence['outputs.GetClusterAuthenticationOptionsOidcConfigResult']:
        """
        OIDC authentication configurations. Note: This field may return `null`, indicating that no valid value can be obtained.
        """
        return pulumi.get(self, "oidc_configs")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="serviceAccounts")
    def service_accounts(self) -> Sequence['outputs.GetClusterAuthenticationOptionsServiceAccountResult']:
        """
        ServiceAccount authentication configuration. Note: this field may return `null`, indicating that no valid values can be obtained.
        """
        return pulumi.get(self, "service_accounts")


class AwaitableGetClusterAuthenticationOptionsResult(GetClusterAuthenticationOptionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetClusterAuthenticationOptionsResult(
            cluster_id=self.cluster_id,
            id=self.id,
            latest_operation_state=self.latest_operation_state,
            oidc_configs=self.oidc_configs,
            result_output_file=self.result_output_file,
            service_accounts=self.service_accounts)


def get_cluster_authentication_options(cluster_id: Optional[str] = None,
                                       result_output_file: Optional[str] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetClusterAuthenticationOptionsResult:
    """
    Use this data source to query detailed information of kubernetes cluster_authentication_options

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    cluster_authentication_options = tencentcloud.Kubernetes.get_cluster_authentication_options(cluster_id="cls-kzilgv5m")
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: Cluster ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['clusterId'] = cluster_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Kubernetes/getClusterAuthenticationOptions:getClusterAuthenticationOptions', __args__, opts=opts, typ=GetClusterAuthenticationOptionsResult).value

    return AwaitableGetClusterAuthenticationOptionsResult(
        cluster_id=pulumi.get(__ret__, 'cluster_id'),
        id=pulumi.get(__ret__, 'id'),
        latest_operation_state=pulumi.get(__ret__, 'latest_operation_state'),
        oidc_configs=pulumi.get(__ret__, 'oidc_configs'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        service_accounts=pulumi.get(__ret__, 'service_accounts'))


@_utilities.lift_output_func(get_cluster_authentication_options)
def get_cluster_authentication_options_output(cluster_id: Optional[pulumi.Input[str]] = None,
                                              result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetClusterAuthenticationOptionsResult]:
    """
    Use this data source to query detailed information of kubernetes cluster_authentication_options

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    cluster_authentication_options = tencentcloud.Kubernetes.get_cluster_authentication_options(cluster_id="cls-kzilgv5m")
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: Cluster ID.
    :param str result_output_file: Used to save results.
    """
    ...
