# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetClusterNativeNodePoolsResult',
    'AwaitableGetClusterNativeNodePoolsResult',
    'get_cluster_native_node_pools',
    'get_cluster_native_node_pools_output',
]

@pulumi.output_type
class GetClusterNativeNodePoolsResult:
    """
    A collection of values returned by getClusterNativeNodePools.
    """
    def __init__(__self__, cluster_id=None, filters=None, id=None, node_pools=None, result_output_file=None):
        if cluster_id and not isinstance(cluster_id, str):
            raise TypeError("Expected argument 'cluster_id' to be a str")
        pulumi.set(__self__, "cluster_id", cluster_id)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if node_pools and not isinstance(node_pools, list):
            raise TypeError("Expected argument 'node_pools' to be a list")
        pulumi.set(__self__, "node_pools", node_pools)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> str:
        """
        ID of the cluster.
        """
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetClusterNativeNodePoolsFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="nodePools")
    def node_pools(self) -> Sequence['outputs.GetClusterNativeNodePoolsNodePoolResult']:
        """
        Node pool list.
        """
        return pulumi.get(self, "node_pools")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetClusterNativeNodePoolsResult(GetClusterNativeNodePoolsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetClusterNativeNodePoolsResult(
            cluster_id=self.cluster_id,
            filters=self.filters,
            id=self.id,
            node_pools=self.node_pools,
            result_output_file=self.result_output_file)


def get_cluster_native_node_pools(cluster_id: Optional[str] = None,
                                  filters: Optional[Sequence[pulumi.InputType['GetClusterNativeNodePoolsFilterArgs']]] = None,
                                  result_output_file: Optional[str] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetClusterNativeNodePoolsResult:
    """
    Use this data source to query detailed information of tke kubernetes cluster_native_node_pools

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    kubernetes_cluster_native_node_pools = tencentcloud.Kubernetes.get_cluster_native_node_pools(cluster_id="cls-eyi0erm0",
        filters=[
            tencentcloud.kubernetes.GetClusterNativeNodePoolsFilterArgs(
                name="NodePoolsName",
                values=["native_node_pool"],
            ),
            tencentcloud.kubernetes.GetClusterNativeNodePoolsFilterArgs(
                name="NodePoolsId",
                values=["np-ngjwhdv4"],
            ),
        ])
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: ID of the cluster.
    :param Sequence[pulumi.InputType['GetClusterNativeNodePoolsFilterArgs']] filters: Query filter conditions: NodePoolsName, Filter according to the node pool name, type: String, required: no. NodePoolsId, Filter according to the node pool ID, type: String, required: no. tags, Filter according to the label key value pairs, type: String, required: no. tag:tag-key, Filter according to the label key value pairs, type: String, required: no.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['clusterId'] = cluster_id
    __args__['filters'] = filters
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Kubernetes/getClusterNativeNodePools:getClusterNativeNodePools', __args__, opts=opts, typ=GetClusterNativeNodePoolsResult).value

    return AwaitableGetClusterNativeNodePoolsResult(
        cluster_id=pulumi.get(__ret__, 'cluster_id'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        node_pools=pulumi.get(__ret__, 'node_pools'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_cluster_native_node_pools)
def get_cluster_native_node_pools_output(cluster_id: Optional[pulumi.Input[str]] = None,
                                         filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetClusterNativeNodePoolsFilterArgs']]]]] = None,
                                         result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetClusterNativeNodePoolsResult]:
    """
    Use this data source to query detailed information of tke kubernetes cluster_native_node_pools

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    kubernetes_cluster_native_node_pools = tencentcloud.Kubernetes.get_cluster_native_node_pools(cluster_id="cls-eyi0erm0",
        filters=[
            tencentcloud.kubernetes.GetClusterNativeNodePoolsFilterArgs(
                name="NodePoolsName",
                values=["native_node_pool"],
            ),
            tencentcloud.kubernetes.GetClusterNativeNodePoolsFilterArgs(
                name="NodePoolsId",
                values=["np-ngjwhdv4"],
            ),
        ])
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: ID of the cluster.
    :param Sequence[pulumi.InputType['GetClusterNativeNodePoolsFilterArgs']] filters: Query filter conditions: NodePoolsName, Filter according to the node pool name, type: String, required: no. NodePoolsId, Filter according to the node pool ID, type: String, required: no. tags, Filter according to the label key value pairs, type: String, required: no. tag:tag-key, Filter according to the label key value pairs, type: String, required: no.
    :param str result_output_file: Used to save results.
    """
    ...
