# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['BackupTimeArgs', 'BackupTime']

@pulumi.input_type
class BackupTimeArgs:
    def __init__(__self__, *,
                 end_backup_time: pulumi.Input[str],
                 instance_id: pulumi.Input[str],
                 start_backup_time: pulumi.Input[str]):
        """
        The set of arguments for constructing a BackupTime resource.
        :param pulumi.Input[str] end_backup_time: End time of daily backup window in the format of `mm:ss`, such as 23:59.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[str] start_backup_time: Start time of daily backup window in the format of `mm:ss`, such as 22:00.
        """
        pulumi.set(__self__, "end_backup_time", end_backup_time)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "start_backup_time", start_backup_time)

    @property
    @pulumi.getter(name="endBackupTime")
    def end_backup_time(self) -> pulumi.Input[str]:
        """
        End time of daily backup window in the format of `mm:ss`, such as 23:59.
        """
        return pulumi.get(self, "end_backup_time")

    @end_backup_time.setter
    def end_backup_time(self, value: pulumi.Input[str]):
        pulumi.set(self, "end_backup_time", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="startBackupTime")
    def start_backup_time(self) -> pulumi.Input[str]:
        """
        Start time of daily backup window in the format of `mm:ss`, such as 22:00.
        """
        return pulumi.get(self, "start_backup_time")

    @start_backup_time.setter
    def start_backup_time(self, value: pulumi.Input[str]):
        pulumi.set(self, "start_backup_time", value)


@pulumi.input_type
class _BackupTimeState:
    def __init__(__self__, *,
                 end_backup_time: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 start_backup_time: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BackupTime resources.
        :param pulumi.Input[str] end_backup_time: End time of daily backup window in the format of `mm:ss`, such as 23:59.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[str] start_backup_time: Start time of daily backup window in the format of `mm:ss`, such as 22:00.
        """
        if end_backup_time is not None:
            pulumi.set(__self__, "end_backup_time", end_backup_time)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if start_backup_time is not None:
            pulumi.set(__self__, "start_backup_time", start_backup_time)

    @property
    @pulumi.getter(name="endBackupTime")
    def end_backup_time(self) -> Optional[pulumi.Input[str]]:
        """
        End time of daily backup window in the format of `mm:ss`, such as 23:59.
        """
        return pulumi.get(self, "end_backup_time")

    @end_backup_time.setter
    def end_backup_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "end_backup_time", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="startBackupTime")
    def start_backup_time(self) -> Optional[pulumi.Input[str]]:
        """
        Start time of daily backup window in the format of `mm:ss`, such as 22:00.
        """
        return pulumi.get(self, "start_backup_time")

    @start_backup_time.setter
    def start_backup_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "start_backup_time", value)


class BackupTime(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 end_backup_time: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 start_backup_time: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a mariadb backup_time

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        backup_time = tencentcloud.mariadb.BackupTime("backupTime",
            end_backup_time="04:00",
            instance_id="tdsql-9vqvls95",
            start_backup_time="01:00")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        mariadb backup_time can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Mariadb/backupTime:BackupTime backup_time backup_time_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] end_backup_time: End time of daily backup window in the format of `mm:ss`, such as 23:59.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[str] start_backup_time: Start time of daily backup window in the format of `mm:ss`, such as 22:00.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BackupTimeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a mariadb backup_time

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        backup_time = tencentcloud.mariadb.BackupTime("backupTime",
            end_backup_time="04:00",
            instance_id="tdsql-9vqvls95",
            start_backup_time="01:00")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        mariadb backup_time can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Mariadb/backupTime:BackupTime backup_time backup_time_id
        ```

        :param str resource_name: The name of the resource.
        :param BackupTimeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BackupTimeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 end_backup_time: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 start_backup_time: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BackupTimeArgs.__new__(BackupTimeArgs)

            if end_backup_time is None and not opts.urn:
                raise TypeError("Missing required property 'end_backup_time'")
            __props__.__dict__["end_backup_time"] = end_backup_time
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if start_backup_time is None and not opts.urn:
                raise TypeError("Missing required property 'start_backup_time'")
            __props__.__dict__["start_backup_time"] = start_backup_time
        super(BackupTime, __self__).__init__(
            'tencentcloud:Mariadb/backupTime:BackupTime',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            end_backup_time: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            start_backup_time: Optional[pulumi.Input[str]] = None) -> 'BackupTime':
        """
        Get an existing BackupTime resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] end_backup_time: End time of daily backup window in the format of `mm:ss`, such as 23:59.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[str] start_backup_time: Start time of daily backup window in the format of `mm:ss`, such as 22:00.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BackupTimeState.__new__(_BackupTimeState)

        __props__.__dict__["end_backup_time"] = end_backup_time
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["start_backup_time"] = start_backup_time
        return BackupTime(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="endBackupTime")
    def end_backup_time(self) -> pulumi.Output[str]:
        """
        End time of daily backup window in the format of `mm:ss`, such as 23:59.
        """
        return pulumi.get(self, "end_backup_time")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="startBackupTime")
    def start_backup_time(self) -> pulumi.Output[str]:
        """
        Start time of daily backup window in the format of `mm:ss`, such as 22:00.
        """
        return pulumi.get(self, "start_backup_time")

