# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['LogFileRetentionPeriodArgs', 'LogFileRetentionPeriod']

@pulumi.input_type
class LogFileRetentionPeriodArgs:
    def __init__(__self__, *,
                 days: pulumi.Input[int],
                 instance_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a LogFileRetentionPeriod resource.
        :param pulumi.Input[int] days: The number of days to save, cannot exceed 30.
        :param pulumi.Input[str] instance_id: instance id.
        """
        pulumi.set(__self__, "days", days)
        pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter
    def days(self) -> pulumi.Input[int]:
        """
        The number of days to save, cannot exceed 30.
        """
        return pulumi.get(self, "days")

    @days.setter
    def days(self, value: pulumi.Input[int]):
        pulumi.set(self, "days", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)


@pulumi.input_type
class _LogFileRetentionPeriodState:
    def __init__(__self__, *,
                 days: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering LogFileRetentionPeriod resources.
        :param pulumi.Input[int] days: The number of days to save, cannot exceed 30.
        :param pulumi.Input[str] instance_id: instance id.
        """
        if days is not None:
            pulumi.set(__self__, "days", days)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter
    def days(self) -> Optional[pulumi.Input[int]]:
        """
        The number of days to save, cannot exceed 30.
        """
        return pulumi.get(self, "days")

    @days.setter
    def days(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "days", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)


class LogFileRetentionPeriod(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 days: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a mariadb log_file_retention_period

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        log_file_retention_period = tencentcloud.mariadb.LogFileRetentionPeriod("logFileRetentionPeriod",
            days=8,
            instance_id="tdsql-4pzs5b67")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        mariadb log_file_retention_period can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Mariadb/logFileRetentionPeriod:LogFileRetentionPeriod log_file_retention_period tdsql-4pzs5b67
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] days: The number of days to save, cannot exceed 30.
        :param pulumi.Input[str] instance_id: instance id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: LogFileRetentionPeriodArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a mariadb log_file_retention_period

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        log_file_retention_period = tencentcloud.mariadb.LogFileRetentionPeriod("logFileRetentionPeriod",
            days=8,
            instance_id="tdsql-4pzs5b67")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        mariadb log_file_retention_period can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Mariadb/logFileRetentionPeriod:LogFileRetentionPeriod log_file_retention_period tdsql-4pzs5b67
        ```

        :param str resource_name: The name of the resource.
        :param LogFileRetentionPeriodArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(LogFileRetentionPeriodArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 days: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = LogFileRetentionPeriodArgs.__new__(LogFileRetentionPeriodArgs)

            if days is None and not opts.urn:
                raise TypeError("Missing required property 'days'")
            __props__.__dict__["days"] = days
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
        super(LogFileRetentionPeriod, __self__).__init__(
            'tencentcloud:Mariadb/logFileRetentionPeriod:LogFileRetentionPeriod',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            days: Optional[pulumi.Input[int]] = None,
            instance_id: Optional[pulumi.Input[str]] = None) -> 'LogFileRetentionPeriod':
        """
        Get an existing LogFileRetentionPeriod resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] days: The number of days to save, cannot exceed 30.
        :param pulumi.Input[str] instance_id: instance id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _LogFileRetentionPeriodState.__new__(_LogFileRetentionPeriodState)

        __props__.__dict__["days"] = days
        __props__.__dict__["instance_id"] = instance_id
        return LogFileRetentionPeriod(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def days(self) -> pulumi.Output[int]:
        """
        The number of days to save, cannot exceed 30.
        """
        return pulumi.get(self, "days")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

