# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['GrafanaSsoCamConfigArgs', 'GrafanaSsoCamConfig']

@pulumi.input_type
class GrafanaSsoCamConfigArgs:
    def __init__(__self__, *,
                 enable_sso_cam_check: pulumi.Input[bool],
                 instance_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a GrafanaSsoCamConfig resource.
        :param pulumi.Input[bool] enable_sso_cam_check: Whether to enable the CAM authorization: `true` for enabling; `false` for disabling.
        :param pulumi.Input[str] instance_id: Grafana instance ID.
        """
        pulumi.set(__self__, "enable_sso_cam_check", enable_sso_cam_check)
        pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="enableSsoCamCheck")
    def enable_sso_cam_check(self) -> pulumi.Input[bool]:
        """
        Whether to enable the CAM authorization: `true` for enabling; `false` for disabling.
        """
        return pulumi.get(self, "enable_sso_cam_check")

    @enable_sso_cam_check.setter
    def enable_sso_cam_check(self, value: pulumi.Input[bool]):
        pulumi.set(self, "enable_sso_cam_check", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)


@pulumi.input_type
class _GrafanaSsoCamConfigState:
    def __init__(__self__, *,
                 enable_sso_cam_check: Optional[pulumi.Input[bool]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering GrafanaSsoCamConfig resources.
        :param pulumi.Input[bool] enable_sso_cam_check: Whether to enable the CAM authorization: `true` for enabling; `false` for disabling.
        :param pulumi.Input[str] instance_id: Grafana instance ID.
        """
        if enable_sso_cam_check is not None:
            pulumi.set(__self__, "enable_sso_cam_check", enable_sso_cam_check)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="enableSsoCamCheck")
    def enable_sso_cam_check(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable the CAM authorization: `true` for enabling; `false` for disabling.
        """
        return pulumi.get(self, "enable_sso_cam_check")

    @enable_sso_cam_check.setter
    def enable_sso_cam_check(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_sso_cam_check", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)


class GrafanaSsoCamConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enable_sso_cam_check: Optional[pulumi.Input[bool]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a monitor grafana_sso_cam_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        grafana_sso_cam_config = tencentcloud.monitor.GrafanaSsoCamConfig("grafanaSsoCamConfig",
            enable_sso_cam_check=False,
            instance_id="grafana-dp2hnnfa")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        monitor grafana_sso_cam_config can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Monitor/grafanaSsoCamConfig:GrafanaSsoCamConfig grafana_sso_cam_config instance_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enable_sso_cam_check: Whether to enable the CAM authorization: `true` for enabling; `false` for disabling.
        :param pulumi.Input[str] instance_id: Grafana instance ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GrafanaSsoCamConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a monitor grafana_sso_cam_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        grafana_sso_cam_config = tencentcloud.monitor.GrafanaSsoCamConfig("grafanaSsoCamConfig",
            enable_sso_cam_check=False,
            instance_id="grafana-dp2hnnfa")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        monitor grafana_sso_cam_config can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Monitor/grafanaSsoCamConfig:GrafanaSsoCamConfig grafana_sso_cam_config instance_id
        ```

        :param str resource_name: The name of the resource.
        :param GrafanaSsoCamConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GrafanaSsoCamConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enable_sso_cam_check: Optional[pulumi.Input[bool]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GrafanaSsoCamConfigArgs.__new__(GrafanaSsoCamConfigArgs)

            if enable_sso_cam_check is None and not opts.urn:
                raise TypeError("Missing required property 'enable_sso_cam_check'")
            __props__.__dict__["enable_sso_cam_check"] = enable_sso_cam_check
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
        super(GrafanaSsoCamConfig, __self__).__init__(
            'tencentcloud:Monitor/grafanaSsoCamConfig:GrafanaSsoCamConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            enable_sso_cam_check: Optional[pulumi.Input[bool]] = None,
            instance_id: Optional[pulumi.Input[str]] = None) -> 'GrafanaSsoCamConfig':
        """
        Get an existing GrafanaSsoCamConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] enable_sso_cam_check: Whether to enable the CAM authorization: `true` for enabling; `false` for disabling.
        :param pulumi.Input[str] instance_id: Grafana instance ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GrafanaSsoCamConfigState.__new__(_GrafanaSsoCamConfigState)

        __props__.__dict__["enable_sso_cam_check"] = enable_sso_cam_check
        __props__.__dict__["instance_id"] = instance_id
        return GrafanaSsoCamConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="enableSsoCamCheck")
    def enable_sso_cam_check(self) -> pulumi.Output[bool]:
        """
        Whether to enable the CAM authorization: `true` for enabling; `false` for disabling.
        """
        return pulumi.get(self, "enable_sso_cam_check")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "instance_id")

