# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['GrafanaVersionUpgradeArgs', 'GrafanaVersionUpgrade']

@pulumi.input_type
class GrafanaVersionUpgradeArgs:
    def __init__(__self__, *,
                 alias: pulumi.Input[str],
                 instance_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a GrafanaVersionUpgrade resource.
        :param pulumi.Input[str] alias: Version alias.
        :param pulumi.Input[str] instance_id: Grafana instance ID.
        """
        pulumi.set(__self__, "alias", alias)
        pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter
    def alias(self) -> pulumi.Input[str]:
        """
        Version alias.
        """
        return pulumi.get(self, "alias")

    @alias.setter
    def alias(self, value: pulumi.Input[str]):
        pulumi.set(self, "alias", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)


@pulumi.input_type
class _GrafanaVersionUpgradeState:
    def __init__(__self__, *,
                 alias: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering GrafanaVersionUpgrade resources.
        :param pulumi.Input[str] alias: Version alias.
        :param pulumi.Input[str] instance_id: Grafana instance ID.
        """
        if alias is not None:
            pulumi.set(__self__, "alias", alias)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter
    def alias(self) -> Optional[pulumi.Input[str]]:
        """
        Version alias.
        """
        return pulumi.get(self, "alias")

    @alias.setter
    def alias(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "alias", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)


class GrafanaVersionUpgrade(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 alias: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a monitor grafana_version_upgrade

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        grafana_version_upgrade = tencentcloud.monitor.GrafanaVersionUpgrade("grafanaVersionUpgrade",
            alias="v8.2.7",
            instance_id="grafana-dp2hnnfa")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        monitor grafana_version_upgrade can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Monitor/grafanaVersionUpgrade:GrafanaVersionUpgrade grafana_version_upgrade instance_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] alias: Version alias.
        :param pulumi.Input[str] instance_id: Grafana instance ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: GrafanaVersionUpgradeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a monitor grafana_version_upgrade

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        grafana_version_upgrade = tencentcloud.monitor.GrafanaVersionUpgrade("grafanaVersionUpgrade",
            alias="v8.2.7",
            instance_id="grafana-dp2hnnfa")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        monitor grafana_version_upgrade can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Monitor/grafanaVersionUpgrade:GrafanaVersionUpgrade grafana_version_upgrade instance_id
        ```

        :param str resource_name: The name of the resource.
        :param GrafanaVersionUpgradeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(GrafanaVersionUpgradeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 alias: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = GrafanaVersionUpgradeArgs.__new__(GrafanaVersionUpgradeArgs)

            if alias is None and not opts.urn:
                raise TypeError("Missing required property 'alias'")
            __props__.__dict__["alias"] = alias
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
        super(GrafanaVersionUpgrade, __self__).__init__(
            'tencentcloud:Monitor/grafanaVersionUpgrade:GrafanaVersionUpgrade',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            alias: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None) -> 'GrafanaVersionUpgrade':
        """
        Get an existing GrafanaVersionUpgrade resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] alias: Version alias.
        :param pulumi.Input[str] instance_id: Grafana instance ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _GrafanaVersionUpgradeState.__new__(_GrafanaVersionUpgradeState)

        __props__.__dict__["alias"] = alias
        __props__.__dict__["instance_id"] = instance_id
        return GrafanaVersionUpgrade(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def alias(self) -> pulumi.Output[str]:
        """
        Version alias.
        """
        return pulumi.get(self, "alias")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "instance_id")

