# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['CloneDbInstanceArgs', 'CloneDbInstance']

@pulumi.input_type
class CloneDbInstanceArgs:
    def __init__(__self__, *,
                 auto_renew_flag: pulumi.Input[int],
                 db_instance_id: pulumi.Input[str],
                 period: pulumi.Input[int],
                 spec_code: pulumi.Input[str],
                 storage: pulumi.Input[int],
                 subnet_id: pulumi.Input[str],
                 vpc_id: pulumi.Input[str],
                 activity_id: Optional[pulumi.Input[int]] = None,
                 backup_set_id: Optional[pulumi.Input[str]] = None,
                 db_node_sets: Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceDbNodeSetArgs']]]] = None,
                 instance_charge_type: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 recovery_target_time: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 sync_mode: Optional[pulumi.Input[str]] = None,
                 tag_lists: Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceTagListArgs']]]] = None):
        """
        The set of arguments for constructing a CloneDbInstance resource.
        :param pulumi.Input[int] auto_renew_flag: Renewal Flag:
        :param pulumi.Input[str] db_instance_id: ID of the original instance to be cloned.
        :param pulumi.Input[int] period: Purchase duration, in months.
               - Prepaid: Supports `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `24`, and `36`.
               - Pay-as-you-go: Only supports `1`.
        :param pulumi.Input[str] spec_code: Purchasable code, which can be obtained from the `SpecCode` field in the return value of the [DescribeClasses](https://intl.cloud.tencent.com/document/api/409/89019?from_cn_redirect=1) API.
        :param pulumi.Input[int] storage: Instance storage capacity in GB.
        :param pulumi.Input[str] subnet_id: VPC subnet ID in the format of `subnet-xxxxxxxx`, which can be obtained in the console or from the `unSubnetId` field in the return value of the [DescribeSubnets](https://intl.cloud.tencent.com/document/api/215/15784?from_cn_redirect=1) API.
        :param pulumi.Input[str] vpc_id: VPC ID in the format of `vpc-xxxxxxx`, which can be obtained in the console or from the `unVpcId` field in the return value of the [DescribeVpcEx](https://intl.cloud.tencent.com/document/api/215/1372?from_cn_redirect=1) API.
        :param pulumi.Input[int] activity_id: Campaign ID.
        :param pulumi.Input[str] backup_set_id: Basic backup set ID.
        :param pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceDbNodeSetArgs']]] db_node_sets: Deployment information of the instance node, which will display the information of each AZ when the instance node is deployed across multiple AZs.
               The information of AZ can be obtained from the `Zone` field in the return value of the [DescribeZones](https://intl.cloud.tencent.com/document/api/409/16769?from_cn_redirect=1) API.
        :param pulumi.Input[str] instance_charge_type: Instance billing type, which currently supports:
               
               - PREPAID: Prepaid, i.e., monthly subscription
               - POSTPAID_BY_HOUR: Pay-as-you-go, i.e., pay by consumption
               
               Default value: PREPAID.
        :param pulumi.Input[str] name: Name of the newly purchased instance, which can contain up to 60 letters, digits, or symbols (-_). If this parameter is not specified, "Unnamed" will be displayed by default.
        :param pulumi.Input[int] project_id: Project ID.
        :param pulumi.Input[str] recovery_target_time: Restoration point in time.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: Security group of the instance, which can be obtained from the `sgld` field in the return value of the [DescribeSecurityGroups](https://intl.cloud.tencent.com/document/api/215/15808?from_cn_redirect=1) API. If this parameter is not specified, the default security group will be bound.
        :param pulumi.Input[str] sync_mode: Primary-standby sync mode, which supports:
               Semi-sync: Semi-sync
               Async: Asynchronous
               Default value for the primary instance: Semi-sync
               Default value for the read-only instance: Async.
        :param pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceTagListArgs']]] tag_lists: The information of tags to be bound with the instance, which is left empty by default. This parameter can be obtained from the `Tags` field in the return value of the [DescribeTags](https://intl.cloud.tencent.com/document/api/651/35316?from_cn_redirect=1) API.
        """
        pulumi.set(__self__, "auto_renew_flag", auto_renew_flag)
        pulumi.set(__self__, "db_instance_id", db_instance_id)
        pulumi.set(__self__, "period", period)
        pulumi.set(__self__, "spec_code", spec_code)
        pulumi.set(__self__, "storage", storage)
        pulumi.set(__self__, "subnet_id", subnet_id)
        pulumi.set(__self__, "vpc_id", vpc_id)
        if activity_id is not None:
            pulumi.set(__self__, "activity_id", activity_id)
        if backup_set_id is not None:
            pulumi.set(__self__, "backup_set_id", backup_set_id)
        if db_node_sets is not None:
            pulumi.set(__self__, "db_node_sets", db_node_sets)
        if instance_charge_type is not None:
            pulumi.set(__self__, "instance_charge_type", instance_charge_type)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if recovery_target_time is not None:
            pulumi.set(__self__, "recovery_target_time", recovery_target_time)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if sync_mode is not None:
            pulumi.set(__self__, "sync_mode", sync_mode)
        if tag_lists is not None:
            pulumi.set(__self__, "tag_lists", tag_lists)

    @property
    @pulumi.getter(name="autoRenewFlag")
    def auto_renew_flag(self) -> pulumi.Input[int]:
        """
        Renewal Flag:
        """
        return pulumi.get(self, "auto_renew_flag")

    @auto_renew_flag.setter
    def auto_renew_flag(self, value: pulumi.Input[int]):
        pulumi.set(self, "auto_renew_flag", value)

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> pulumi.Input[str]:
        """
        ID of the original instance to be cloned.
        """
        return pulumi.get(self, "db_instance_id")

    @db_instance_id.setter
    def db_instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "db_instance_id", value)

    @property
    @pulumi.getter
    def period(self) -> pulumi.Input[int]:
        """
        Purchase duration, in months.
        - Prepaid: Supports `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `24`, and `36`.
        - Pay-as-you-go: Only supports `1`.
        """
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: pulumi.Input[int]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="specCode")
    def spec_code(self) -> pulumi.Input[str]:
        """
        Purchasable code, which can be obtained from the `SpecCode` field in the return value of the [DescribeClasses](https://intl.cloud.tencent.com/document/api/409/89019?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "spec_code")

    @spec_code.setter
    def spec_code(self, value: pulumi.Input[str]):
        pulumi.set(self, "spec_code", value)

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Input[int]:
        """
        Instance storage capacity in GB.
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: pulumi.Input[int]):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Input[str]:
        """
        VPC subnet ID in the format of `subnet-xxxxxxxx`, which can be obtained in the console or from the `unSubnetId` field in the return value of the [DescribeSubnets](https://intl.cloud.tencent.com/document/api/215/15784?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Input[str]:
        """
        VPC ID in the format of `vpc-xxxxxxx`, which can be obtained in the console or from the `unVpcId` field in the return value of the [DescribeVpcEx](https://intl.cloud.tencent.com/document/api/215/1372?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "vpc_id", value)

    @property
    @pulumi.getter(name="activityId")
    def activity_id(self) -> Optional[pulumi.Input[int]]:
        """
        Campaign ID.
        """
        return pulumi.get(self, "activity_id")

    @activity_id.setter
    def activity_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "activity_id", value)

    @property
    @pulumi.getter(name="backupSetId")
    def backup_set_id(self) -> Optional[pulumi.Input[str]]:
        """
        Basic backup set ID.
        """
        return pulumi.get(self, "backup_set_id")

    @backup_set_id.setter
    def backup_set_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "backup_set_id", value)

    @property
    @pulumi.getter(name="dbNodeSets")
    def db_node_sets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceDbNodeSetArgs']]]]:
        """
        Deployment information of the instance node, which will display the information of each AZ when the instance node is deployed across multiple AZs.
        The information of AZ can be obtained from the `Zone` field in the return value of the [DescribeZones](https://intl.cloud.tencent.com/document/api/409/16769?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "db_node_sets")

    @db_node_sets.setter
    def db_node_sets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceDbNodeSetArgs']]]]):
        pulumi.set(self, "db_node_sets", value)

    @property
    @pulumi.getter(name="instanceChargeType")
    def instance_charge_type(self) -> Optional[pulumi.Input[str]]:
        """
        Instance billing type, which currently supports:

        - PREPAID: Prepaid, i.e., monthly subscription
        - POSTPAID_BY_HOUR: Pay-as-you-go, i.e., pay by consumption

        Default value: PREPAID.
        """
        return pulumi.get(self, "instance_charge_type")

    @instance_charge_type.setter
    def instance_charge_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_charge_type", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the newly purchased instance, which can contain up to 60 letters, digits, or symbols (-_). If this parameter is not specified, "Unnamed" will be displayed by default.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[int]]:
        """
        Project ID.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="recoveryTargetTime")
    def recovery_target_time(self) -> Optional[pulumi.Input[str]]:
        """
        Restoration point in time.
        """
        return pulumi.get(self, "recovery_target_time")

    @recovery_target_time.setter
    def recovery_target_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "recovery_target_time", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Security group of the instance, which can be obtained from the `sgld` field in the return value of the [DescribeSecurityGroups](https://intl.cloud.tencent.com/document/api/215/15808?from_cn_redirect=1) API. If this parameter is not specified, the default security group will be bound.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="syncMode")
    def sync_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Primary-standby sync mode, which supports:
        Semi-sync: Semi-sync
        Async: Asynchronous
        Default value for the primary instance: Semi-sync
        Default value for the read-only instance: Async.
        """
        return pulumi.get(self, "sync_mode")

    @sync_mode.setter
    def sync_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sync_mode", value)

    @property
    @pulumi.getter(name="tagLists")
    def tag_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceTagListArgs']]]]:
        """
        The information of tags to be bound with the instance, which is left empty by default. This parameter can be obtained from the `Tags` field in the return value of the [DescribeTags](https://intl.cloud.tencent.com/document/api/651/35316?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "tag_lists")

    @tag_lists.setter
    def tag_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceTagListArgs']]]]):
        pulumi.set(self, "tag_lists", value)


@pulumi.input_type
class _CloneDbInstanceState:
    def __init__(__self__, *,
                 activity_id: Optional[pulumi.Input[int]] = None,
                 auto_renew_flag: Optional[pulumi.Input[int]] = None,
                 backup_set_id: Optional[pulumi.Input[str]] = None,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 db_node_sets: Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceDbNodeSetArgs']]]] = None,
                 instance_charge_type: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 recovery_target_time: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 spec_code: Optional[pulumi.Input[str]] = None,
                 storage: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 sync_mode: Optional[pulumi.Input[str]] = None,
                 tag_lists: Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceTagListArgs']]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CloneDbInstance resources.
        :param pulumi.Input[int] activity_id: Campaign ID.
        :param pulumi.Input[int] auto_renew_flag: Renewal Flag:
        :param pulumi.Input[str] backup_set_id: Basic backup set ID.
        :param pulumi.Input[str] db_instance_id: ID of the original instance to be cloned.
        :param pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceDbNodeSetArgs']]] db_node_sets: Deployment information of the instance node, which will display the information of each AZ when the instance node is deployed across multiple AZs.
               The information of AZ can be obtained from the `Zone` field in the return value of the [DescribeZones](https://intl.cloud.tencent.com/document/api/409/16769?from_cn_redirect=1) API.
        :param pulumi.Input[str] instance_charge_type: Instance billing type, which currently supports:
               
               - PREPAID: Prepaid, i.e., monthly subscription
               - POSTPAID_BY_HOUR: Pay-as-you-go, i.e., pay by consumption
               
               Default value: PREPAID.
        :param pulumi.Input[str] name: Name of the newly purchased instance, which can contain up to 60 letters, digits, or symbols (-_). If this parameter is not specified, "Unnamed" will be displayed by default.
        :param pulumi.Input[int] period: Purchase duration, in months.
               - Prepaid: Supports `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `24`, and `36`.
               - Pay-as-you-go: Only supports `1`.
        :param pulumi.Input[int] project_id: Project ID.
        :param pulumi.Input[str] recovery_target_time: Restoration point in time.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: Security group of the instance, which can be obtained from the `sgld` field in the return value of the [DescribeSecurityGroups](https://intl.cloud.tencent.com/document/api/215/15808?from_cn_redirect=1) API. If this parameter is not specified, the default security group will be bound.
        :param pulumi.Input[str] spec_code: Purchasable code, which can be obtained from the `SpecCode` field in the return value of the [DescribeClasses](https://intl.cloud.tencent.com/document/api/409/89019?from_cn_redirect=1) API.
        :param pulumi.Input[int] storage: Instance storage capacity in GB.
        :param pulumi.Input[str] subnet_id: VPC subnet ID in the format of `subnet-xxxxxxxx`, which can be obtained in the console or from the `unSubnetId` field in the return value of the [DescribeSubnets](https://intl.cloud.tencent.com/document/api/215/15784?from_cn_redirect=1) API.
        :param pulumi.Input[str] sync_mode: Primary-standby sync mode, which supports:
               Semi-sync: Semi-sync
               Async: Asynchronous
               Default value for the primary instance: Semi-sync
               Default value for the read-only instance: Async.
        :param pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceTagListArgs']]] tag_lists: The information of tags to be bound with the instance, which is left empty by default. This parameter can be obtained from the `Tags` field in the return value of the [DescribeTags](https://intl.cloud.tencent.com/document/api/651/35316?from_cn_redirect=1) API.
        :param pulumi.Input[str] vpc_id: VPC ID in the format of `vpc-xxxxxxx`, which can be obtained in the console or from the `unVpcId` field in the return value of the [DescribeVpcEx](https://intl.cloud.tencent.com/document/api/215/1372?from_cn_redirect=1) API.
        """
        if activity_id is not None:
            pulumi.set(__self__, "activity_id", activity_id)
        if auto_renew_flag is not None:
            pulumi.set(__self__, "auto_renew_flag", auto_renew_flag)
        if backup_set_id is not None:
            pulumi.set(__self__, "backup_set_id", backup_set_id)
        if db_instance_id is not None:
            pulumi.set(__self__, "db_instance_id", db_instance_id)
        if db_node_sets is not None:
            pulumi.set(__self__, "db_node_sets", db_node_sets)
        if instance_charge_type is not None:
            pulumi.set(__self__, "instance_charge_type", instance_charge_type)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if period is not None:
            pulumi.set(__self__, "period", period)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)
        if recovery_target_time is not None:
            pulumi.set(__self__, "recovery_target_time", recovery_target_time)
        if security_group_ids is not None:
            pulumi.set(__self__, "security_group_ids", security_group_ids)
        if spec_code is not None:
            pulumi.set(__self__, "spec_code", spec_code)
        if storage is not None:
            pulumi.set(__self__, "storage", storage)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)
        if sync_mode is not None:
            pulumi.set(__self__, "sync_mode", sync_mode)
        if tag_lists is not None:
            pulumi.set(__self__, "tag_lists", tag_lists)
        if vpc_id is not None:
            pulumi.set(__self__, "vpc_id", vpc_id)

    @property
    @pulumi.getter(name="activityId")
    def activity_id(self) -> Optional[pulumi.Input[int]]:
        """
        Campaign ID.
        """
        return pulumi.get(self, "activity_id")

    @activity_id.setter
    def activity_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "activity_id", value)

    @property
    @pulumi.getter(name="autoRenewFlag")
    def auto_renew_flag(self) -> Optional[pulumi.Input[int]]:
        """
        Renewal Flag:
        """
        return pulumi.get(self, "auto_renew_flag")

    @auto_renew_flag.setter
    def auto_renew_flag(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "auto_renew_flag", value)

    @property
    @pulumi.getter(name="backupSetId")
    def backup_set_id(self) -> Optional[pulumi.Input[str]]:
        """
        Basic backup set ID.
        """
        return pulumi.get(self, "backup_set_id")

    @backup_set_id.setter
    def backup_set_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "backup_set_id", value)

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the original instance to be cloned.
        """
        return pulumi.get(self, "db_instance_id")

    @db_instance_id.setter
    def db_instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "db_instance_id", value)

    @property
    @pulumi.getter(name="dbNodeSets")
    def db_node_sets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceDbNodeSetArgs']]]]:
        """
        Deployment information of the instance node, which will display the information of each AZ when the instance node is deployed across multiple AZs.
        The information of AZ can be obtained from the `Zone` field in the return value of the [DescribeZones](https://intl.cloud.tencent.com/document/api/409/16769?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "db_node_sets")

    @db_node_sets.setter
    def db_node_sets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceDbNodeSetArgs']]]]):
        pulumi.set(self, "db_node_sets", value)

    @property
    @pulumi.getter(name="instanceChargeType")
    def instance_charge_type(self) -> Optional[pulumi.Input[str]]:
        """
        Instance billing type, which currently supports:

        - PREPAID: Prepaid, i.e., monthly subscription
        - POSTPAID_BY_HOUR: Pay-as-you-go, i.e., pay by consumption

        Default value: PREPAID.
        """
        return pulumi.get(self, "instance_charge_type")

    @instance_charge_type.setter
    def instance_charge_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_charge_type", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the newly purchased instance, which can contain up to 60 letters, digits, or symbols (-_). If this parameter is not specified, "Unnamed" will be displayed by default.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def period(self) -> Optional[pulumi.Input[int]]:
        """
        Purchase duration, in months.
        - Prepaid: Supports `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `24`, and `36`.
        - Pay-as-you-go: Only supports `1`.
        """
        return pulumi.get(self, "period")

    @period.setter
    def period(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "period", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[int]]:
        """
        Project ID.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "project_id", value)

    @property
    @pulumi.getter(name="recoveryTargetTime")
    def recovery_target_time(self) -> Optional[pulumi.Input[str]]:
        """
        Restoration point in time.
        """
        return pulumi.get(self, "recovery_target_time")

    @recovery_target_time.setter
    def recovery_target_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "recovery_target_time", value)

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Security group of the instance, which can be obtained from the `sgld` field in the return value of the [DescribeSecurityGroups](https://intl.cloud.tencent.com/document/api/215/15808?from_cn_redirect=1) API. If this parameter is not specified, the default security group will be bound.
        """
        return pulumi.get(self, "security_group_ids")

    @security_group_ids.setter
    def security_group_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "security_group_ids", value)

    @property
    @pulumi.getter(name="specCode")
    def spec_code(self) -> Optional[pulumi.Input[str]]:
        """
        Purchasable code, which can be obtained from the `SpecCode` field in the return value of the [DescribeClasses](https://intl.cloud.tencent.com/document/api/409/89019?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "spec_code")

    @spec_code.setter
    def spec_code(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "spec_code", value)

    @property
    @pulumi.getter
    def storage(self) -> Optional[pulumi.Input[int]]:
        """
        Instance storage capacity in GB.
        """
        return pulumi.get(self, "storage")

    @storage.setter
    def storage(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "storage", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        VPC subnet ID in the format of `subnet-xxxxxxxx`, which can be obtained in the console or from the `unSubnetId` field in the return value of the [DescribeSubnets](https://intl.cloud.tencent.com/document/api/215/15784?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter(name="syncMode")
    def sync_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Primary-standby sync mode, which supports:
        Semi-sync: Semi-sync
        Async: Asynchronous
        Default value for the primary instance: Semi-sync
        Default value for the read-only instance: Async.
        """
        return pulumi.get(self, "sync_mode")

    @sync_mode.setter
    def sync_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sync_mode", value)

    @property
    @pulumi.getter(name="tagLists")
    def tag_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceTagListArgs']]]]:
        """
        The information of tags to be bound with the instance, which is left empty by default. This parameter can be obtained from the `Tags` field in the return value of the [DescribeTags](https://intl.cloud.tencent.com/document/api/651/35316?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "tag_lists")

    @tag_lists.setter
    def tag_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['CloneDbInstanceTagListArgs']]]]):
        pulumi.set(self, "tag_lists", value)

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> Optional[pulumi.Input[str]]:
        """
        VPC ID in the format of `vpc-xxxxxxx`, which can be obtained in the console or from the `unVpcId` field in the return value of the [DescribeVpcEx](https://intl.cloud.tencent.com/document/api/215/1372?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "vpc_id")

    @vpc_id.setter
    def vpc_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_id", value)


class CloneDbInstance(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 activity_id: Optional[pulumi.Input[int]] = None,
                 auto_renew_flag: Optional[pulumi.Input[int]] = None,
                 backup_set_id: Optional[pulumi.Input[str]] = None,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 db_node_sets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceDbNodeSetArgs']]]]] = None,
                 instance_charge_type: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 recovery_target_time: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 spec_code: Optional[pulumi.Input[str]] = None,
                 storage: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 sync_mode: Optional[pulumi.Input[str]] = None,
                 tag_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceTagListArgs']]]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a postgresql clone db instance

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.postgresql.CloneDbInstance("example",
            auto_renew_flag=0,
            db_instance_id="postgres-evsqpyap",
            db_node_sets=[
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    role="Primary",
                    zone="ap-guangzhou-6",
                ),
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    role="Standby",
                    zone="ap-guangzhou-6",
                ),
            ],
            instance_charge_type="POSTPAID_BY_HOUR",
            period=1,
            project_id=0,
            recovery_target_time="2024-10-12 18:17:00",
            security_group_ids=["sg-8stavs03"],
            spec_code="pg.it.medium4",
            storage=200,
            subnet_id="subnet-b8hintyy",
            tag_lists=[tencentcloud.postgresql.CloneDbInstanceTagListArgs(
                tag_key="createBy",
                tag_value="terraform",
            )],
            vpc_id="vpc-a6zec4mf")
        ```
        <!--End PulumiCodeChooser -->

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        base_backups = tencentcloud.Postgresql.get_base_backups(filters=[tencentcloud.postgresql.GetBaseBackupsFilterArgs(
                name="db-instance-id",
                values=["postgres-evsqpyap"],
            )],
            order_by="Size",
            order_by_type="asc")
        example = tencentcloud.postgresql.CloneDbInstance("example",
            db_instance_id="postgres-evsqpyap",
            spec_code="pg.it.medium4",
            storage=200,
            period=1,
            auto_renew_flag=0,
            vpc_id="vpc-a6zec4mf",
            subnet_id="subnet-b8hintyy",
            instance_charge_type="POSTPAID_BY_HOUR",
            security_group_ids=["sg-8stavs03"],
            project_id=0,
            backup_set_id=base_backups.base_backup_sets[0].id,
            db_node_sets=[
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    role="Primary",
                    zone="ap-guangzhou-6",
                ),
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    role="Standby",
                    zone="ap-guangzhou-6",
                ),
            ],
            tag_lists=[tencentcloud.postgresql.CloneDbInstanceTagListArgs(
                tag_key="createBy",
                tag_value="terraform",
            )])
        ```
        <!--End PulumiCodeChooser -->

        ### Clone db instance from CDC

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.postgresql.CloneDbInstance("example",
            auto_renew_flag=0,
            db_instance_id="postgres-evsqpyap",
            db_node_sets=[
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    dedicated_cluster_id="cluster-262n63e8",
                    role="Primary",
                    zone="ap-guangzhou-6",
                ),
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    dedicated_cluster_id="cluster-262n63e8",
                    role="Standby",
                    zone="ap-guangzhou-6",
                ),
            ],
            instance_charge_type="POSTPAID_BY_HOUR",
            period=1,
            project_id=0,
            recovery_target_time="2024-10-12 18:17:00",
            security_group_ids=["sg-8stavs03"],
            spec_code="pg.it.medium4",
            storage=200,
            subnet_id="subnet-b8hintyy",
            tag_lists=[tencentcloud.postgresql.CloneDbInstanceTagListArgs(
                tag_key="createBy",
                tag_value="terraform",
            )],
            vpc_id="vpc-a6zec4mf")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] activity_id: Campaign ID.
        :param pulumi.Input[int] auto_renew_flag: Renewal Flag:
        :param pulumi.Input[str] backup_set_id: Basic backup set ID.
        :param pulumi.Input[str] db_instance_id: ID of the original instance to be cloned.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceDbNodeSetArgs']]]] db_node_sets: Deployment information of the instance node, which will display the information of each AZ when the instance node is deployed across multiple AZs.
               The information of AZ can be obtained from the `Zone` field in the return value of the [DescribeZones](https://intl.cloud.tencent.com/document/api/409/16769?from_cn_redirect=1) API.
        :param pulumi.Input[str] instance_charge_type: Instance billing type, which currently supports:
               
               - PREPAID: Prepaid, i.e., monthly subscription
               - POSTPAID_BY_HOUR: Pay-as-you-go, i.e., pay by consumption
               
               Default value: PREPAID.
        :param pulumi.Input[str] name: Name of the newly purchased instance, which can contain up to 60 letters, digits, or symbols (-_). If this parameter is not specified, "Unnamed" will be displayed by default.
        :param pulumi.Input[int] period: Purchase duration, in months.
               - Prepaid: Supports `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `24`, and `36`.
               - Pay-as-you-go: Only supports `1`.
        :param pulumi.Input[int] project_id: Project ID.
        :param pulumi.Input[str] recovery_target_time: Restoration point in time.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: Security group of the instance, which can be obtained from the `sgld` field in the return value of the [DescribeSecurityGroups](https://intl.cloud.tencent.com/document/api/215/15808?from_cn_redirect=1) API. If this parameter is not specified, the default security group will be bound.
        :param pulumi.Input[str] spec_code: Purchasable code, which can be obtained from the `SpecCode` field in the return value of the [DescribeClasses](https://intl.cloud.tencent.com/document/api/409/89019?from_cn_redirect=1) API.
        :param pulumi.Input[int] storage: Instance storage capacity in GB.
        :param pulumi.Input[str] subnet_id: VPC subnet ID in the format of `subnet-xxxxxxxx`, which can be obtained in the console or from the `unSubnetId` field in the return value of the [DescribeSubnets](https://intl.cloud.tencent.com/document/api/215/15784?from_cn_redirect=1) API.
        :param pulumi.Input[str] sync_mode: Primary-standby sync mode, which supports:
               Semi-sync: Semi-sync
               Async: Asynchronous
               Default value for the primary instance: Semi-sync
               Default value for the read-only instance: Async.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceTagListArgs']]]] tag_lists: The information of tags to be bound with the instance, which is left empty by default. This parameter can be obtained from the `Tags` field in the return value of the [DescribeTags](https://intl.cloud.tencent.com/document/api/651/35316?from_cn_redirect=1) API.
        :param pulumi.Input[str] vpc_id: VPC ID in the format of `vpc-xxxxxxx`, which can be obtained in the console or from the `unVpcId` field in the return value of the [DescribeVpcEx](https://intl.cloud.tencent.com/document/api/215/1372?from_cn_redirect=1) API.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CloneDbInstanceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a postgresql clone db instance

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.postgresql.CloneDbInstance("example",
            auto_renew_flag=0,
            db_instance_id="postgres-evsqpyap",
            db_node_sets=[
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    role="Primary",
                    zone="ap-guangzhou-6",
                ),
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    role="Standby",
                    zone="ap-guangzhou-6",
                ),
            ],
            instance_charge_type="POSTPAID_BY_HOUR",
            period=1,
            project_id=0,
            recovery_target_time="2024-10-12 18:17:00",
            security_group_ids=["sg-8stavs03"],
            spec_code="pg.it.medium4",
            storage=200,
            subnet_id="subnet-b8hintyy",
            tag_lists=[tencentcloud.postgresql.CloneDbInstanceTagListArgs(
                tag_key="createBy",
                tag_value="terraform",
            )],
            vpc_id="vpc-a6zec4mf")
        ```
        <!--End PulumiCodeChooser -->

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        base_backups = tencentcloud.Postgresql.get_base_backups(filters=[tencentcloud.postgresql.GetBaseBackupsFilterArgs(
                name="db-instance-id",
                values=["postgres-evsqpyap"],
            )],
            order_by="Size",
            order_by_type="asc")
        example = tencentcloud.postgresql.CloneDbInstance("example",
            db_instance_id="postgres-evsqpyap",
            spec_code="pg.it.medium4",
            storage=200,
            period=1,
            auto_renew_flag=0,
            vpc_id="vpc-a6zec4mf",
            subnet_id="subnet-b8hintyy",
            instance_charge_type="POSTPAID_BY_HOUR",
            security_group_ids=["sg-8stavs03"],
            project_id=0,
            backup_set_id=base_backups.base_backup_sets[0].id,
            db_node_sets=[
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    role="Primary",
                    zone="ap-guangzhou-6",
                ),
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    role="Standby",
                    zone="ap-guangzhou-6",
                ),
            ],
            tag_lists=[tencentcloud.postgresql.CloneDbInstanceTagListArgs(
                tag_key="createBy",
                tag_value="terraform",
            )])
        ```
        <!--End PulumiCodeChooser -->

        ### Clone db instance from CDC

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.postgresql.CloneDbInstance("example",
            auto_renew_flag=0,
            db_instance_id="postgres-evsqpyap",
            db_node_sets=[
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    dedicated_cluster_id="cluster-262n63e8",
                    role="Primary",
                    zone="ap-guangzhou-6",
                ),
                tencentcloud.postgresql.CloneDbInstanceDbNodeSetArgs(
                    dedicated_cluster_id="cluster-262n63e8",
                    role="Standby",
                    zone="ap-guangzhou-6",
                ),
            ],
            instance_charge_type="POSTPAID_BY_HOUR",
            period=1,
            project_id=0,
            recovery_target_time="2024-10-12 18:17:00",
            security_group_ids=["sg-8stavs03"],
            spec_code="pg.it.medium4",
            storage=200,
            subnet_id="subnet-b8hintyy",
            tag_lists=[tencentcloud.postgresql.CloneDbInstanceTagListArgs(
                tag_key="createBy",
                tag_value="terraform",
            )],
            vpc_id="vpc-a6zec4mf")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param CloneDbInstanceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CloneDbInstanceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 activity_id: Optional[pulumi.Input[int]] = None,
                 auto_renew_flag: Optional[pulumi.Input[int]] = None,
                 backup_set_id: Optional[pulumi.Input[str]] = None,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 db_node_sets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceDbNodeSetArgs']]]]] = None,
                 instance_charge_type: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 period: Optional[pulumi.Input[int]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 recovery_target_time: Optional[pulumi.Input[str]] = None,
                 security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 spec_code: Optional[pulumi.Input[str]] = None,
                 storage: Optional[pulumi.Input[int]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 sync_mode: Optional[pulumi.Input[str]] = None,
                 tag_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceTagListArgs']]]]] = None,
                 vpc_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CloneDbInstanceArgs.__new__(CloneDbInstanceArgs)

            __props__.__dict__["activity_id"] = activity_id
            if auto_renew_flag is None and not opts.urn:
                raise TypeError("Missing required property 'auto_renew_flag'")
            __props__.__dict__["auto_renew_flag"] = auto_renew_flag
            __props__.__dict__["backup_set_id"] = backup_set_id
            if db_instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'db_instance_id'")
            __props__.__dict__["db_instance_id"] = db_instance_id
            __props__.__dict__["db_node_sets"] = db_node_sets
            __props__.__dict__["instance_charge_type"] = instance_charge_type
            __props__.__dict__["name"] = name
            if period is None and not opts.urn:
                raise TypeError("Missing required property 'period'")
            __props__.__dict__["period"] = period
            __props__.__dict__["project_id"] = project_id
            __props__.__dict__["recovery_target_time"] = recovery_target_time
            __props__.__dict__["security_group_ids"] = security_group_ids
            if spec_code is None and not opts.urn:
                raise TypeError("Missing required property 'spec_code'")
            __props__.__dict__["spec_code"] = spec_code
            if storage is None and not opts.urn:
                raise TypeError("Missing required property 'storage'")
            __props__.__dict__["storage"] = storage
            if subnet_id is None and not opts.urn:
                raise TypeError("Missing required property 'subnet_id'")
            __props__.__dict__["subnet_id"] = subnet_id
            __props__.__dict__["sync_mode"] = sync_mode
            __props__.__dict__["tag_lists"] = tag_lists
            if vpc_id is None and not opts.urn:
                raise TypeError("Missing required property 'vpc_id'")
            __props__.__dict__["vpc_id"] = vpc_id
        super(CloneDbInstance, __self__).__init__(
            'tencentcloud:Postgresql/cloneDbInstance:CloneDbInstance',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            activity_id: Optional[pulumi.Input[int]] = None,
            auto_renew_flag: Optional[pulumi.Input[int]] = None,
            backup_set_id: Optional[pulumi.Input[str]] = None,
            db_instance_id: Optional[pulumi.Input[str]] = None,
            db_node_sets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceDbNodeSetArgs']]]]] = None,
            instance_charge_type: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            period: Optional[pulumi.Input[int]] = None,
            project_id: Optional[pulumi.Input[int]] = None,
            recovery_target_time: Optional[pulumi.Input[str]] = None,
            security_group_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            spec_code: Optional[pulumi.Input[str]] = None,
            storage: Optional[pulumi.Input[int]] = None,
            subnet_id: Optional[pulumi.Input[str]] = None,
            sync_mode: Optional[pulumi.Input[str]] = None,
            tag_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceTagListArgs']]]]] = None,
            vpc_id: Optional[pulumi.Input[str]] = None) -> 'CloneDbInstance':
        """
        Get an existing CloneDbInstance resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] activity_id: Campaign ID.
        :param pulumi.Input[int] auto_renew_flag: Renewal Flag:
        :param pulumi.Input[str] backup_set_id: Basic backup set ID.
        :param pulumi.Input[str] db_instance_id: ID of the original instance to be cloned.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceDbNodeSetArgs']]]] db_node_sets: Deployment information of the instance node, which will display the information of each AZ when the instance node is deployed across multiple AZs.
               The information of AZ can be obtained from the `Zone` field in the return value of the [DescribeZones](https://intl.cloud.tencent.com/document/api/409/16769?from_cn_redirect=1) API.
        :param pulumi.Input[str] instance_charge_type: Instance billing type, which currently supports:
               
               - PREPAID: Prepaid, i.e., monthly subscription
               - POSTPAID_BY_HOUR: Pay-as-you-go, i.e., pay by consumption
               
               Default value: PREPAID.
        :param pulumi.Input[str] name: Name of the newly purchased instance, which can contain up to 60 letters, digits, or symbols (-_). If this parameter is not specified, "Unnamed" will be displayed by default.
        :param pulumi.Input[int] period: Purchase duration, in months.
               - Prepaid: Supports `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `24`, and `36`.
               - Pay-as-you-go: Only supports `1`.
        :param pulumi.Input[int] project_id: Project ID.
        :param pulumi.Input[str] recovery_target_time: Restoration point in time.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] security_group_ids: Security group of the instance, which can be obtained from the `sgld` field in the return value of the [DescribeSecurityGroups](https://intl.cloud.tencent.com/document/api/215/15808?from_cn_redirect=1) API. If this parameter is not specified, the default security group will be bound.
        :param pulumi.Input[str] spec_code: Purchasable code, which can be obtained from the `SpecCode` field in the return value of the [DescribeClasses](https://intl.cloud.tencent.com/document/api/409/89019?from_cn_redirect=1) API.
        :param pulumi.Input[int] storage: Instance storage capacity in GB.
        :param pulumi.Input[str] subnet_id: VPC subnet ID in the format of `subnet-xxxxxxxx`, which can be obtained in the console or from the `unSubnetId` field in the return value of the [DescribeSubnets](https://intl.cloud.tencent.com/document/api/215/15784?from_cn_redirect=1) API.
        :param pulumi.Input[str] sync_mode: Primary-standby sync mode, which supports:
               Semi-sync: Semi-sync
               Async: Asynchronous
               Default value for the primary instance: Semi-sync
               Default value for the read-only instance: Async.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['CloneDbInstanceTagListArgs']]]] tag_lists: The information of tags to be bound with the instance, which is left empty by default. This parameter can be obtained from the `Tags` field in the return value of the [DescribeTags](https://intl.cloud.tencent.com/document/api/651/35316?from_cn_redirect=1) API.
        :param pulumi.Input[str] vpc_id: VPC ID in the format of `vpc-xxxxxxx`, which can be obtained in the console or from the `unVpcId` field in the return value of the [DescribeVpcEx](https://intl.cloud.tencent.com/document/api/215/1372?from_cn_redirect=1) API.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CloneDbInstanceState.__new__(_CloneDbInstanceState)

        __props__.__dict__["activity_id"] = activity_id
        __props__.__dict__["auto_renew_flag"] = auto_renew_flag
        __props__.__dict__["backup_set_id"] = backup_set_id
        __props__.__dict__["db_instance_id"] = db_instance_id
        __props__.__dict__["db_node_sets"] = db_node_sets
        __props__.__dict__["instance_charge_type"] = instance_charge_type
        __props__.__dict__["name"] = name
        __props__.__dict__["period"] = period
        __props__.__dict__["project_id"] = project_id
        __props__.__dict__["recovery_target_time"] = recovery_target_time
        __props__.__dict__["security_group_ids"] = security_group_ids
        __props__.__dict__["spec_code"] = spec_code
        __props__.__dict__["storage"] = storage
        __props__.__dict__["subnet_id"] = subnet_id
        __props__.__dict__["sync_mode"] = sync_mode
        __props__.__dict__["tag_lists"] = tag_lists
        __props__.__dict__["vpc_id"] = vpc_id
        return CloneDbInstance(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="activityId")
    def activity_id(self) -> pulumi.Output[Optional[int]]:
        """
        Campaign ID.
        """
        return pulumi.get(self, "activity_id")

    @property
    @pulumi.getter(name="autoRenewFlag")
    def auto_renew_flag(self) -> pulumi.Output[int]:
        """
        Renewal Flag:
        """
        return pulumi.get(self, "auto_renew_flag")

    @property
    @pulumi.getter(name="backupSetId")
    def backup_set_id(self) -> pulumi.Output[Optional[str]]:
        """
        Basic backup set ID.
        """
        return pulumi.get(self, "backup_set_id")

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> pulumi.Output[str]:
        """
        ID of the original instance to be cloned.
        """
        return pulumi.get(self, "db_instance_id")

    @property
    @pulumi.getter(name="dbNodeSets")
    def db_node_sets(self) -> pulumi.Output[Optional[Sequence['outputs.CloneDbInstanceDbNodeSet']]]:
        """
        Deployment information of the instance node, which will display the information of each AZ when the instance node is deployed across multiple AZs.
        The information of AZ can be obtained from the `Zone` field in the return value of the [DescribeZones](https://intl.cloud.tencent.com/document/api/409/16769?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "db_node_sets")

    @property
    @pulumi.getter(name="instanceChargeType")
    def instance_charge_type(self) -> pulumi.Output[Optional[str]]:
        """
        Instance billing type, which currently supports:

        - PREPAID: Prepaid, i.e., monthly subscription
        - POSTPAID_BY_HOUR: Pay-as-you-go, i.e., pay by consumption

        Default value: PREPAID.
        """
        return pulumi.get(self, "instance_charge_type")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the newly purchased instance, which can contain up to 60 letters, digits, or symbols (-_). If this parameter is not specified, "Unnamed" will be displayed by default.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def period(self) -> pulumi.Output[int]:
        """
        Purchase duration, in months.
        - Prepaid: Supports `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`, `10`, `11`, `12`, `24`, and `36`.
        - Pay-as-you-go: Only supports `1`.
        """
        return pulumi.get(self, "period")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[Optional[int]]:
        """
        Project ID.
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter(name="recoveryTargetTime")
    def recovery_target_time(self) -> pulumi.Output[Optional[str]]:
        """
        Restoration point in time.
        """
        return pulumi.get(self, "recovery_target_time")

    @property
    @pulumi.getter(name="securityGroupIds")
    def security_group_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Security group of the instance, which can be obtained from the `sgld` field in the return value of the [DescribeSecurityGroups](https://intl.cloud.tencent.com/document/api/215/15808?from_cn_redirect=1) API. If this parameter is not specified, the default security group will be bound.
        """
        return pulumi.get(self, "security_group_ids")

    @property
    @pulumi.getter(name="specCode")
    def spec_code(self) -> pulumi.Output[str]:
        """
        Purchasable code, which can be obtained from the `SpecCode` field in the return value of the [DescribeClasses](https://intl.cloud.tencent.com/document/api/409/89019?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "spec_code")

    @property
    @pulumi.getter
    def storage(self) -> pulumi.Output[int]:
        """
        Instance storage capacity in GB.
        """
        return pulumi.get(self, "storage")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Output[str]:
        """
        VPC subnet ID in the format of `subnet-xxxxxxxx`, which can be obtained in the console or from the `unSubnetId` field in the return value of the [DescribeSubnets](https://intl.cloud.tencent.com/document/api/215/15784?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "subnet_id")

    @property
    @pulumi.getter(name="syncMode")
    def sync_mode(self) -> pulumi.Output[Optional[str]]:
        """
        Primary-standby sync mode, which supports:
        Semi-sync: Semi-sync
        Async: Asynchronous
        Default value for the primary instance: Semi-sync
        Default value for the read-only instance: Async.
        """
        return pulumi.get(self, "sync_mode")

    @property
    @pulumi.getter(name="tagLists")
    def tag_lists(self) -> pulumi.Output[Optional[Sequence['outputs.CloneDbInstanceTagList']]]:
        """
        The information of tags to be bound with the instance, which is left empty by default. This parameter can be obtained from the `Tags` field in the return value of the [DescribeTags](https://intl.cloud.tencent.com/document/api/651/35316?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "tag_lists")

    @property
    @pulumi.getter(name="vpcId")
    def vpc_id(self) -> pulumi.Output[str]:
        """
        VPC ID in the format of `vpc-xxxxxxx`, which can be obtained in the console or from the `unVpcId` field in the return value of the [DescribeVpcEx](https://intl.cloud.tencent.com/document/api/215/1372?from_cn_redirect=1) API.
        """
        return pulumi.get(self, "vpc_id")

