# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDbInstanceVersionsResult',
    'AwaitableGetDbInstanceVersionsResult',
    'get_db_instance_versions',
    'get_db_instance_versions_output',
]

@pulumi.output_type
class GetDbInstanceVersionsResult:
    """
    A collection of values returned by getDbInstanceVersions.
    """
    def __init__(__self__, id=None, result_output_file=None, version_sets=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if version_sets and not isinstance(version_sets, list):
            raise TypeError("Expected argument 'version_sets' to be a list")
        pulumi.set(__self__, "version_sets", version_sets)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="versionSets")
    def version_sets(self) -> Sequence['outputs.GetDbInstanceVersionsVersionSetResult']:
        """
        List of database versions.
        """
        return pulumi.get(self, "version_sets")


class AwaitableGetDbInstanceVersionsResult(GetDbInstanceVersionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDbInstanceVersionsResult(
            id=self.id,
            result_output_file=self.result_output_file,
            version_sets=self.version_sets)


def get_db_instance_versions(result_output_file: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDbInstanceVersionsResult:
    """
    Use this data source to query detailed information of postgresql db_instance_versions

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    db_instance_versions = tencentcloud.Postgresql.get_db_instance_versions()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Postgresql/getDbInstanceVersions:getDbInstanceVersions', __args__, opts=opts, typ=GetDbInstanceVersionsResult).value

    return AwaitableGetDbInstanceVersionsResult(
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        version_sets=pulumi.get(__ret__, 'version_sets'))


@_utilities.lift_output_func(get_db_instance_versions)
def get_db_instance_versions_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDbInstanceVersionsResult]:
    """
    Use this data source to query detailed information of postgresql db_instance_versions

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    db_instance_versions = tencentcloud.Postgresql.get_db_instance_versions()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    ...
