# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'BackupDownloadRestrictionLimitVpcArgs',
    'InstanceNodeInfoArgs',
    'ParamTemplateParamDetailArgs',
    'ParamTemplateParamsOverrideArgs',
    'GetBackupDownloadInfoLimitVpcArgs',
]

@pulumi.input_type
class BackupDownloadRestrictionLimitVpcArgs:
    def __init__(__self__, *,
                 region: pulumi.Input[str],
                 vpc_lists: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        :param pulumi.Input[str] region: Customize the region of the VPC to which the backup file is downloaded.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] vpc_lists: Customize the list of VPCs to download backup files.
        """
        pulumi.set(__self__, "region", region)
        pulumi.set(__self__, "vpc_lists", vpc_lists)

    @property
    @pulumi.getter
    def region(self) -> pulumi.Input[str]:
        """
        Customize the region of the VPC to which the backup file is downloaded.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: pulumi.Input[str]):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="vpcLists")
    def vpc_lists(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        Customize the list of VPCs to download backup files.
        """
        return pulumi.get(self, "vpc_lists")

    @vpc_lists.setter
    def vpc_lists(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "vpc_lists", value)


@pulumi.input_type
class InstanceNodeInfoArgs:
    def __init__(__self__, *,
                 id: Optional[pulumi.Input[int]] = None,
                 master: Optional[pulumi.Input[bool]] = None,
                 zone_id: Optional[pulumi.Input[int]] = None):
        """
        :param pulumi.Input[int] id: ID of the master or replica node.
        :param pulumi.Input[bool] master: Indicates whether the node is master.
        :param pulumi.Input[int] zone_id: ID of the availability zone of the master or replica node.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)
        if master is not None:
            pulumi.set(__self__, "master", master)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter
    def id(self) -> Optional[pulumi.Input[int]]:
        """
        ID of the master or replica node.
        """
        return pulumi.get(self, "id")

    @id.setter
    def id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "id", value)

    @property
    @pulumi.getter
    def master(self) -> Optional[pulumi.Input[bool]]:
        """
        Indicates whether the node is master.
        """
        return pulumi.get(self, "master")

    @master.setter
    def master(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "master", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[int]]:
        """
        ID of the availability zone of the master or replica node.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "zone_id", value)


@pulumi.input_type
class ParamTemplateParamDetailArgs:
    def __init__(__self__, *,
                 current_value: Optional[pulumi.Input[str]] = None,
                 default: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enum_values: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 max: Optional[pulumi.Input[str]] = None,
                 min: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 need_reboot: Optional[pulumi.Input[int]] = None,
                 param_type: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] current_value: Current value.
        :param pulumi.Input[str] default: Default value.
        :param pulumi.Input[str] description: Parameter template description.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] enum_values: Enum values.
        :param pulumi.Input[str] max: Maximum value.
        :param pulumi.Input[str] min: Minimum value.
        :param pulumi.Input[str] name: Parameter template name.
        :param pulumi.Input[int] need_reboot: Indicates whether to reboot redis instance if modified.
        :param pulumi.Input[str] param_type: Parameter type.
        """
        if current_value is not None:
            pulumi.set(__self__, "current_value", current_value)
        if default is not None:
            pulumi.set(__self__, "default", default)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enum_values is not None:
            pulumi.set(__self__, "enum_values", enum_values)
        if max is not None:
            pulumi.set(__self__, "max", max)
        if min is not None:
            pulumi.set(__self__, "min", min)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if need_reboot is not None:
            pulumi.set(__self__, "need_reboot", need_reboot)
        if param_type is not None:
            pulumi.set(__self__, "param_type", param_type)

    @property
    @pulumi.getter(name="currentValue")
    def current_value(self) -> Optional[pulumi.Input[str]]:
        """
        Current value.
        """
        return pulumi.get(self, "current_value")

    @current_value.setter
    def current_value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "current_value", value)

    @property
    @pulumi.getter
    def default(self) -> Optional[pulumi.Input[str]]:
        """
        Default value.
        """
        return pulumi.get(self, "default")

    @default.setter
    def default(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Parameter template description.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="enumValues")
    def enum_values(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Enum values.
        """
        return pulumi.get(self, "enum_values")

    @enum_values.setter
    def enum_values(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "enum_values", value)

    @property
    @pulumi.getter
    def max(self) -> Optional[pulumi.Input[str]]:
        """
        Maximum value.
        """
        return pulumi.get(self, "max")

    @max.setter
    def max(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "max", value)

    @property
    @pulumi.getter
    def min(self) -> Optional[pulumi.Input[str]]:
        """
        Minimum value.
        """
        return pulumi.get(self, "min")

    @min.setter
    def min(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "min", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Parameter template name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="needReboot")
    def need_reboot(self) -> Optional[pulumi.Input[int]]:
        """
        Indicates whether to reboot redis instance if modified.
        """
        return pulumi.get(self, "need_reboot")

    @need_reboot.setter
    def need_reboot(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "need_reboot", value)

    @property
    @pulumi.getter(name="paramType")
    def param_type(self) -> Optional[pulumi.Input[str]]:
        """
        Parameter type.
        """
        return pulumi.get(self, "param_type")

    @param_type.setter
    def param_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "param_type", value)


@pulumi.input_type
class ParamTemplateParamsOverrideArgs:
    def __init__(__self__, *,
                 key: pulumi.Input[str],
                 value: pulumi.Input[str]):
        """
        :param pulumi.Input[str] key: Parameter key e.g. `timeout`, check https://www.tencentcloud.com/document/product/239/39796 for more reference.
        :param pulumi.Input[str] value: Parameter value, check https://www.tencentcloud.com/document/product/239/39796 for more reference.
        """
        pulumi.set(__self__, "key", key)
        pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter
    def key(self) -> pulumi.Input[str]:
        """
        Parameter key e.g. `timeout`, check https://www.tencentcloud.com/document/product/239/39796 for more reference.
        """
        return pulumi.get(self, "key")

    @key.setter
    def key(self, value: pulumi.Input[str]):
        pulumi.set(self, "key", value)

    @property
    @pulumi.getter
    def value(self) -> pulumi.Input[str]:
        """
        Parameter value, check https://www.tencentcloud.com/document/product/239/39796 for more reference.
        """
        return pulumi.get(self, "value")

    @value.setter
    def value(self, value: pulumi.Input[str]):
        pulumi.set(self, "value", value)


@pulumi.input_type
class GetBackupDownloadInfoLimitVpcArgs:
    def __init__(__self__, *,
                 region: str,
                 vpc_lists: Sequence[str]):
        """
        :param str region: Customize the region of the VPC to which the backup file is downloaded.
        :param Sequence[str] vpc_lists: Customize the list of VPCs to download backup files.
        """
        pulumi.set(__self__, "region", region)
        pulumi.set(__self__, "vpc_lists", vpc_lists)

    @property
    @pulumi.getter
    def region(self) -> str:
        """
        Customize the region of the VPC to which the backup file is downloaded.
        """
        return pulumi.get(self, "region")

    @region.setter
    def region(self, value: str):
        pulumi.set(self, "region", value)

    @property
    @pulumi.getter(name="vpcLists")
    def vpc_lists(self) -> Sequence[str]:
        """
        Customize the list of VPCs to download backup files.
        """
        return pulumi.get(self, "vpc_lists")

    @vpc_lists.setter
    def vpc_lists(self, value: Sequence[str]):
        pulumi.set(self, "vpc_lists", value)


