# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetParamRecordsResult',
    'AwaitableGetParamRecordsResult',
    'get_param_records',
    'get_param_records_output',
]

@pulumi.output_type
class GetParamRecordsResult:
    """
    A collection of values returned by getParamRecords.
    """
    def __init__(__self__, id=None, instance_id=None, instance_param_histories=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if instance_param_histories and not isinstance(instance_param_histories, list):
            raise TypeError("Expected argument 'instance_param_histories' to be a list")
        pulumi.set(__self__, "instance_param_histories", instance_param_histories)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="instanceParamHistories")
    def instance_param_histories(self) -> Sequence['outputs.GetParamRecordsInstanceParamHistoryResult']:
        """
        The parameter name.
        """
        return pulumi.get(self, "instance_param_histories")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetParamRecordsResult(GetParamRecordsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetParamRecordsResult(
            id=self.id,
            instance_id=self.instance_id,
            instance_param_histories=self.instance_param_histories,
            result_output_file=self.result_output_file)


def get_param_records(instance_id: Optional[str] = None,
                      result_output_file: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetParamRecordsResult:
    """
    Use this data source to query detailed information of redis param records

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    param_records = tencentcloud.Redis.get_param_records(instance_id="crs-c1nl9rpv")
    ```
    <!--End PulumiCodeChooser -->


    :param str instance_id: The ID of instance.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Redis/getParamRecords:getParamRecords', __args__, opts=opts, typ=GetParamRecordsResult).value

    return AwaitableGetParamRecordsResult(
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        instance_param_histories=pulumi.get(__ret__, 'instance_param_histories'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_param_records)
def get_param_records_output(instance_id: Optional[pulumi.Input[str]] = None,
                             result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetParamRecordsResult]:
    """
    Use this data source to query detailed information of redis param records

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    param_records = tencentcloud.Redis.get_param_records(instance_id="crs-c1nl9rpv")
    ```
    <!--End PulumiCodeChooser -->


    :param str instance_id: The ID of instance.
    :param str result_output_file: Used to save results.
    """
    ...
