# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ReadOnlyArgs', 'ReadOnly']

@pulumi.input_type
class ReadOnlyArgs:
    def __init__(__self__, *,
                 input_mode: pulumi.Input[str],
                 instance_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a ReadOnly resource.
        :param pulumi.Input[str] input_mode: Instance input mode: `0`: read-write; `1`: read-only.
        :param pulumi.Input[str] instance_id: The ID of instance.
        """
        pulumi.set(__self__, "input_mode", input_mode)
        pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="inputMode")
    def input_mode(self) -> pulumi.Input[str]:
        """
        Instance input mode: `0`: read-write; `1`: read-only.
        """
        return pulumi.get(self, "input_mode")

    @input_mode.setter
    def input_mode(self, value: pulumi.Input[str]):
        pulumi.set(self, "input_mode", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)


@pulumi.input_type
class _ReadOnlyState:
    def __init__(__self__, *,
                 input_mode: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ReadOnly resources.
        :param pulumi.Input[str] input_mode: Instance input mode: `0`: read-write; `1`: read-only.
        :param pulumi.Input[str] instance_id: The ID of instance.
        """
        if input_mode is not None:
            pulumi.set(__self__, "input_mode", input_mode)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="inputMode")
    def input_mode(self) -> Optional[pulumi.Input[str]]:
        """
        Instance input mode: `0`: read-write; `1`: read-only.
        """
        return pulumi.get(self, "input_mode")

    @input_mode.setter
    def input_mode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "input_mode", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)


class ReadOnly(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 input_mode: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a redis read_only

        ## Example Usage

        ## Import

        redis read_only can be imported using the instanceId, e.g.

        ```sh
        $ pulumi import tencentcloud:Redis/readOnly:ReadOnly read_only crs-c1nl9rpv
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] input_mode: Instance input mode: `0`: read-write; `1`: read-only.
        :param pulumi.Input[str] instance_id: The ID of instance.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ReadOnlyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a redis read_only

        ## Example Usage

        ## Import

        redis read_only can be imported using the instanceId, e.g.

        ```sh
        $ pulumi import tencentcloud:Redis/readOnly:ReadOnly read_only crs-c1nl9rpv
        ```

        :param str resource_name: The name of the resource.
        :param ReadOnlyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ReadOnlyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 input_mode: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ReadOnlyArgs.__new__(ReadOnlyArgs)

            if input_mode is None and not opts.urn:
                raise TypeError("Missing required property 'input_mode'")
            __props__.__dict__["input_mode"] = input_mode
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
        super(ReadOnly, __self__).__init__(
            'tencentcloud:Redis/readOnly:ReadOnly',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            input_mode: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None) -> 'ReadOnly':
        """
        Get an existing ReadOnly resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] input_mode: Instance input mode: `0`: read-write; `1`: read-only.
        :param pulumi.Input[str] instance_id: The ID of instance.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ReadOnlyState.__new__(_ReadOnlyState)

        __props__.__dict__["input_mode"] = input_mode
        __props__.__dict__["instance_id"] = instance_id
        return ReadOnly(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="inputMode")
    def input_mode(self) -> pulumi.Output[str]:
        """
        Instance input mode: `0`: read-write; `1`: read-only.
        """
        return pulumi.get(self, "input_mode")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

