# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ReplicaReadonlyArgs', 'ReplicaReadonly']

@pulumi.input_type
class ReplicaReadonlyArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 operate: pulumi.Input[str],
                 readonly_policies: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a ReplicaReadonly resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] operate: The replica is read-only, `enable` - enable read-write splitting, `disable`- disable read-write splitting.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] readonly_policies: Routing policy: Enter `master` or `replication`, which indicates the master node or slave node.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "operate", operate)
        if readonly_policies is not None:
            pulumi.set(__self__, "readonly_policies", readonly_policies)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def operate(self) -> pulumi.Input[str]:
        """
        The replica is read-only, `enable` - enable read-write splitting, `disable`- disable read-write splitting.
        """
        return pulumi.get(self, "operate")

    @operate.setter
    def operate(self, value: pulumi.Input[str]):
        pulumi.set(self, "operate", value)

    @property
    @pulumi.getter(name="readonlyPolicies")
    def readonly_policies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Routing policy: Enter `master` or `replication`, which indicates the master node or slave node.
        """
        return pulumi.get(self, "readonly_policies")

    @readonly_policies.setter
    def readonly_policies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "readonly_policies", value)


@pulumi.input_type
class _ReplicaReadonlyState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 readonly_policies: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering ReplicaReadonly resources.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] operate: The replica is read-only, `enable` - enable read-write splitting, `disable`- disable read-write splitting.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] readonly_policies: Routing policy: Enter `master` or `replication`, which indicates the master node or slave node.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if operate is not None:
            pulumi.set(__self__, "operate", operate)
        if readonly_policies is not None:
            pulumi.set(__self__, "readonly_policies", readonly_policies)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def operate(self) -> Optional[pulumi.Input[str]]:
        """
        The replica is read-only, `enable` - enable read-write splitting, `disable`- disable read-write splitting.
        """
        return pulumi.get(self, "operate")

    @operate.setter
    def operate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "operate", value)

    @property
    @pulumi.getter(name="readonlyPolicies")
    def readonly_policies(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Routing policy: Enter `master` or `replication`, which indicates the master node or slave node.
        """
        return pulumi.get(self, "readonly_policies")

    @readonly_policies.setter
    def readonly_policies(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "readonly_policies", value)


class ReplicaReadonly(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 readonly_policies: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Provides a resource to create a redis replica_readonly

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] operate: The replica is read-only, `enable` - enable read-write splitting, `disable`- disable read-write splitting.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] readonly_policies: Routing policy: Enter `master` or `replication`, which indicates the master node or slave node.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ReplicaReadonlyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a redis replica_readonly

        :param str resource_name: The name of the resource.
        :param ReplicaReadonlyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ReplicaReadonlyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 readonly_policies: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ReplicaReadonlyArgs.__new__(ReplicaReadonlyArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if operate is None and not opts.urn:
                raise TypeError("Missing required property 'operate'")
            __props__.__dict__["operate"] = operate
            __props__.__dict__["readonly_policies"] = readonly_policies
        super(ReplicaReadonly, __self__).__init__(
            'tencentcloud:Redis/replicaReadonly:ReplicaReadonly',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            operate: Optional[pulumi.Input[str]] = None,
            readonly_policies: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'ReplicaReadonly':
        """
        Get an existing ReplicaReadonly resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] operate: The replica is read-only, `enable` - enable read-write splitting, `disable`- disable read-write splitting.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] readonly_policies: Routing policy: Enter `master` or `replication`, which indicates the master node or slave node.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ReplicaReadonlyState.__new__(_ReplicaReadonlyState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["operate"] = operate
        __props__.__dict__["readonly_policies"] = readonly_policies
        return ReplicaReadonly(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def operate(self) -> pulumi.Output[str]:
        """
        The replica is read-only, `enable` - enable read-write splitting, `disable`- disable read-write splitting.
        """
        return pulumi.get(self, "operate")

    @property
    @pulumi.getter(name="readonlyPolicies")
    def readonly_policies(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Routing policy: Enter `master` or `replication`, which indicates the master node or slave node.
        """
        return pulumi.get(self, "readonly_policies")

