# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['SslArgs', 'Ssl']

@pulumi.input_type
class SslArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 ssl_config: pulumi.Input[str]):
        """
        The set of arguments for constructing a Ssl resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] ssl_config: The SSL configuration status of the instance: `enabled`,`disabled`.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "ssl_config", ssl_config)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="sslConfig")
    def ssl_config(self) -> pulumi.Input[str]:
        """
        The SSL configuration status of the instance: `enabled`,`disabled`.
        """
        return pulumi.get(self, "ssl_config")

    @ssl_config.setter
    def ssl_config(self, value: pulumi.Input[str]):
        pulumi.set(self, "ssl_config", value)


@pulumi.input_type
class _SslState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ssl_config: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Ssl resources.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] ssl_config: The SSL configuration status of the instance: `enabled`,`disabled`.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if ssl_config is not None:
            pulumi.set(__self__, "ssl_config", ssl_config)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="sslConfig")
    def ssl_config(self) -> Optional[pulumi.Input[str]]:
        """
        The SSL configuration status of the instance: `enabled`,`disabled`.
        """
        return pulumi.get(self, "ssl_config")

    @ssl_config.setter
    def ssl_config(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ssl_config", value)


class Ssl(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ssl_config: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a redis ssl

        ## Import

        redis ssl can be imported using the instanceId, e.g.

        ```sh
        $ pulumi import tencentcloud:Redis/ssl:Ssl ssl crs-c1nl9rpv
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] ssl_config: The SSL configuration status of the instance: `enabled`,`disabled`.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: SslArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a redis ssl

        ## Import

        redis ssl can be imported using the instanceId, e.g.

        ```sh
        $ pulumi import tencentcloud:Redis/ssl:Ssl ssl crs-c1nl9rpv
        ```

        :param str resource_name: The name of the resource.
        :param SslArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(SslArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ssl_config: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = SslArgs.__new__(SslArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if ssl_config is None and not opts.urn:
                raise TypeError("Missing required property 'ssl_config'")
            __props__.__dict__["ssl_config"] = ssl_config
        super(Ssl, __self__).__init__(
            'tencentcloud:Redis/ssl:Ssl',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            ssl_config: Optional[pulumi.Input[str]] = None) -> 'Ssl':
        """
        Get an existing Ssl resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of instance.
        :param pulumi.Input[str] ssl_config: The SSL configuration status of the instance: `enabled`,`disabled`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _SslState.__new__(_SslState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["ssl_config"] = ssl_config
        return Ssl(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The ID of instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="sslConfig")
    def ssl_config(self) -> pulumi.Output[str]:
        """
        The SSL configuration status of the instance: `enabled`,`disabled`.
        """
        return pulumi.get(self, "ssl_config")

