# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['InstanceStatusConfigArgs', 'InstanceStatusConfig']

@pulumi.input_type
class InstanceStatusConfigArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 operate: pulumi.Input[str]):
        """
        The set of arguments for constructing a InstanceStatusConfig resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] operate: `resume`, `stop`.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "operate", operate)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def operate(self) -> pulumi.Input[str]:
        """
        `resume`, `stop`.
        """
        return pulumi.get(self, "operate")

    @operate.setter
    def operate(self, value: pulumi.Input[str]):
        pulumi.set(self, "operate", value)


@pulumi.input_type
class _InstanceStatusConfigState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 instance_status: Optional[pulumi.Input[int]] = None,
                 operate: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering InstanceStatusConfig resources.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[int] instance_status: Instance status (`1`=creating, `2`=running, `3`=abnormal, `4`=restarting, `5`=stopping, `6`=stopped, `7`=deleted).
        :param pulumi.Input[str] operate: `resume`, `stop`.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if instance_status is not None:
            pulumi.set(__self__, "instance_status", instance_status)
        if operate is not None:
            pulumi.set(__self__, "operate", operate)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="instanceStatus")
    def instance_status(self) -> Optional[pulumi.Input[int]]:
        """
        Instance status (`1`=creating, `2`=running, `3`=abnormal, `4`=restarting, `5`=stopping, `6`=stopped, `7`=deleted).
        """
        return pulumi.get(self, "instance_status")

    @instance_status.setter
    def instance_status(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "instance_status", value)

    @property
    @pulumi.getter
    def operate(self) -> Optional[pulumi.Input[str]]:
        """
        `resume`, `stop`.
        """
        return pulumi.get(self, "operate")

    @operate.setter
    def operate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "operate", value)


class InstanceStatusConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a rum instance_status_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        instance_status_config = tencentcloud.rum.InstanceStatusConfig("instanceStatusConfig",
            instance_id="rum-pasZKEI3RLgakj",
            operate="stop")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        rum instance_status_config can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Rum/instanceStatusConfig:InstanceStatusConfig instance_status_config instance_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] operate: `resume`, `stop`.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InstanceStatusConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a rum instance_status_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        instance_status_config = tencentcloud.rum.InstanceStatusConfig("instanceStatusConfig",
            instance_id="rum-pasZKEI3RLgakj",
            operate="stop")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        rum instance_status_config can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Rum/instanceStatusConfig:InstanceStatusConfig instance_status_config instance_id
        ```

        :param str resource_name: The name of the resource.
        :param InstanceStatusConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InstanceStatusConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InstanceStatusConfigArgs.__new__(InstanceStatusConfigArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if operate is None and not opts.urn:
                raise TypeError("Missing required property 'operate'")
            __props__.__dict__["operate"] = operate
            __props__.__dict__["instance_status"] = None
        super(InstanceStatusConfig, __self__).__init__(
            'tencentcloud:Rum/instanceStatusConfig:InstanceStatusConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            instance_status: Optional[pulumi.Input[int]] = None,
            operate: Optional[pulumi.Input[str]] = None) -> 'InstanceStatusConfig':
        """
        Get an existing InstanceStatusConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[int] instance_status: Instance status (`1`=creating, `2`=running, `3`=abnormal, `4`=restarting, `5`=stopping, `6`=stopped, `7`=deleted).
        :param pulumi.Input[str] operate: `resume`, `stop`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InstanceStatusConfigState.__new__(_InstanceStatusConfigState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["instance_status"] = instance_status
        __props__.__dict__["operate"] = operate
        return InstanceStatusConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="instanceStatus")
    def instance_status(self) -> pulumi.Output[int]:
        """
        Instance status (`1`=creating, `2`=running, `3`=abnormal, `4`=restarting, `5`=stopping, `6`=stopped, `7`=deleted).
        """
        return pulumi.get(self, "instance_status")

    @property
    @pulumi.getter
    def operate(self) -> pulumi.Output[str]:
        """
        `resume`, `stop`.
        """
        return pulumi.get(self, "operate")

