# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ProjectStatusConfigArgs', 'ProjectStatusConfig']

@pulumi.input_type
class ProjectStatusConfigArgs:
    def __init__(__self__, *,
                 operate: pulumi.Input[str],
                 project_id: pulumi.Input[int]):
        """
        The set of arguments for constructing a ProjectStatusConfig resource.
        :param pulumi.Input[str] operate: `resume`, `stop`.
        :param pulumi.Input[int] project_id: Project ID.
        """
        pulumi.set(__self__, "operate", operate)
        pulumi.set(__self__, "project_id", project_id)

    @property
    @pulumi.getter
    def operate(self) -> pulumi.Input[str]:
        """
        `resume`, `stop`.
        """
        return pulumi.get(self, "operate")

    @operate.setter
    def operate(self, value: pulumi.Input[str]):
        pulumi.set(self, "operate", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Input[int]:
        """
        Project ID.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "project_id", value)


@pulumi.input_type
class _ProjectStatusConfigState:
    def __init__(__self__, *,
                 operate: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering ProjectStatusConfig resources.
        :param pulumi.Input[str] operate: `resume`, `stop`.
        :param pulumi.Input[int] project_id: Project ID.
        """
        if operate is not None:
            pulumi.set(__self__, "operate", operate)
        if project_id is not None:
            pulumi.set(__self__, "project_id", project_id)

    @property
    @pulumi.getter
    def operate(self) -> Optional[pulumi.Input[str]]:
        """
        `resume`, `stop`.
        """
        return pulumi.get(self, "operate")

    @operate.setter
    def operate(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "operate", value)

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> Optional[pulumi.Input[int]]:
        """
        Project ID.
        """
        return pulumi.get(self, "project_id")

    @project_id.setter
    def project_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "project_id", value)


class ProjectStatusConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a rum project_status_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        project_status_config = tencentcloud.rum.ProjectStatusConfig("projectStatusConfig",
            operate="stop",
            project_id=131407)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        rum project_status_config can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Rum/projectStatusConfig:ProjectStatusConfig project_status_config project_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] operate: `resume`, `stop`.
        :param pulumi.Input[int] project_id: Project ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProjectStatusConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a rum project_status_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        project_status_config = tencentcloud.rum.ProjectStatusConfig("projectStatusConfig",
            operate="stop",
            project_id=131407)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        rum project_status_config can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Rum/projectStatusConfig:ProjectStatusConfig project_status_config project_id
        ```

        :param str resource_name: The name of the resource.
        :param ProjectStatusConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProjectStatusConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 operate: Optional[pulumi.Input[str]] = None,
                 project_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProjectStatusConfigArgs.__new__(ProjectStatusConfigArgs)

            if operate is None and not opts.urn:
                raise TypeError("Missing required property 'operate'")
            __props__.__dict__["operate"] = operate
            if project_id is None and not opts.urn:
                raise TypeError("Missing required property 'project_id'")
            __props__.__dict__["project_id"] = project_id
        super(ProjectStatusConfig, __self__).__init__(
            'tencentcloud:Rum/projectStatusConfig:ProjectStatusConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            operate: Optional[pulumi.Input[str]] = None,
            project_id: Optional[pulumi.Input[int]] = None) -> 'ProjectStatusConfig':
        """
        Get an existing ProjectStatusConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] operate: `resume`, `stop`.
        :param pulumi.Input[int] project_id: Project ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ProjectStatusConfigState.__new__(_ProjectStatusConfigState)

        __props__.__dict__["operate"] = operate
        __props__.__dict__["project_id"] = project_id
        return ProjectStatusConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def operate(self) -> pulumi.Output[str]:
        """
        `resume`, `stop`.
        """
        return pulumi.get(self, "operate")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> pulumi.Output[int]:
        """
        Project ID.
        """
        return pulumi.get(self, "project_id")

