# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ConfigDatabaseCdcArgs', 'ConfigDatabaseCdc']

@pulumi.input_type
class ConfigDatabaseCdcArgs:
    def __init__(__self__, *,
                 db_name: pulumi.Input[str],
                 instance_id: pulumi.Input[str],
                 modify_type: pulumi.Input[str]):
        """
        The set of arguments for constructing a ConfigDatabaseCdc resource.
        :param pulumi.Input[str] db_name: database name.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] modify_type: Enable or disable CDC. Valid values: enable, disable.
        """
        pulumi.set(__self__, "db_name", db_name)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "modify_type", modify_type)

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> pulumi.Input[str]:
        """
        database name.
        """
        return pulumi.get(self, "db_name")

    @db_name.setter
    def db_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "db_name", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="modifyType")
    def modify_type(self) -> pulumi.Input[str]:
        """
        Enable or disable CDC. Valid values: enable, disable.
        """
        return pulumi.get(self, "modify_type")

    @modify_type.setter
    def modify_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "modify_type", value)


@pulumi.input_type
class _ConfigDatabaseCdcState:
    def __init__(__self__, *,
                 db_name: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 modify_type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ConfigDatabaseCdc resources.
        :param pulumi.Input[str] db_name: database name.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] modify_type: Enable or disable CDC. Valid values: enable, disable.
        """
        if db_name is not None:
            pulumi.set(__self__, "db_name", db_name)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if modify_type is not None:
            pulumi.set(__self__, "modify_type", modify_type)

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> Optional[pulumi.Input[str]]:
        """
        database name.
        """
        return pulumi.get(self, "db_name")

    @db_name.setter
    def db_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "db_name", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="modifyType")
    def modify_type(self) -> Optional[pulumi.Input[str]]:
        """
        Enable or disable CDC. Valid values: enable, disable.
        """
        return pulumi.get(self, "modify_type")

    @modify_type.setter
    def modify_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "modify_type", value)


class ConfigDatabaseCdc(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_name: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 modify_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a sqlserver config_database_cdc

        ## Example Usage

        ### Turn off database data change capture (CDC)

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="sqlserver")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[4].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="desc.")
        example_basic_instance = tencentcloud.sqlserver.BasicInstance("exampleBasicInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            project_id=0,
            memory=4,
            storage=100,
            cpu=2,
            machine_type="CLOUD_PREMIUM",
            maintenance_week_sets=[
                1,
                2,
                3,
            ],
            maintenance_start_time="09:00",
            maintenance_time_span=3,
            security_groups=[security_group.id],
            tags={
                "test": "test",
            })
        example_db = tencentcloud.sqlserver.Db("exampleDb",
            instance_id=example_basic_instance.id,
            charset="Chinese_PRC_BIN",
            remark="test-remark")
        example_config_database_cdc = tencentcloud.sqlserver.ConfigDatabaseCdc("exampleConfigDatabaseCdc",
            instance_id=example_basic_instance.id,
            db_name=example_db.name,
            modify_type="disable")
        ```
        <!--End PulumiCodeChooser -->

        ### Enable Database Data Change Capture (CDC)

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.sqlserver.ConfigDatabaseCdc("example",
            instance_id=tencentcloud_sqlserver_basic_instance["example"]["id"],
            db_name=tencentcloud_sqlserver_db["example"]["name"],
            modify_type="enable")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        sqlserver config_database_cdc can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Sqlserver/configDatabaseCdc:ConfigDatabaseCdc example mssql-i9ma6oy7#tf_example_db
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] db_name: database name.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] modify_type: Enable or disable CDC. Valid values: enable, disable.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ConfigDatabaseCdcArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a sqlserver config_database_cdc

        ## Example Usage

        ### Turn off database data change capture (CDC)

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="sqlserver")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[4].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="desc.")
        example_basic_instance = tencentcloud.sqlserver.BasicInstance("exampleBasicInstance",
            availability_zone=zones.zones[4].name,
            charge_type="POSTPAID_BY_HOUR",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            project_id=0,
            memory=4,
            storage=100,
            cpu=2,
            machine_type="CLOUD_PREMIUM",
            maintenance_week_sets=[
                1,
                2,
                3,
            ],
            maintenance_start_time="09:00",
            maintenance_time_span=3,
            security_groups=[security_group.id],
            tags={
                "test": "test",
            })
        example_db = tencentcloud.sqlserver.Db("exampleDb",
            instance_id=example_basic_instance.id,
            charset="Chinese_PRC_BIN",
            remark="test-remark")
        example_config_database_cdc = tencentcloud.sqlserver.ConfigDatabaseCdc("exampleConfigDatabaseCdc",
            instance_id=example_basic_instance.id,
            db_name=example_db.name,
            modify_type="disable")
        ```
        <!--End PulumiCodeChooser -->

        ### Enable Database Data Change Capture (CDC)

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.sqlserver.ConfigDatabaseCdc("example",
            instance_id=tencentcloud_sqlserver_basic_instance["example"]["id"],
            db_name=tencentcloud_sqlserver_db["example"]["name"],
            modify_type="enable")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        sqlserver config_database_cdc can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Sqlserver/configDatabaseCdc:ConfigDatabaseCdc example mssql-i9ma6oy7#tf_example_db
        ```

        :param str resource_name: The name of the resource.
        :param ConfigDatabaseCdcArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ConfigDatabaseCdcArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_name: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 modify_type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ConfigDatabaseCdcArgs.__new__(ConfigDatabaseCdcArgs)

            if db_name is None and not opts.urn:
                raise TypeError("Missing required property 'db_name'")
            __props__.__dict__["db_name"] = db_name
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if modify_type is None and not opts.urn:
                raise TypeError("Missing required property 'modify_type'")
            __props__.__dict__["modify_type"] = modify_type
        super(ConfigDatabaseCdc, __self__).__init__(
            'tencentcloud:Sqlserver/configDatabaseCdc:ConfigDatabaseCdc',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            db_name: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            modify_type: Optional[pulumi.Input[str]] = None) -> 'ConfigDatabaseCdc':
        """
        Get an existing ConfigDatabaseCdc resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] db_name: database name.
        :param pulumi.Input[str] instance_id: Instance ID.
        :param pulumi.Input[str] modify_type: Enable or disable CDC. Valid values: enable, disable.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ConfigDatabaseCdcState.__new__(_ConfigDatabaseCdcState)

        __props__.__dict__["db_name"] = db_name
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["modify_type"] = modify_type
        return ConfigDatabaseCdc(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dbName")
    def db_name(self) -> pulumi.Output[str]:
        """
        database name.
        """
        return pulumi.get(self, "db_name")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="modifyType")
    def modify_type(self) -> pulumi.Output[str]:
        """
        Enable or disable CDC. Valid values: enable, disable.
        """
        return pulumi.get(self, "modify_type")

