# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetReadonlyGroupsResult',
    'AwaitableGetReadonlyGroupsResult',
    'get_readonly_groups',
    'get_readonly_groups_output',
]

@pulumi.output_type
class GetReadonlyGroupsResult:
    """
    A collection of values returned by getReadonlyGroups.
    """
    def __init__(__self__, id=None, lists=None, master_instance_id=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if master_instance_id and not isinstance(master_instance_id, str):
            raise TypeError("Expected argument 'master_instance_id' to be a str")
        pulumi.set(__self__, "master_instance_id", master_instance_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetReadonlyGroupsListResult']:
        """
        A list of SQL Server readonly group. Each element contains the following attributes:
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter(name="masterInstanceId")
    def master_instance_id(self) -> Optional[str]:
        """
        Master instance id.
        """
        return pulumi.get(self, "master_instance_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetReadonlyGroupsResult(GetReadonlyGroupsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetReadonlyGroupsResult(
            id=self.id,
            lists=self.lists,
            master_instance_id=self.master_instance_id,
            result_output_file=self.result_output_file)


def get_readonly_groups(master_instance_id: Optional[str] = None,
                        result_output_file: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetReadonlyGroupsResult:
    """
    Use this data source to query the list of SQL Server readonly groups.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Sqlserver.get_dbs(instance_id="mssql-ds1xhnt9")
    ```
    <!--End PulumiCodeChooser -->


    :param str master_instance_id: Master SQL Server instance ID.
    :param str result_output_file: Used to store results.
    """
    __args__ = dict()
    __args__['masterInstanceId'] = master_instance_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Sqlserver/getReadonlyGroups:getReadonlyGroups', __args__, opts=opts, typ=GetReadonlyGroupsResult).value

    return AwaitableGetReadonlyGroupsResult(
        id=pulumi.get(__ret__, 'id'),
        lists=pulumi.get(__ret__, 'lists'),
        master_instance_id=pulumi.get(__ret__, 'master_instance_id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_readonly_groups)
def get_readonly_groups_output(master_instance_id: Optional[pulumi.Input[Optional[str]]] = None,
                               result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetReadonlyGroupsResult]:
    """
    Use this data source to query the list of SQL Server readonly groups.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Sqlserver.get_dbs(instance_id="mssql-ds1xhnt9")
    ```
    <!--End PulumiCodeChooser -->


    :param str master_instance_id: Master SQL Server instance ID.
    :param str result_output_file: Used to store results.
    """
    ...
