# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetRotationHistoryResult',
    'AwaitableGetRotationHistoryResult',
    'get_rotation_history',
    'get_rotation_history_output',
]

@pulumi.output_type
class GetRotationHistoryResult:
    """
    A collection of values returned by getRotationHistory.
    """
    def __init__(__self__, id=None, result_output_file=None, secret_name=None, version_ids=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if secret_name and not isinstance(secret_name, str):
            raise TypeError("Expected argument 'secret_name' to be a str")
        pulumi.set(__self__, "secret_name", secret_name)
        if version_ids and not isinstance(version_ids, list):
            raise TypeError("Expected argument 'version_ids' to be a list")
        pulumi.set(__self__, "version_ids", version_ids)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="secretName")
    def secret_name(self) -> str:
        return pulumi.get(self, "secret_name")

    @property
    @pulumi.getter(name="versionIds")
    def version_ids(self) -> Sequence[str]:
        """
        The number of version numbers. The maximum number of version numbers that can be displayed to users is 10.
        """
        return pulumi.get(self, "version_ids")


class AwaitableGetRotationHistoryResult(GetRotationHistoryResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRotationHistoryResult(
            id=self.id,
            result_output_file=self.result_output_file,
            secret_name=self.secret_name,
            version_ids=self.version_ids)


def get_rotation_history(result_output_file: Optional[str] = None,
                         secret_name: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRotationHistoryResult:
    """
    Use this data source to query detailed information of ssm rotation_history

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Ssm.get_rotation_history(secret_name="keep_terraform")
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str secret_name: Secret name.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    __args__['secretName'] = secret_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Ssm/getRotationHistory:getRotationHistory', __args__, opts=opts, typ=GetRotationHistoryResult).value

    return AwaitableGetRotationHistoryResult(
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        secret_name=pulumi.get(__ret__, 'secret_name'),
        version_ids=pulumi.get(__ret__, 'version_ids'))


@_utilities.lift_output_func(get_rotation_history)
def get_rotation_history_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                secret_name: Optional[pulumi.Input[str]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRotationHistoryResult]:
    """
    Use this data source to query detailed information of ssm rotation_history

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Ssm.get_rotation_history(secret_name="keep_terraform")
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str secret_name: Secret name.
    """
    ...
