# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ApplicationFileConfigArgs', 'ApplicationFileConfig']

@pulumi.input_type
class ApplicationFileConfigArgs:
    def __init__(__self__, *,
                 application_id: pulumi.Input[str],
                 config_file_name: pulumi.Input[str],
                 config_file_path: pulumi.Input[str],
                 config_file_value: pulumi.Input[str],
                 config_name: pulumi.Input[str],
                 config_version: pulumi.Input[str],
                 config_file_code: Optional[pulumi.Input[str]] = None,
                 config_post_cmd: Optional[pulumi.Input[str]] = None,
                 config_version_desc: Optional[pulumi.Input[str]] = None,
                 encode_with_base64: Optional[pulumi.Input[bool]] = None,
                 program_id_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        The set of arguments for constructing a ApplicationFileConfig resource.
        :param pulumi.Input[str] application_id: Config file associated application ID.
        :param pulumi.Input[str] config_file_name: Config file name.
        :param pulumi.Input[str] config_file_path: config release path.
        :param pulumi.Input[str] config_file_value: Configuration file content (the original content encoding needs to be in utf-8 format, if the ConfigFileCode is gbk, it will be converted in the background).
        :param pulumi.Input[str] config_name: Config Name.
        :param pulumi.Input[str] config_version: Config version.
        :param pulumi.Input[str] config_file_code: Configuration file encoding, utf-8 or gbk. Note: If you choose gbk, you need the support of a new version of tsf-consul-template (public cloud virtual machines need to use 1.32 tsf-agent, and containers need to obtain the latest tsf-consul-template-docker.tar.gz from the documentation).
        :param pulumi.Input[str] config_post_cmd: post command.
        :param pulumi.Input[str] config_version_desc: config version description.
        :param pulumi.Input[bool] encode_with_base64: the config value is encoded with base64 or not.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] program_id_lists: datasource for auth.
        """
        pulumi.set(__self__, "application_id", application_id)
        pulumi.set(__self__, "config_file_name", config_file_name)
        pulumi.set(__self__, "config_file_path", config_file_path)
        pulumi.set(__self__, "config_file_value", config_file_value)
        pulumi.set(__self__, "config_name", config_name)
        pulumi.set(__self__, "config_version", config_version)
        if config_file_code is not None:
            pulumi.set(__self__, "config_file_code", config_file_code)
        if config_post_cmd is not None:
            pulumi.set(__self__, "config_post_cmd", config_post_cmd)
        if config_version_desc is not None:
            pulumi.set(__self__, "config_version_desc", config_version_desc)
        if encode_with_base64 is not None:
            pulumi.set(__self__, "encode_with_base64", encode_with_base64)
        if program_id_lists is not None:
            pulumi.set(__self__, "program_id_lists", program_id_lists)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> pulumi.Input[str]:
        """
        Config file associated application ID.
        """
        return pulumi.get(self, "application_id")

    @application_id.setter
    def application_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "application_id", value)

    @property
    @pulumi.getter(name="configFileName")
    def config_file_name(self) -> pulumi.Input[str]:
        """
        Config file name.
        """
        return pulumi.get(self, "config_file_name")

    @config_file_name.setter
    def config_file_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_file_name", value)

    @property
    @pulumi.getter(name="configFilePath")
    def config_file_path(self) -> pulumi.Input[str]:
        """
        config release path.
        """
        return pulumi.get(self, "config_file_path")

    @config_file_path.setter
    def config_file_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_file_path", value)

    @property
    @pulumi.getter(name="configFileValue")
    def config_file_value(self) -> pulumi.Input[str]:
        """
        Configuration file content (the original content encoding needs to be in utf-8 format, if the ConfigFileCode is gbk, it will be converted in the background).
        """
        return pulumi.get(self, "config_file_value")

    @config_file_value.setter
    def config_file_value(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_file_value", value)

    @property
    @pulumi.getter(name="configName")
    def config_name(self) -> pulumi.Input[str]:
        """
        Config Name.
        """
        return pulumi.get(self, "config_name")

    @config_name.setter
    def config_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_name", value)

    @property
    @pulumi.getter(name="configVersion")
    def config_version(self) -> pulumi.Input[str]:
        """
        Config version.
        """
        return pulumi.get(self, "config_version")

    @config_version.setter
    def config_version(self, value: pulumi.Input[str]):
        pulumi.set(self, "config_version", value)

    @property
    @pulumi.getter(name="configFileCode")
    def config_file_code(self) -> Optional[pulumi.Input[str]]:
        """
        Configuration file encoding, utf-8 or gbk. Note: If you choose gbk, you need the support of a new version of tsf-consul-template (public cloud virtual machines need to use 1.32 tsf-agent, and containers need to obtain the latest tsf-consul-template-docker.tar.gz from the documentation).
        """
        return pulumi.get(self, "config_file_code")

    @config_file_code.setter
    def config_file_code(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_file_code", value)

    @property
    @pulumi.getter(name="configPostCmd")
    def config_post_cmd(self) -> Optional[pulumi.Input[str]]:
        """
        post command.
        """
        return pulumi.get(self, "config_post_cmd")

    @config_post_cmd.setter
    def config_post_cmd(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_post_cmd", value)

    @property
    @pulumi.getter(name="configVersionDesc")
    def config_version_desc(self) -> Optional[pulumi.Input[str]]:
        """
        config version description.
        """
        return pulumi.get(self, "config_version_desc")

    @config_version_desc.setter
    def config_version_desc(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_version_desc", value)

    @property
    @pulumi.getter(name="encodeWithBase64")
    def encode_with_base64(self) -> Optional[pulumi.Input[bool]]:
        """
        the config value is encoded with base64 or not.
        """
        return pulumi.get(self, "encode_with_base64")

    @encode_with_base64.setter
    def encode_with_base64(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "encode_with_base64", value)

    @property
    @pulumi.getter(name="programIdLists")
    def program_id_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        datasource for auth.
        """
        return pulumi.get(self, "program_id_lists")

    @program_id_lists.setter
    def program_id_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "program_id_lists", value)


@pulumi.input_type
class _ApplicationFileConfigState:
    def __init__(__self__, *,
                 application_id: Optional[pulumi.Input[str]] = None,
                 config_file_code: Optional[pulumi.Input[str]] = None,
                 config_file_name: Optional[pulumi.Input[str]] = None,
                 config_file_path: Optional[pulumi.Input[str]] = None,
                 config_file_value: Optional[pulumi.Input[str]] = None,
                 config_name: Optional[pulumi.Input[str]] = None,
                 config_post_cmd: Optional[pulumi.Input[str]] = None,
                 config_version: Optional[pulumi.Input[str]] = None,
                 config_version_desc: Optional[pulumi.Input[str]] = None,
                 encode_with_base64: Optional[pulumi.Input[bool]] = None,
                 program_id_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering ApplicationFileConfig resources.
        :param pulumi.Input[str] application_id: Config file associated application ID.
        :param pulumi.Input[str] config_file_code: Configuration file encoding, utf-8 or gbk. Note: If you choose gbk, you need the support of a new version of tsf-consul-template (public cloud virtual machines need to use 1.32 tsf-agent, and containers need to obtain the latest tsf-consul-template-docker.tar.gz from the documentation).
        :param pulumi.Input[str] config_file_name: Config file name.
        :param pulumi.Input[str] config_file_path: config release path.
        :param pulumi.Input[str] config_file_value: Configuration file content (the original content encoding needs to be in utf-8 format, if the ConfigFileCode is gbk, it will be converted in the background).
        :param pulumi.Input[str] config_name: Config Name.
        :param pulumi.Input[str] config_post_cmd: post command.
        :param pulumi.Input[str] config_version: Config version.
        :param pulumi.Input[str] config_version_desc: config version description.
        :param pulumi.Input[bool] encode_with_base64: the config value is encoded with base64 or not.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] program_id_lists: datasource for auth.
        """
        if application_id is not None:
            pulumi.set(__self__, "application_id", application_id)
        if config_file_code is not None:
            pulumi.set(__self__, "config_file_code", config_file_code)
        if config_file_name is not None:
            pulumi.set(__self__, "config_file_name", config_file_name)
        if config_file_path is not None:
            pulumi.set(__self__, "config_file_path", config_file_path)
        if config_file_value is not None:
            pulumi.set(__self__, "config_file_value", config_file_value)
        if config_name is not None:
            pulumi.set(__self__, "config_name", config_name)
        if config_post_cmd is not None:
            pulumi.set(__self__, "config_post_cmd", config_post_cmd)
        if config_version is not None:
            pulumi.set(__self__, "config_version", config_version)
        if config_version_desc is not None:
            pulumi.set(__self__, "config_version_desc", config_version_desc)
        if encode_with_base64 is not None:
            pulumi.set(__self__, "encode_with_base64", encode_with_base64)
        if program_id_lists is not None:
            pulumi.set(__self__, "program_id_lists", program_id_lists)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> Optional[pulumi.Input[str]]:
        """
        Config file associated application ID.
        """
        return pulumi.get(self, "application_id")

    @application_id.setter
    def application_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "application_id", value)

    @property
    @pulumi.getter(name="configFileCode")
    def config_file_code(self) -> Optional[pulumi.Input[str]]:
        """
        Configuration file encoding, utf-8 or gbk. Note: If you choose gbk, you need the support of a new version of tsf-consul-template (public cloud virtual machines need to use 1.32 tsf-agent, and containers need to obtain the latest tsf-consul-template-docker.tar.gz from the documentation).
        """
        return pulumi.get(self, "config_file_code")

    @config_file_code.setter
    def config_file_code(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_file_code", value)

    @property
    @pulumi.getter(name="configFileName")
    def config_file_name(self) -> Optional[pulumi.Input[str]]:
        """
        Config file name.
        """
        return pulumi.get(self, "config_file_name")

    @config_file_name.setter
    def config_file_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_file_name", value)

    @property
    @pulumi.getter(name="configFilePath")
    def config_file_path(self) -> Optional[pulumi.Input[str]]:
        """
        config release path.
        """
        return pulumi.get(self, "config_file_path")

    @config_file_path.setter
    def config_file_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_file_path", value)

    @property
    @pulumi.getter(name="configFileValue")
    def config_file_value(self) -> Optional[pulumi.Input[str]]:
        """
        Configuration file content (the original content encoding needs to be in utf-8 format, if the ConfigFileCode is gbk, it will be converted in the background).
        """
        return pulumi.get(self, "config_file_value")

    @config_file_value.setter
    def config_file_value(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_file_value", value)

    @property
    @pulumi.getter(name="configName")
    def config_name(self) -> Optional[pulumi.Input[str]]:
        """
        Config Name.
        """
        return pulumi.get(self, "config_name")

    @config_name.setter
    def config_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_name", value)

    @property
    @pulumi.getter(name="configPostCmd")
    def config_post_cmd(self) -> Optional[pulumi.Input[str]]:
        """
        post command.
        """
        return pulumi.get(self, "config_post_cmd")

    @config_post_cmd.setter
    def config_post_cmd(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_post_cmd", value)

    @property
    @pulumi.getter(name="configVersion")
    def config_version(self) -> Optional[pulumi.Input[str]]:
        """
        Config version.
        """
        return pulumi.get(self, "config_version")

    @config_version.setter
    def config_version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_version", value)

    @property
    @pulumi.getter(name="configVersionDesc")
    def config_version_desc(self) -> Optional[pulumi.Input[str]]:
        """
        config version description.
        """
        return pulumi.get(self, "config_version_desc")

    @config_version_desc.setter
    def config_version_desc(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "config_version_desc", value)

    @property
    @pulumi.getter(name="encodeWithBase64")
    def encode_with_base64(self) -> Optional[pulumi.Input[bool]]:
        """
        the config value is encoded with base64 or not.
        """
        return pulumi.get(self, "encode_with_base64")

    @encode_with_base64.setter
    def encode_with_base64(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "encode_with_base64", value)

    @property
    @pulumi.getter(name="programIdLists")
    def program_id_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        datasource for auth.
        """
        return pulumi.get(self, "program_id_lists")

    @program_id_lists.setter
    def program_id_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "program_id_lists", value)


class ApplicationFileConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_id: Optional[pulumi.Input[str]] = None,
                 config_file_code: Optional[pulumi.Input[str]] = None,
                 config_file_name: Optional[pulumi.Input[str]] = None,
                 config_file_path: Optional[pulumi.Input[str]] = None,
                 config_file_value: Optional[pulumi.Input[str]] = None,
                 config_name: Optional[pulumi.Input[str]] = None,
                 config_post_cmd: Optional[pulumi.Input[str]] = None,
                 config_version: Optional[pulumi.Input[str]] = None,
                 config_version_desc: Optional[pulumi.Input[str]] = None,
                 encode_with_base64: Optional[pulumi.Input[bool]] = None,
                 program_id_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Provides a resource to create a tsf application_file_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        application_file_config = tencentcloud.tsf.ApplicationFileConfig("applicationFileConfig",
            application_id="application-a24x29xv",
            config_file_code="UTF-8",
            config_file_name="application.yaml",
            config_file_path="/etc/nginx",
            config_file_value="test: 1",
            config_name="terraform-test",
            config_post_cmd="source .bashrc",
            config_version="1.0",
            config_version_desc="1.0",
            encode_with_base64=True)
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] application_id: Config file associated application ID.
        :param pulumi.Input[str] config_file_code: Configuration file encoding, utf-8 or gbk. Note: If you choose gbk, you need the support of a new version of tsf-consul-template (public cloud virtual machines need to use 1.32 tsf-agent, and containers need to obtain the latest tsf-consul-template-docker.tar.gz from the documentation).
        :param pulumi.Input[str] config_file_name: Config file name.
        :param pulumi.Input[str] config_file_path: config release path.
        :param pulumi.Input[str] config_file_value: Configuration file content (the original content encoding needs to be in utf-8 format, if the ConfigFileCode is gbk, it will be converted in the background).
        :param pulumi.Input[str] config_name: Config Name.
        :param pulumi.Input[str] config_post_cmd: post command.
        :param pulumi.Input[str] config_version: Config version.
        :param pulumi.Input[str] config_version_desc: config version description.
        :param pulumi.Input[bool] encode_with_base64: the config value is encoded with base64 or not.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] program_id_lists: datasource for auth.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ApplicationFileConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a tsf application_file_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        application_file_config = tencentcloud.tsf.ApplicationFileConfig("applicationFileConfig",
            application_id="application-a24x29xv",
            config_file_code="UTF-8",
            config_file_name="application.yaml",
            config_file_path="/etc/nginx",
            config_file_value="test: 1",
            config_name="terraform-test",
            config_post_cmd="source .bashrc",
            config_version="1.0",
            config_version_desc="1.0",
            encode_with_base64=True)
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param ApplicationFileConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ApplicationFileConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 application_id: Optional[pulumi.Input[str]] = None,
                 config_file_code: Optional[pulumi.Input[str]] = None,
                 config_file_name: Optional[pulumi.Input[str]] = None,
                 config_file_path: Optional[pulumi.Input[str]] = None,
                 config_file_value: Optional[pulumi.Input[str]] = None,
                 config_name: Optional[pulumi.Input[str]] = None,
                 config_post_cmd: Optional[pulumi.Input[str]] = None,
                 config_version: Optional[pulumi.Input[str]] = None,
                 config_version_desc: Optional[pulumi.Input[str]] = None,
                 encode_with_base64: Optional[pulumi.Input[bool]] = None,
                 program_id_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ApplicationFileConfigArgs.__new__(ApplicationFileConfigArgs)

            if application_id is None and not opts.urn:
                raise TypeError("Missing required property 'application_id'")
            __props__.__dict__["application_id"] = application_id
            __props__.__dict__["config_file_code"] = config_file_code
            if config_file_name is None and not opts.urn:
                raise TypeError("Missing required property 'config_file_name'")
            __props__.__dict__["config_file_name"] = config_file_name
            if config_file_path is None and not opts.urn:
                raise TypeError("Missing required property 'config_file_path'")
            __props__.__dict__["config_file_path"] = config_file_path
            if config_file_value is None and not opts.urn:
                raise TypeError("Missing required property 'config_file_value'")
            __props__.__dict__["config_file_value"] = config_file_value
            if config_name is None and not opts.urn:
                raise TypeError("Missing required property 'config_name'")
            __props__.__dict__["config_name"] = config_name
            __props__.__dict__["config_post_cmd"] = config_post_cmd
            if config_version is None and not opts.urn:
                raise TypeError("Missing required property 'config_version'")
            __props__.__dict__["config_version"] = config_version
            __props__.__dict__["config_version_desc"] = config_version_desc
            __props__.__dict__["encode_with_base64"] = encode_with_base64
            __props__.__dict__["program_id_lists"] = program_id_lists
        super(ApplicationFileConfig, __self__).__init__(
            'tencentcloud:Tsf/applicationFileConfig:ApplicationFileConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            application_id: Optional[pulumi.Input[str]] = None,
            config_file_code: Optional[pulumi.Input[str]] = None,
            config_file_name: Optional[pulumi.Input[str]] = None,
            config_file_path: Optional[pulumi.Input[str]] = None,
            config_file_value: Optional[pulumi.Input[str]] = None,
            config_name: Optional[pulumi.Input[str]] = None,
            config_post_cmd: Optional[pulumi.Input[str]] = None,
            config_version: Optional[pulumi.Input[str]] = None,
            config_version_desc: Optional[pulumi.Input[str]] = None,
            encode_with_base64: Optional[pulumi.Input[bool]] = None,
            program_id_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'ApplicationFileConfig':
        """
        Get an existing ApplicationFileConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] application_id: Config file associated application ID.
        :param pulumi.Input[str] config_file_code: Configuration file encoding, utf-8 or gbk. Note: If you choose gbk, you need the support of a new version of tsf-consul-template (public cloud virtual machines need to use 1.32 tsf-agent, and containers need to obtain the latest tsf-consul-template-docker.tar.gz from the documentation).
        :param pulumi.Input[str] config_file_name: Config file name.
        :param pulumi.Input[str] config_file_path: config release path.
        :param pulumi.Input[str] config_file_value: Configuration file content (the original content encoding needs to be in utf-8 format, if the ConfigFileCode is gbk, it will be converted in the background).
        :param pulumi.Input[str] config_name: Config Name.
        :param pulumi.Input[str] config_post_cmd: post command.
        :param pulumi.Input[str] config_version: Config version.
        :param pulumi.Input[str] config_version_desc: config version description.
        :param pulumi.Input[bool] encode_with_base64: the config value is encoded with base64 or not.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] program_id_lists: datasource for auth.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ApplicationFileConfigState.__new__(_ApplicationFileConfigState)

        __props__.__dict__["application_id"] = application_id
        __props__.__dict__["config_file_code"] = config_file_code
        __props__.__dict__["config_file_name"] = config_file_name
        __props__.__dict__["config_file_path"] = config_file_path
        __props__.__dict__["config_file_value"] = config_file_value
        __props__.__dict__["config_name"] = config_name
        __props__.__dict__["config_post_cmd"] = config_post_cmd
        __props__.__dict__["config_version"] = config_version
        __props__.__dict__["config_version_desc"] = config_version_desc
        __props__.__dict__["encode_with_base64"] = encode_with_base64
        __props__.__dict__["program_id_lists"] = program_id_lists
        return ApplicationFileConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="applicationId")
    def application_id(self) -> pulumi.Output[str]:
        """
        Config file associated application ID.
        """
        return pulumi.get(self, "application_id")

    @property
    @pulumi.getter(name="configFileCode")
    def config_file_code(self) -> pulumi.Output[Optional[str]]:
        """
        Configuration file encoding, utf-8 or gbk. Note: If you choose gbk, you need the support of a new version of tsf-consul-template (public cloud virtual machines need to use 1.32 tsf-agent, and containers need to obtain the latest tsf-consul-template-docker.tar.gz from the documentation).
        """
        return pulumi.get(self, "config_file_code")

    @property
    @pulumi.getter(name="configFileName")
    def config_file_name(self) -> pulumi.Output[str]:
        """
        Config file name.
        """
        return pulumi.get(self, "config_file_name")

    @property
    @pulumi.getter(name="configFilePath")
    def config_file_path(self) -> pulumi.Output[str]:
        """
        config release path.
        """
        return pulumi.get(self, "config_file_path")

    @property
    @pulumi.getter(name="configFileValue")
    def config_file_value(self) -> pulumi.Output[str]:
        """
        Configuration file content (the original content encoding needs to be in utf-8 format, if the ConfigFileCode is gbk, it will be converted in the background).
        """
        return pulumi.get(self, "config_file_value")

    @property
    @pulumi.getter(name="configName")
    def config_name(self) -> pulumi.Output[str]:
        """
        Config Name.
        """
        return pulumi.get(self, "config_name")

    @property
    @pulumi.getter(name="configPostCmd")
    def config_post_cmd(self) -> pulumi.Output[Optional[str]]:
        """
        post command.
        """
        return pulumi.get(self, "config_post_cmd")

    @property
    @pulumi.getter(name="configVersion")
    def config_version(self) -> pulumi.Output[str]:
        """
        Config version.
        """
        return pulumi.get(self, "config_version")

    @property
    @pulumi.getter(name="configVersionDesc")
    def config_version_desc(self) -> pulumi.Output[Optional[str]]:
        """
        config version description.
        """
        return pulumi.get(self, "config_version_desc")

    @property
    @pulumi.getter(name="encodeWithBase64")
    def encode_with_base64(self) -> pulumi.Output[Optional[bool]]:
        """
        the config value is encoded with base64 or not.
        """
        return pulumi.get(self, "encode_with_base64")

    @property
    @pulumi.getter(name="programIdLists")
    def program_id_lists(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        datasource for auth.
        """
        return pulumi.get(self, "program_id_lists")

