# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetMicroserviceApiVersionResult',
    'AwaitableGetMicroserviceApiVersionResult',
    'get_microservice_api_version',
    'get_microservice_api_version_output',
]

@pulumi.output_type
class GetMicroserviceApiVersionResult:
    """
    A collection of values returned by getMicroserviceApiVersion.
    """
    def __init__(__self__, id=None, method=None, microservice_id=None, path=None, result_output_file=None, results=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if method and not isinstance(method, str):
            raise TypeError("Expected argument 'method' to be a str")
        pulumi.set(__self__, "method", method)
        if microservice_id and not isinstance(microservice_id, str):
            raise TypeError("Expected argument 'microservice_id' to be a str")
        pulumi.set(__self__, "microservice_id", microservice_id)
        if path and not isinstance(path, str):
            raise TypeError("Expected argument 'path' to be a str")
        pulumi.set(__self__, "path", path)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def method(self) -> Optional[str]:
        return pulumi.get(self, "method")

    @property
    @pulumi.getter(name="microserviceId")
    def microservice_id(self) -> str:
        return pulumi.get(self, "microservice_id")

    @property
    @pulumi.getter
    def path(self) -> Optional[str]:
        return pulumi.get(self, "path")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetMicroserviceApiVersionResultResult']:
        """
        api version list.
        """
        return pulumi.get(self, "results")


class AwaitableGetMicroserviceApiVersionResult(GetMicroserviceApiVersionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetMicroserviceApiVersionResult(
            id=self.id,
            method=self.method,
            microservice_id=self.microservice_id,
            path=self.path,
            result_output_file=self.result_output_file,
            results=self.results)


def get_microservice_api_version(method: Optional[str] = None,
                                 microservice_id: Optional[str] = None,
                                 path: Optional[str] = None,
                                 result_output_file: Optional[str] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetMicroserviceApiVersionResult:
    """
    Use this data source to query detailed information of tsf microservice_api_version

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    microservice_api_version = tencentcloud.Tsf.get_microservice_api_version(method="get",
        microservice_id="ms-yq3jo6jd",
        path="")
    ```
    <!--End PulumiCodeChooser -->


    :param str method: request method.
    :param str microservice_id: Microservice ID.
    :param str path: api path.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['method'] = method
    __args__['microserviceId'] = microservice_id
    __args__['path'] = path
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tsf/getMicroserviceApiVersion:getMicroserviceApiVersion', __args__, opts=opts, typ=GetMicroserviceApiVersionResult).value

    return AwaitableGetMicroserviceApiVersionResult(
        id=pulumi.get(__ret__, 'id'),
        method=pulumi.get(__ret__, 'method'),
        microservice_id=pulumi.get(__ret__, 'microservice_id'),
        path=pulumi.get(__ret__, 'path'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        results=pulumi.get(__ret__, 'results'))


@_utilities.lift_output_func(get_microservice_api_version)
def get_microservice_api_version_output(method: Optional[pulumi.Input[Optional[str]]] = None,
                                        microservice_id: Optional[pulumi.Input[str]] = None,
                                        path: Optional[pulumi.Input[Optional[str]]] = None,
                                        result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetMicroserviceApiVersionResult]:
    """
    Use this data source to query detailed information of tsf microservice_api_version

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    microservice_api_version = tencentcloud.Tsf.get_microservice_api_version(method="get",
        microservice_id="ms-yq3jo6jd",
        path="")
    ```
    <!--End PulumiCodeChooser -->


    :param str method: request method.
    :param str microservice_id: Microservice ID.
    :param str path: api path.
    :param str result_output_file: Used to save results.
    """
    ...
