# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetFindDomainsResult',
    'AwaitableGetFindDomainsResult',
    'get_find_domains',
    'get_find_domains_output',
]

@pulumi.output_type
class GetFindDomainsResult:
    """
    A collection of values returned by getFindDomains.
    """
    def __init__(__self__, by=None, id=None, is_waf_domain=None, key=None, lists=None, order=None, result_output_file=None):
        if by and not isinstance(by, str):
            raise TypeError("Expected argument 'by' to be a str")
        pulumi.set(__self__, "by", by)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if is_waf_domain and not isinstance(is_waf_domain, str):
            raise TypeError("Expected argument 'is_waf_domain' to be a str")
        pulumi.set(__self__, "is_waf_domain", is_waf_domain)
        if key and not isinstance(key, str):
            raise TypeError("Expected argument 'key' to be a str")
        pulumi.set(__self__, "key", key)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if order and not isinstance(order, str):
            raise TypeError("Expected argument 'order' to be a str")
        pulumi.set(__self__, "order", order)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def by(self) -> Optional[str]:
        return pulumi.get(self, "by")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isWafDomain")
    def is_waf_domain(self) -> Optional[str]:
        """
        Whether access to waf or not.
        """
        return pulumi.get(self, "is_waf_domain")

    @property
    @pulumi.getter
    def key(self) -> Optional[str]:
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetFindDomainsListResult']:
        """
        Domain info list.
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter
    def order(self) -> Optional[str]:
        return pulumi.get(self, "order")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetFindDomainsResult(GetFindDomainsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFindDomainsResult(
            by=self.by,
            id=self.id,
            is_waf_domain=self.is_waf_domain,
            key=self.key,
            lists=self.lists,
            order=self.order,
            result_output_file=self.result_output_file)


def get_find_domains(by: Optional[str] = None,
                     is_waf_domain: Optional[str] = None,
                     key: Optional[str] = None,
                     order: Optional[str] = None,
                     result_output_file: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFindDomainsResult:
    """
    Use this data source to query detailed information of waf find_domains

    ## Example Usage

    ### Find all domains

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Waf.get_find_domains()
    ```
    <!--End PulumiCodeChooser -->

    ### Find domains by filter

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Waf.get_find_domains(by="FindTime",
        is_waf_domain="1",
        key="keyWord",
        order="asc")
    ```
    <!--End PulumiCodeChooser -->


    :param str by: Sorting parameter, eg: FindTime.
    :param str is_waf_domain: Whether access to waf or not.
    :param str key: Filter condition.
    :param str order: Sorting type, eg: desc, asc.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['by'] = by
    __args__['isWafDomain'] = is_waf_domain
    __args__['key'] = key
    __args__['order'] = order
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Waf/getFindDomains:getFindDomains', __args__, opts=opts, typ=GetFindDomainsResult).value

    return AwaitableGetFindDomainsResult(
        by=pulumi.get(__ret__, 'by'),
        id=pulumi.get(__ret__, 'id'),
        is_waf_domain=pulumi.get(__ret__, 'is_waf_domain'),
        key=pulumi.get(__ret__, 'key'),
        lists=pulumi.get(__ret__, 'lists'),
        order=pulumi.get(__ret__, 'order'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_find_domains)
def get_find_domains_output(by: Optional[pulumi.Input[Optional[str]]] = None,
                            is_waf_domain: Optional[pulumi.Input[Optional[str]]] = None,
                            key: Optional[pulumi.Input[Optional[str]]] = None,
                            order: Optional[pulumi.Input[Optional[str]]] = None,
                            result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetFindDomainsResult]:
    """
    Use this data source to query detailed information of waf find_domains

    ## Example Usage

    ### Find all domains

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Waf.get_find_domains()
    ```
    <!--End PulumiCodeChooser -->

    ### Find domains by filter

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Waf.get_find_domains(by="FindTime",
        is_waf_domain="1",
        key="keyWord",
        order="asc")
    ```
    <!--End PulumiCodeChooser -->


    :param str by: Sorting parameter, eg: FindTime.
    :param str is_waf_domain: Whether access to waf or not.
    :param str key: Filter condition.
    :param str order: Sorting type, eg: desc, asc.
    :param str result_output_file: Used to save results.
    """
    ...
